
function ochrana_nazvu(string,maxlen){
	var new_string = string;	
	pulmin = (maxlen/2)-2;
	stringlen = string.length;

	if(stringlen > maxlen){
		new_string = string.substring(0,pulmin) + "..." + string.substring(stringlen-pulmin);		
	}else{
		new_string = string;
	}

	return "<span title='" + string + "'>" + new_string + "</span>";		
}

function toSmartFileSize(size){
	var sfs;
		fs = Math.round(size/1000);
		sfs = (fs<1000) ? fs + " kB" : (Math.round((fs/1000)*10)/10) + " MB";
	return sfs;
}

function fileQueued(file, queuelength) {

	var listingfiles = document.getElementById("SWFUploadFileListingFiles");

	if(!listingfiles.getElementsByTagName("ul")[0]) {
		
		var info = document.createElement("h4");
		info.id = "queueName";
		info.appendChild(document.createTextNode(" "));
		
		listingfiles.appendChild(info);
		
		var ul = document.createElement("ul")
		ul.id = "queueUl";
		listingfiles.appendChild(ul);
	}
	
	listingfiles = listingfiles.getElementsByTagName("ul")[0];

	var li = document.createElement("li");
	li.id = file.id;
	li.className = "SWFUploadFileItem";
	li.innerHTML  = '<div class="title">' + file.name + '</div>';
	li.innerHTML += '<div class="proc" id="' + file.id + 'pc">&nbsp;</div>';
	li.innerHTML += '<input type="hidden" class="fileSize" value="' + file.size + '" />';
	li.innerHTML += '<div class="size">' + toSmartFileSize(file.size) + '</div>';
	li.innerHTML += '<div class="remove"><a id="' + file.id + 'deletebtn" href="javascript: swfu.cancelFile(\'' + file.id + '\');"><img src="repository/images/cancel.gif" border="0" /></a></div>';

	listingfiles.appendChild(li);

	// spocita velikost fronty
	swfUploadTotalSize();
	
	var queueinfo = document.getElementById("SWFUploadQueueInfo");
	queueinfo.innerHTML = queuelength + " files queued";
	document.getElementById(swfu.movieName + "UploadBtn").style.display = "block";
	document.getElementById("cancelqueuebtn").style.display = "block";
}

function swfUploadTotalSize() {
	var total = 0;
	var queueSizeValue = document.getElementById("SWFUploadQueueSizeValue");
	var listingfiles = document.getElementById("SWFUploadFileListingFiles");
	var inputs = listingfiles.getElementsByTagName("input");
    for (i = 0; i != inputs.length; i++) {
		if(inputs[i].className == "fileSize") total = (total * 1) + (inputs[i].value * 1);
	}

	var queueSizeValue = document.getElementById("SWFUploadQueueSizeValue");
	queueSizeValue.value = total;

	var queueSize = document.getElementById("SWFUploadQueueSize");
	if(queueSizeValue.value > 0){
		queueSize.innerHTML = toSmartFileSize(queueSizeValue.value);
	}else{
		queueSize.innerHTML = " ";
	}
}

function uploadFileCancelled(file, queuelength) {

	var li = document.getElementById(file.id);

	li.innerHTML  = '<div class="title">' + file.name + ' - cancelled</div>';
	li.className = "SWFUploadFileItem SWFcancelled";

	setTimeout('swfUploadTotalSize();',300);
	setTimeout('remLi(\''+file.id+'\');',250);

	var queueinfo = document.getElementById("SWFUploadQueueInfo");
	queueinfo.innerHTML = queuelength + " files queued";

	if(queuelength=="0") cancelQueue();
}

function remLi(e){
	if($(e)) new Element.remove($(e));
}

function uploadFileStart(file, position, queuelength) {
	var div = document.getElementById("SWFUploadQueueInfo");
	div.innerHTML = "Uploading file " + position + " of " + queuelength;
	var li = document.getElementById(file.id);
	li.className += " SWFuploading";
}

function uploadProgress(file, bytesLoaded) {

	var li = document.getElementById(file.id);
	var percent = Math.ceil((bytesLoaded / file.size)*100);
	if(percent > 0) li.style.background = SWFupload_li_bg + " url(repository/images/SWFupload_progress.gif) " + ((SWFupload_ul_width/100)*percent) + "px 0px no-repeat";

	var pc = document.getElementById(file.id + "pc");
	pc.innerHTML = percent + "%";
}

function uploadError(errno) {
	// SWFUpload.debug(errno);
}

function uploadFileComplete(file) {
	var li = document.getElementById(file.id);
	li.className = "SWFUploadFileItem SWFcompleted";
}

function cancelQueue() {
	swfu.cancelQueue();
	document.getElementById(swfu.movieName + "UploadBtn").style.display = "none";
	document.getElementById("cancelqueuebtn").style.display = "none";
}

function uploadQueueComplete(file){
	document.getElementById(swfu.movieName + "UploadBtn").style.display = "none";
	document.getElementById(swfu.movieName + "BrowseBtn").style.display = "none";

	var div = document.getElementById("SWFUploadQueueInfo");
	div.innerHTML = '<a href="javascript: sendForm(\'storageForm\');" class="continueButton"><img src="repository/images/SWFupload_accept.gif" border="0" alt="Continue" />&nbsp;Continue&nbsp;</a>';

	new Element.remove($("queueUl"));
	new Element.remove($("queueName"));	

	document.getElementById("cancelqueuebtn").style.display = "none";
}