<?
//
// Sending HTML mail with attachements
// version 1.2
//
// function mailit($from, $to, $subjekt, $message, $attachments);
// $attachmets = array(array("title"=>"first title", "file"=>"first.file"), array("title"=>"second title", "file"=>"second.file"));
//

if (!isset($MAILIT_INC)) {
  $MAILIT_INC = true;

	function mailit($from, $to, $subjekt, $message, $attachments) {
		  $boundary = uniqid("");

		  $subjekt_arr = explode(" ",$subjekt);
		  reset($subjekt_arr);
		  while (list($key,$val)=each($subjekt_arr)) {
			$subjekt_arr[$key] = "=?utf-8?B?".base64_encode($val." ")."?=";
		  }
		  $subjekt = implode(" ",$subjekt_arr);
		  
		  $headers = "From: ".$from."\n".
					 "MIME-Version: 1.0\n".
					 "Reply-To: ".$from."\n".
					 "Content-Type: multipart/mixed; boundary=\"".$boundary."\"";

		  $body = "--".$boundary."\n".
				  "Content-Type: text/html; charset=utf-8\n".
				  "Content-Transfer-Encoding: 8bit\n".
				  "\n".wordwrap($message);
			
			if (is_array($attachments)) {
			  reset($attachments);
			while (list($key,$val) = each($attachments)) {
				  if ($fp = @fopen($val["file"],"r")) {
					  $pom = $val["file"];
						list($pom,$contenttype) = explode(": ",trim(`file -i $pom`));
						if (!preg_match("|^[^/]+/[^/]+$|",$contenttype)) { $contenttype = "application/octet-stream"; }
				$body .= "\n".
						 "\n".
						 "--".$boundary."\n".
						 "Content-Type: ".$contenttype."; name=\"".$val["title"]."\"\n".
						 "Content-Transfer-Encoding: base64\n".
						 "Content-Disposition: attachment; filename=\"".preg_replace("|^(.+[/\\\\])?([^/\\\\]+)$|","\\2",$val["file"])."\"\n".
						 "\n".chunk_split(base64_encode(fread($fp,filesize($val["file"]))));
						fclose($fp);
					}
				}
			}

		  $body .= "\n".
				   "--".$boundary."--";

		return mail($to, $subjekt, $body, $headers);
	}
}

?>