<?
session_start();

header("Content-Type: text/html; charset=UTF-8");

	include("../../include/local.inc.php");
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("content.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$activeModule="content";
	$u=new Underwood();

	/* */

	if($u->verifyUserRight("content_list_pages")==0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();
	}

	/* ziska informace o strankach */
	$pagesData=getPages("normal");
	$pagesDataCount=getPages("count");

	$section=$_SESSION[content][l][section];
	$off=intval($_SESSION[content][l][off]);
	$order=$_SESSION[content][l][o];
	$how=$_SESSION[content][l][d];
	$offset=intval($_SESSION[content][l][offset]);
	$resultCountAll=intval($pagesDataCount);

	// pokud nemam adnou sekci (sem v rootu)
	if($section<1){		
		echo($u->simpleMessage('info',$u->getText('content_chooseSection')));
		exit();
	}

	// prava uzivatele na strom
	$structureRightsData=$u->getStructureRightsData($_SESSION['uw']['user']['id']);

	// pokud nemam pristup do tehle rubriky
	if(in_array($_SESSION[content][l][section], $structureRightsData[$_SESSION['uw']['user']['id']])==false){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();
	}

	$pageLinkCount=10;
	// konec nastaveni
	$pageLinkCountHalf=($pageLinkCount/2);
	$pagesCount=ceil($resultCountAll/$offset);
	$currentPage=(($off/$offset)+1);

	$start=($currentPage<($pageLinkCountHalf+1) ? 1 : ($currentPage+$pageLinkCountHalf>$pagesCount ? ($pagesCount-($pageLinkCount-1)>0 ? $pagesCount-($pageLinkCount-1) : 1) : $currentPage-$pageLinkCountHalf));
	$lastPage=($start+$pageLinkCount>$pagesCount ? $pagesCount+1 : $start+$pageLinkCount);

	$pagin.=('<table cellpadding="1" cellspacing="0" border="0" align="center" id="navigator">');
		$pagin.=('<tr>');
		$pagin.=('<td><a href="#" onClick="listFrom(0);" class="smaller">&#124;&#139;</a>&nbsp;&nbsp;</td>');
		$pagin.=('<td align="left">');

	$pagin.=($currentPage <> 1 ? '<a href="#" onClick="listFrom('. (($currentPage-2)*$offset) .');">&laquo;</a>&nbsp;&nbsp;' : '&laquo;&nbsp;&nbsp;');

	$pagin.=('</td><td align="center" class="pages">');

	for ($i = $start, $x=($start*$offset)-$offset; $i < $lastPage; $i++, $x=$x+$offset){
		if ($i == $currentPage) {				
			$pagin.='<strong class="black">'.$i.'</strong> ';
		} else {
			$pagin.='<a href="#" onClick="listFrom('.$x.');">'.$i.'</a> ';
		}
	}

	$pagin.=('</td><td align="right">');

	$pagin.=($currentPage<$pagesCount ? '&nbsp;&nbsp;<a href="#" onClick="listFrom('. ($currentPage*$offset) .');">&raquo;</a>' : '&nbsp;&nbsp;&raquo;');
	
			$pagin.=('</td>');
			$pagin.=('<td>&nbsp;&nbsp;<a href="#" onClick="listFrom('. (($pagesCount*$offset)-$offset) .');" class="smaller">&#155;&#124;</a></td>');
			$pagin.=('<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>');
			$pagin.=('<td>'.($off+1).'-'.($off+$offset>$resultCountAll ? $resultCountAll : $off+$offset).'/'.$resultCountAll.'</td>');
			$pagin.=('<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>');

			$pagin.=('<td>'.$u->getText("goToPage").'&nbsp;</td>');
		
			$pagin.=('<td>');
			$pagin.=('<input type="text" class="pager" id="goToPageNum" value="'.ceil(($currentPage!=$pagesCount ? $currentPage+1 : $pagesCount)).'">');
			$start=1;
			for ($i = $start, $x=($start*$offset)-$offset; $i <= $pagesCount; $i++, $x=$x+$offset){				
				$pagin.="\n".'<input type="hidden" id="offSetFor['.$i.']" value="'.$x.'">';
			}
				$pagin.="\n".'<input type="hidden" id="pageCount" value="'.$pagesCount.'">';
			$pagin.=('</td>');
			$pagin.=('<td><a href="#" onClick="goToPage($(\'goToPageNum\').value);"><img src="'.UW_BASE_URL.'/images/icons/check.gif" border="0" alt="" /></td>');
			$pagin.=('<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>');
			$pagin.=('<td>'.$u->getText("page").'&nbsp;</td>');
			$pagin.=('<td>'.$currentPage.'/'.$pagesCount.'</td>');
			$pagin.=('<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>');
			$pagin.=('<td>');
				$pagin.=('<div id="trackPaginSlider">');
					$pagin.=('<div id="handlePaginSlider"> </div>');
				$pagin.=('</div>');
				$pagin.=('<input type="hidden" name="cPage" id="cPage" value="'.$currentPage.'">');
				$pagin.=('<input type="hidden" name="mPage" id="mPage" value="'.$pagesCount.'">');
			$pagin.=('</td>');
			$pagin.=('<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>');
			$pagin.=('<td><a href="content.php?useSection='.$_SESSION[content][l][section].'&setOff='.$_SESSION[content][l][off].'&setOrder='.$_SESSION[content][l][o].'&setDirection='.$_SESSION[content][l][d].'&setFilter='.$_SESSION[content][l][filter].'">'.$u->getText("LinkToThisPage").'</a></td>');
		$pagin.=('</tr>');
	$pagin.=('</table>');

	$v=0;
	if(is_array($pagesData)){
		echo('<table cellpadding="2" cellspacing="0" border="0" class="list">');
		
		echo('<thead>');
			echo('<tr>');
				echo('<th class="pointer'.($order=="title" ? ($how=="ASC" ? " asc" : " desc") :'').'" onclick="setOrder(\'title\');" colspan="2">'.$u->getText('content_page').'</th>');
				echo('<th class="pointer'.($order=="mtime" ? ($how=="ASC" ? " asc" : " desc") :'').'" onclick="setOrder(\'mtime\');">'.$u->getText('content_modified').'</th>');
				echo('<th class="pointer'.($order=="page_id" ? ($how=="ASC" ? " asc" : " desc") :'').'" onclick="setOrder(\'page_id\');">'.$u->getText('content_id').'</th>');

				if($u->verifyUserRight("content_page_index_update")==1){
					echo('<th class="pointer'.($order=="page_index" ? ($how=="ASC" ? " asc" : " desc") :'').'" onclick="setOrder(\'page_index\');">'.$u->getText('content_index').'</th>');
				}
				if($u->verifyUserRight("content_page_status_update")==1){
					echo('<th class="pointer'.($order=="status" ? ($how=="ASC" ? " asc" : " desc") :'').'" onclick="setOrder(\'status\');">'.$u->getText('content_status').'</th>');
				}
				echo('<th colspan="4">&nbsp;</th>');
			echo('</tr>');
		echo('</thead>');

		echo('<tfoot>');
			echo('<tr>');
				echo('<td colspan="7">');
					echo $pagin;
				echo('</td>');
			echo('</tr>');
		echo('</tfoot>');

		echo('<tbody>');
		reset($pagesData);
		while(list($key,$val)=each($pagesData)){

			echo('<tr class="'.($v%2==0 ? "dark" : "light").'" onmouseover="this.className=\'high\'" onmouseout="this.className=\''.($v%2==0 ? "dark" : "light").'\'">');
				echo('<td><img src="'.UW_BASE_URL.'/images/icons/document.gif" border="0" alt="'.$u->getText('content_page').'" title="'.$u->getText('content_page').'" /></td>');
				echo('<td><div class="overflowRow"><a href="#" onClick="openPage(\''.$val[page_id].'\');"><strong>'.$val[title].'</strong></a><span class="overflowText">'.$u->plainText($val[text]).'</span></div></td>');
				echo('<td nowrap>'.$u->printSmartDate($val[mtime]).'&nbsp;</td>');
				echo('<td>'.$val[page_id].'&nbsp;</td>');

				if($u->verifyUserRight("content_page_index_update")==1){
					echo('<td align="center"><a href="#" onclick="setSectionIndex('.$section.','.$val[page_id].','.$u->flipIndex($val[page_index]).');"><img src="'.UW_BASE_URL.'/images/index_icon_'.$val[page_index].'.gif" border="0" alt="" class="" /></a></td>');
				}

				if($u->verifyUserRight("content_page_status_update")==1){
					echo('<td align="center"><a href="#" onclick="setPageStatus('.$val[page_id].','.$u->flipStatus($val[status]).');"><img src="'.UW_BASE_URL.'/images/status_icon_'.$val[status].'.gif" border="0" alt="" class="" /></a></td>');
				}

				if($u->verifyUserRight("content_page_update")==1){
					echo('<td class="nobg" nowrap="nowrap"><a href="#" onClick="openPage(\''.$val[page_id].'\');" class="button"><img src="'.UW_BASE_URL.'/images/icons/edit.gif" border="0" alt="" /> '.$u->getText('edit').'</a></td>');
				}

				echo('<td class="nobg" nowrap="nowrap"><a href="#" onClick="openPageStructure(\''.$val[page_id].'\');" class="button"><img src="'.UW_BASE_URL.'/images/icons/folder.gif" border="0" alt="" /> '.$u->getText('content_sections').'</a></td>');

				if($u->verifyUserRight("content_page_delete")==1){
					echo('<td class="nobg" class="wDel"><a href="#" onclick="showDarkbox(250,50,\'initPageDeletion('.$val[page_id].');\');" class="button nomarg"><img src="'.UW_BASE_URL.'/images/icons/delete.gif" border="0" alt="" class="" /></a></td>');
				}
			echo('</tr>');
			$v++;
		}
		echo('</tbody>');
		echo('</table>');
	}else{
		echo($u->simpleMessage('info',$u->getText('content_sectionIsEmpty')));
	}

?>