<?
session_start();

header("Content-Type: text/html; charset=UTF-8");

	include("../../include/local.inc.php");		
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("images.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$activeModule="library";	
	$u=new Underwood();	

	/* */

	$openImage=intval($_GET["image"]);

	if($u->verifyUserRight("library_images_image_insert,library_images_image_upload")==0 && $openImage==0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}

	if($u->verifyUserRight("library_images_item_update")==0 && $openImage>0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}


	/* pokud hledam obrazky na disku */
	if($_GET[listImages]==1){
		
		@mkdir(UW_LIBRARY_IMAGES_DIR,"0777");

		// vezme vsechny soubory v adresari
		$gf=new getDirContent();
		$all_images = $gf->open(UW_LIBRARY_IMAGES_DIR);

		// vezme ulozene soubory
			$search="";
			$search[unlimited]=true;
		$imagesDataOld=getImagesData($search);

		$old_images = "";
		if(is_array($imagesDataOld)){

			reset($imagesDataOld);
			while(list($key,$val)=each($imagesDataOld)){
				$old_images[]=$val[filename];
			}

			$new_images=array_diff($all_images,$old_images);
		}	
							
		if(count($new_images)==0) $new_images="";

		// pokud jsou nejaky jine nez ty uz ulozene vypise select, jinak info
		
		if(is_array($new_images)){
			reset($new_images);
			while(list($key,$val)=each($new_images)){							
				$filenameData = $u->getFilenameParts($val);
				$extension=$filenameData[ext];
				if(in_array($extension,$cfg[library_image_allowed_types])==false) unset($new_images[$key]);
			}
		}

		if(count($new_images)==0) $new_images="";

		// pokud nejsou dn nov obrzky na disku
		if(!is_array($new_images)){
			echo $u->simpleMessage('info',$u->getText('library_images_msg_newImagesNotFound'));
			echo('<a href="#" onClick="getOffset(); list();" class="button"><img src="'.UW_BASE_URL.'/images/icons/cancel.gif" border="0" alt="" /> '.$u->getText('cancel').'</a>');
			exit();
		}
	}

	/* ziska informace o obrazcich */
	if($openImage>0){
		$search="";
		$search[id]=$openImage;	
		/* */
		$imagesData=getImagesData($search);	
	}
	

/* form */

echo('<form enctype="multipart/form-data" name="imagesEditForm" id="imagesEditForm" method="post" action="aac_images_save.php" target="uploadIframe">');

	echo('<table cellpadding="8" cellspacing="0" border="0" class="tableEdit">');
	echo('<tr><td><h4 class="title">'.($openImage>0 ? $imagesData[$openImage][title].'&nbsp;&nbsp;&nbsp;<span>|</span>&nbsp;&nbsp;&nbsp;<strong>'.$imagesData[$openImage][filename].'</strong>' : $u->getText("library_images_newImage")).'</h4></td></tr>');
		echo('<tr>');
			echo('<td>');  

	echo('<table cellpadding="2" cellspacing="0" border="0">');
		echo('<tr>');
			echo('<td><strong>'.$u->getText('library_images_it_title').'</strong></td>');
			echo('<td>&nbsp;</td>');
			echo('<td><input type="text" name="image_title" id="image_title" class="input long high" value="'.$u->insertData($imagesData[$openImage][title]).'"></td>');
			echo('<td>&nbsp;</td>');
			echo('<td class="example">'.$u->getText('e_g').' '.$u->getText('library_images_eg_itemTitle').'</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td colspan="5">&nbsp;</td>');
		echo('</tr>');

		if($openImage>0){
			echo('<tr>');
				echo('<td><strong>'.$u->getText('library_images_it_filename').'</strong></td>');
				echo('<td>&nbsp;</td>');
				echo('<td><strong>'.$u->insertData($imagesData[$openImage][filename]).'</strong></td>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
			echo('</tr>');			
			echo('<tr>');
				echo('<td><strong>'.$u->getText('library_images_it_renameOldimage').'</strong></td>');
				echo('<td>&nbsp;</td>');
				echo('<td><input type="hidden" value="'.$u->insertData($imagesData[$openImage][filename]).'" name="oldFilename" id="oldFilename"><input type="text" class="input long" name="newFilename" id="newFilename"></td>');
				echo('<td>&nbsp;</td>');
				echo('<td class="example"><strong class="high">'.$u->getText('tip').'</strong>: '.$u->getText('library_images_tip_useOnlySimpleChars').'</td>');
			echo('</tr>');	
			echo('<tr>');
				echo('<td><strong>'.$u->getText('library_images_it_newImagename').'</strong></td>');
				echo('<td>&nbsp;</td>');
				echo('<td><input type="file" name="updateImage" id="updateImage"></td>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
			echo('</tr>');

			echo('<tr>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
			echo('</tr>');

			echo('<tr>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
				echo('<td><a href="#" onclick="initImageCropEditor('.$openImage.',\'just_crop\')" class="buttonBorded">&nbsp;'.$u->getText('library_images_cropImage').'</a></td>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
			echo('</tr>');
			
		}elseif($_GET[listImages]==1){
			echo('<tr>');
				echo('<td><strong>'.$u->getText('library_images_it_filename').'</strong></td>');
				echo('<td>&nbsp;</td>');
					if(is_array($new_images) && count($new_images)){
						echo('<td><select name="assImage" id="assImage">');
							reset($new_images);
							while(list($key,$val)=each($new_images)){
								echo('<option value="'.$val.'">'.$val.'</option>');
							}
						echo('</select></td>');
					}else{
						$hide_save_button=1;
						echo('<td>'.$u->simpleMessage('info', $u->getText('library_images_msg_newImagesNotFound')).'</td>');
					}				
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
			echo('</tr>');	
		}else{
			echo('<tr>');
				echo('<td><strong>'.$u->getText('library_images_it_filename').'</strong></td>');
				echo('<td>&nbsp;</td>');
				echo('<td><input type="file" name="newImage" id="newImage"></td>');
				echo('<td>&nbsp;</td>');
				echo('<td class="example"><strong class="high">'.$u->getText('tip').'</strong>: '.$u->getText('library_images_tip_useOnlyTheseTypes').' -  '.implode(",",$cfg[library_image_allowed_types]).'</td>');			

			echo('</tr>');	
		}

		echo('<tr>');
			echo('<td colspan="5">&nbsp;</td>');
		echo('</tr>');
		echo('<tr valign="top">');
			echo('<td>'.$u->getText('library_images_it_about').'</td>');
			echo('<td>&nbsp;</td>');
			echo('<td><textarea name="image_note" id="image_note" class="area w100p">'.$u->insertData($imagesData[$openImage][note]).'</textarea></td>');
			echo('<td>&nbsp;</td>');
			echo('<td>&nbsp;</td>');
		echo('</tr>');		
		echo('<tr>');
			echo('<td><strong>'.$u->getText('library_images_it_keywords').'</strong></td>');
			echo('<td>&nbsp;</td>');
			echo('<td><input type="text" name="image_keywords" id="image_keywords" class="input long" value="'.$u->insertData($imagesData[$openImage][keywords]).'"></td>');
			echo('<td>&nbsp;</td>');
			echo('<td class="example">'.$u->getText('e_g').' '.$u->getText('library_images_eg_itemKeywords').'</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td colspan="5">&nbsp;</td>');
		echo('</tr>');
	echo('</table>');	

	echo('<tr>');
		echo('<td>');
		if($hide_save_button==0) echo('<a href="#" onClick="sendForm(\'imagesEditForm\');" class="button"><img src="'.UW_BASE_URL.'/images/icons/save.gif" border="0" alt="" /> '.$u->getText('save').'</a>');
		echo('<a href="#" onClick="getOffset(); list();" class="button"><img src="'.UW_BASE_URL.'/images/icons/cancel.gif" border="0" alt="" /> '.$u->getText('cancel').'</a><a href="#" onClick="'.($listImages==1 ? 'openUploadedImage' : 'openImage').'('.$openImage.');" class="button"><img src="'.UW_BASE_URL.'/images/icons/change.gif" border="0" alt="" /> '.$u->getText('refresh').'</a></td>');
	echo('</tr>');

	echo('<tr><td>&nbsp;</td></tr>');

  echo('</table>');
  
	echo('<input type="hidden" name="fcc_require" value="d_username,d_email">');
	echo('<input type="hidden" name="fcc_email" value="d_email">');
	echo('<input type="hidden" name="fcc_same" value="d_pass,d_pass2">');	
	echo('<input type="hidden" name="action" value="save">');
	echo('<input type="hidden" name="image_id" id="image_id" value="'.$openImage.'">');
	echo('<input type="hidden" name="image_action" id="image_action" value="">');

echo('</form>');

?>