<?
	session_start();

	include("../../include/local.inc.php");		
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("locations.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$u=new Underwood();	
	$locations=new Locations();

	/* */

	/* kontrola jestli je uzivatel prihlaseny */
	if($u->verifyUserRight("0")==0){
		echo('AccessDenied');
		exit();
	}

	$sort_order=$_GET["order"];
	$sort_how=$_GET["how"];

	$orderHowSort=array(SORT_ASC,SORT_DESC);

	if($sort_order=="" || $sort_order=="undefined") $sort_order="sort";
	if($sort_how=="" || $sort_how=="undefined") $sort_how=0;


	/* ziska data o klientech */
		$search[webID] = $_SESSION["structure"]["web"];
		$search[langID] = $_SESSION["structure"]["lang"];
	$locationsData=$locations->getLocationsData($search);

	
	if(is_array($locationsData)){

		// seradi podle defaultniho poradi (nebo podle toho jak chce user)

	foreach ($locationsData as $key => $row) {
	   $sort_sort[$key]  = $row['page_sort'];		 
	   $sort_id[$key]  = $row['id'];
	   $sort_title[$key]  = $row['title'];
	   $sort_mtime[$key]  = $row['mtime'];
	   $sort_ctime[$key]  = $row['ctime'];
	}

	array_multisort(${"sort_".$sort_order}, $orderHowSort[$sort_how], $sort_sort, SORT_ASC, $locationsData);
	// konec razeni

	/* form */
	echo('<form name="locationsSortForm" id="locationsSortForm">');

		echo('<table cellpadding="10" cellspacing="0" border="0" class="tableEdit">');
		echo('<tr>');
			echo('<td>'); 

			echo('<table cellpadding="2" cellspacing="0" border="0">');
			echo('<tr>');
			echo('<td><strong>'.$u->getText('mod_locations_sort_change_according_to').'</strong></td>');

			echo('<td><a href="#" onClick="openLocationsSort(\'sort\',\'0\');" class="button"> '.$u->getText('mod_locations_sort_change_according_default_order').'</a></td>');

			echo('<td><a href="#" onClick="openLocationsSort(\'title\',\'0\');" class="button"> '.$u->getText('mod_locations_sort_change_according_title').'</a></td>');

			echo('<td><a href="#" onClick="openLocationsSort(\'id\',\'0\');" class="button"> '.$u->getText('mod_locations_sort_change_according_id').'</a></td>');

			echo('<td><a href="#" onClick="openLocationsSort(\'ctime\',\'0\');" class="button"> '.$u->getText('mod_locations_sort_change_according_ctime').'</a></td>');

			echo('<td><a href="#" onClick="openLocationsSort(\'mtime\',\'0\');" class="button"> '.$u->getText('mod_locations_sort_change_according_mtime').'</a></td>');

			echo('<td>|</td>');

			echo('<td><a href="#" onClick="openLocationsSort(\''.$sort_order.'\',\''.($sort_how==0 ? 1 : 0).'\');" class="button"> '.$u->getText('mod_locations_sort_change_according_backwards').'</a></td>');
			echo('</tr>');
			echo('</table>');
			echo('</td>');

		echo('</tr>');
		echo('<tr>');
			echo('<td>'); 

			echo ($u->getText("mod_locations_tip_orderCanBeChangedByDragAndDrop")."<br /><br />");

			echo('<ul id="sortable_list">');
			reset($locationsData);
			while(list($key,$val)=each($locationsData)){

				echo('<li id="item_'.$val[id].'" class="'.($v%2==0 ? "dark" : "light").'">');
				echo('<div class="overflowRow"><span class="float_id">id ['.$val[id].']</span><strong>'.$val[title].'</strong><span class="overflowText">'.$u->plainText($val[production]).' ('.$val[director].')</span></div>');
				echo('</li>');
				$v++;
			}
			echo('</ul>');
			
			echo("\n".'<br clear="all" />');

			echo('</td>');
		echo('</tr>');  
		echo('<tr>');
			echo('<td><a href="#" onClick="saveLocationsSort();" class="button"><img src="'.UW_BASE_URL.'/images/icons/save.gif" border="0" alt="" /> '.$u->getText('save').'</a><a href="#" onClick="getOffset(); list();" class="button"><img src="'.UW_BASE_URL.'/images/icons/cancel.gif" border="0" alt="" /> '.$u->getText('cancel').'</a><a href="#" onClick="openLocationsSort(\''.$sort_order.'\', \''.$sort_how.'\'); " class="button"><img src="'.UW_BASE_URL.'/images/icons/change.gif" border="0" alt="" /> '.$u->getText('refresh').'</a></td>');
		echo('</tr>');

		echo('<tr><td>&nbsp;</td></tr>');

	  echo('</table>');

		echo('<input type="hidden" name="sorted" id="sorted">');
		echo('<input type="hidden" name="action" value="save">');

	echo('</form>');

}else{
	echo($u->simpleMessage('info',$u->getText('mod_locations_locations_noLocations')));
}					

?>