/* locations */

// ěščřžýáíé


function listLocations(){
	var currentDate = new Date();
	http = createRequestObject();
	http.open('get', 'aac_locations_list.php?PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	http.onreadystatechange = listLocationsHandle;
	http.send(null);
}

function listLocationsHandle(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('locationsListArea').innerHTML=response;
				setTimeout("clearAacInfo('aacInfoArea');",1500);
				if($('mPage')) renderSlider();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;loading&nbsp;locations!';
		}
	}
}

function openLocation(id){
	var currentDate = new Date();
	http.open('get', 'aac_locations_open.php?item=' + id + '&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	http.onreadystatechange = handleOpenLocation;
	http.send(null);
}

function handleOpenLocation(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';

				$('locationsListArea').innerHTML=response;

				setTimeout("clearAacInfo('aacInfoArea');",1500);
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;loading&nbsp;location!';
		}
	}
}

function saveLocation(id){
	var currentDate = new Date();
	var postData=getFormData('locationEditForm');

	http.open('post', 'aac_locations_save.php?item=' + id + '&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf(), true);
	http.onreadystatechange = handleSaveLocation;
	http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	http.setRequestHeader("Content-length", postData.length);
	http.setRequestHeader("Connection", "close");
	http.send(postData);
}

function handleSaveLocation(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Saving';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Saving...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;

			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';									
				
			}else if(response=="inserted" || response=="updated"){

				if($("ajax_message")){
					$("ajax_message").className="mess_ok";
					$("ajax_message").innerHTML=getText("mod_locations_locations_msg_DataWasSaved");
				}else{
					var a=$("locationsListArea");
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_ok");
					e.className="mess_ok";
					e.innerHTML=getText("mod_locations_locations_msg_DataWasSaved");
					a.insertBefore(e, $("locationEditForm"));
				}
				
				aia.className = "infoSuccess";
				aia.innerHTML = 'Saved';

				listLocations();
			
			}else{
				$('locationsListArea').innerHTML=response;
			}

		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;saving&nbsp;location!';
		}
	}
}

function setLocationStatus(item,status){
	http = createRequestObject();
	http.open('get', 'aac_locations_status_update.php?item=' + item + '&status=' + status + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = setLocationStatusHandle;
	http.send(null);
}

function setLocationStatusHandle(){
	var aia=document.getElementById('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Updating...';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Updated';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'OK';
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				list();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;set&nbsp;location&nbsp;status!';
		}
	}
}

function setRecentStatus(item,status){
	http = createRequestObject();
	http.open('get', 'aac_locations_recent_update.php?item=' + item + '&status=' + status + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = setLocationRecentHandle;
	http.send(null);
}

function setLocationRecentHandle(){
	var aia=document.getElementById('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Updating...';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Updated';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'OK';
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				list();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;set&nbsp;recent&nbsp;status!';
		}
	}
}

function initLocationDeletion(user_id){
	$('darkboxDetails').innerHTML = '';
	$('darkboxDetails').innerHTML+= getText('mod_locations_locations_reallyDeleteThisLocation');
	$('darkboxDetails').innerHTML+= '<br /><br />';
	$('darkboxDetails').innerHTML+= '<a href="javascript: deleteLocation('+user_id+'); hideDarkbox();"><strong>'+getText('delete')+'</strong></a>';
	$('darkboxDetails').innerHTML+= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
	$('darkboxDetails').innerHTML+= '<a href="javascript: hideDarkbox();">'+getText('cancel')+'</a>';
}

function deleteLocation(item){
	http = createRequestObject();
	http.open('get', 'aac_locations_delete.php?item=' + item + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = deleteLocationHandle;
	http.send(null);
}

function deleteLocationHandle(){
	var aia=document.getElementById('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Deleting...';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Deleted';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'OK';
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				list();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;delete&nbsp;location!';
		}
	}
}

	/* sort */

function openLocationsSort(order, how){
	var currentDate = new Date();
	http = createRequestObject();
	http.open('get', 'aac_locations_sort_open.php?PHPSESSID=' + $("sid").value + '&order=' + order + '&how=' + how + '&time='+currentDate.valueOf());
	http.onreadystatechange = handleOpenLocationsSort;
	http.send(null);
}

function handleOpenLocationsSort(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('locationsListArea').innerHTML=response;
				setTimeout("clearAacInfo('aacInfoArea');",1500);

				initLocationsSort();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;loading&nbsp;locations&nbsp;sort!';
		}
	}
}

function initLocationsSort(){
	Sortable.create('sortable_list', {
	onChange:function(){ void(0); }, hoverclass:"slist_hover",
	onUpdate:function(){
		document.getElementById("sorted").value=cleanSerialized(Sortable.serialize('sortable_list',{})), void(0);
	}});
}

function cleanSerialized(string){	
	s=string.replace(/[^\d&]+/g,"");
	s=s.replace(/&/g,",");
	return s;
}

function saveLocationsSort(){
	document.getElementById("sorted").value=cleanSerialized(Sortable.serialize('sortable_list',{}));

	var currentDate = new Date();
	var postData=getFormData('locationsSortForm');

	http.open('post', 'aac_locations_sort_save.php?PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf(), true);
	http.onreadystatechange = saveLocationsSortHandle;
	http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	http.setRequestHeader("Content-length", postData.length);
	http.setRequestHeader("Connection", "close");
	http.send(postData);
}

function saveLocationsSortHandle(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Saving';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Saving...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';				
			
			}else if(response=="updated"){
				aia.className = "infoSuccess";
				aia.innerHTML = 'Saved';
				
				if($("ajax_message")){
					$("ajax_message").className="mess_ok";
					$("ajax_message").innerHTML=getText("content_msg_DataWasSaved");
				}else{
					var a=$("locationsListArea");
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_ok");
					e.className="mess_ok";
					e.innerHTML=getText("content_msg_DataWasSaved");
					a.insertBefore(e, $("locationsSortForm"));
				}
				
				getOffset();
				list();
							
				setTimeout("clearAacInfo('aacInfoArea');",1500);

			}else{
				alert(response);
			}

		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;saving&nbsp;locations&nbsp;sort(404)!';
		}
	}
}


	/*  */

function getOffset(){
	var listHeight=winHeight();
	if(window.innerHeight) listHeight=window.innerHeight;

	var listHeight=listHeight-161;

	var offsetValue=Math.round(listHeight/21)-2;
	$('offset').value=offsetValue;
}

function list(){
	a=$("listAction").value;
	eval(a);
}
function setOrder(o){
	if($("o").value==o){
		$("d").value=($("d").value=="ASC" ? "DESC" : "ASC");
	}else{
		$("o").value=o;
	}
	list();
}
function listFrom(n){
	$("off").value=n;
	list();
}

function setFilter(){
	$("off").value=0;
	$("filter").value=$("fakeFilter").value;
	list();
}

function clearFilter(){
	$("off").value=0;
	$("filter").value="";
	$("fakeFilter").value="";
	list();
}

function goToPage(n){
	pc=$("pageCount").value;

	// nejde o cislo
	if(isInteger(n)==false){
		
		$("goToPageNum").value="";

	}else{
		n=Math.ceil(n);
		if(n<1) n=1;
		if((pc-n)<1) n=pc;
		tmp_o=$("offSetFor["+n+"]").value;

		listFrom(tmp_o);
	}
}

function setUserOffset(){
	uo=$("userOffsetValue").value;

	// nejde o cislo
	if(isInteger(uo)==false){		
		$("userOffsetValue").value="";
	}else{
		$("useroffset").value=uo;
		$("off").value=0;
		list();
	}
}

/* set session */

function setListSession(module,code){
	var postData = "module="+module;
	els=getElementsByClass('l');
	var elsLen = els.length;
	for (i=0; i<elsLen; i++){ postData+='&' + els[i].id + "=" + els[i].value; }

	if(isHttpBusy){
		http.onreadystatechange = function () {}
		http.abort();
	}
	http.open('post', 'aac_session_list_save.php?PHPSESSID=' + $("sid").value + '&code=' + code, true);
	http.onreadystatechange = handleSetListSession;
	http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	http.setRequestHeader("Content-length", postData.length);
	http.setRequestHeader("Connection", "close");
	isHttpBusy = true;
	http.send(postData);
}

function handleSetListSession(){
	isHttpBusy = false;
	if(http.readyState == 1) void(0);
	if(http.readyState == 2) void(0);
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response!="error") eval(response);
		}
	}
}

/* save session */

function saveSession(spe,key,value,code){
	if(isHttpBusy){
		http.onreadystatechange = function () {}
		http.abort();
	}
	http = createRequestObject();
	http.open('get', 'aac_session_save.php?variant=' + spe + '&key=' + key + '&value=' + value + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = handleSessionSave;
	isHttpBusy = true;
	http.send(null);
	if(code) setTimeout("eval("+code+");",100);
}

function handleSessionSave(){
	isHttpBusy = false;
	return true;
}