<?
session_start();

header("Content-Type: text/html; charset=UTF-8");

	include("../../include/local.inc.php");
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("studios.inc.php");
	include("../mod_photos/photos.class.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$u=new Underwood();
	$studios=new Studios();
	$photoClass=new Photos();	

	/* */

	/* kontrola jestli je uzivatel prihlaseny */
	if($u->verifyUserRight("0")==0){
		echo('AccessDenied');
		exit();
	}

	$studio=intval($_GET[studio]);
	$item=intval($_GET[item]);

	/* ziska informace o lektorovi */
	if($studio>0){
		$search[id] = $studio;
		$search[param]="normal";
		$studiosData = $studios->getStudiosData($search);
	}else{
		echo('NoStudio');
	}

	// vezme data o stageu
	$stagesData = $studiosData[$studio]['stages']['data'];

	// vezme informaci o setech
	$setsData = $photoClass->getSetsData($none, "meta_title ASC");
	
	echo('<form name="studioStageEditForm" id="studioStageEditForm">');

	echo('<table cellpadding="3" cellspacing="0" border="0">');
		echo('<tr>');
			echo('<td class="caption">'.$u->getText('mod_studios_studios_studio_stage_title').'</td>');
			echo('<td>');
				echo('<input class="input high long" name="stage_title" id="stage_title" value="'.$stagesData[$item]["title"].'" />');
			echo('</td>');
		echo('</tr>');

		echo('<tr>');
			echo('<td class="caption">'.$u->getText('mod_studios_studios_studio_stage_slideshow').'</td>');
			echo('<td>');
				echo('<select name="stage_set_id" name="stage_set_id" class="donotHide">');
					echo('<option value="0"'.($stagesData[$item]["set_id"]==0 ? " selected" : "").'>-- ('.$u->getText('nothing').') --</option>');
					reset($setsData);
					while(list($key,$val)=each($setsData)){
						echo('<option value="'.$val[id].'"'.($stagesData[$item]["set_id"]==$val[id] ? " selected" : "").'>'.$val['title'].'</option>');
					}
					echo('</select>');
			echo('</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td class="caption">'.$u->getText('mod_studios_studios_studio_stage_area').'</td>');
			echo('<td>');
				echo('<input class="input" name="stage_area" id="stage_area" value="'.$stagesData[$item]["area"].'" />');
			echo('</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td class="caption">'.$u->getText('mod_studios_studios_studio_stage_height').'</td>');
			echo('<td>');
				echo('<input class="input" name="stage_height" id="stage_height" value="'.$stagesData[$item]["height"].'" />');
			echo('</td>');
		echo('</tr>');
		echo('<tr valign="top">');
			echo('<td class="caption">'.$u->getText('mod_studios_studios_studio_stage_note').'</td>');
			echo('<td>');
				echo('<textarea name="stage_note" id="stage_note" class="area w400">'.$stagesData[$item]["note"].'</textarea>');
			echo('</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td>&nbsp;</td>');
			echo('<td>&nbsp;</td>');
		echo('</tr>');

		echo('<tr>');
			echo('<td>&nbsp;</td>');
			echo('<td><a href="#" onClick="saveStudioStage();" class="button"><img src="'.UW_BASE_URL.'/images/icons/save.gif" border="0" alt="" /> '.$u->getText('save').'</a><a href="#" onClick="hideDarkbox();" class="button"><img src="'.UW_BASE_URL.'/images/icons/cancel.gif" border="0" alt="" /> '.$u->getText('cancel').'</a></td>');
		echo('</tr>');

	echo('</table>');

		echo('<input type="hidden" name="action" value="save">');
		echo('<input type="hidden" name="studio_id" value="'.$studio.'">');
		echo('<input type="hidden" name="item_id" value="'.$item.'">');

	echo('</form>');
?>