/* studios */

// ěščřžýáíé

function listStudios(){
	var currentDate = new Date();
	http = createRequestObject();
	http.open('get', 'aac_studios_list.php?PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	http.onreadystatechange = listStudiosHandle;
	http.send(null);
}

function listStudiosHandle(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('studiosListArea').innerHTML=response;
				setTimeout("clearAacInfo('aacInfoArea');",1500);
				if($('mPage')) renderSlider();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;loading&nbsp;studios!';
		}
	}
}

function openStudio(id){
	var currentDate = new Date();
	http.open('get', 'aac_studios_open.php?item=' + id + '&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	http.onreadystatechange = handleOpenStudio;
	http.send(null);
}

function handleOpenStudio(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';

				$('studiosListArea').innerHTML=response;

				setTimeout("clearAacInfo('aacInfoArea');",1500);
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;loading&nbsp;studio!';
		}
	}
}

function saveStudio(id){
	var currentDate = new Date();
	var postData=getFormData('studioEditForm');

	http.open('post', 'aac_studios_save.php?item=' + id + '&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf(), true);
	http.onreadystatechange = handleSaveStudio;
	http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	http.setRequestHeader("Content-length", postData.length);
	http.setRequestHeader("Connection", "close");
	http.send(postData);
}

function handleSaveStudio(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Saving';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Saving...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;

			if(response=="error"){
				aia.className = "infoError";
							
			}else if(response=="inserted" || response=="updated"){

				if($("ajax_message")){
					$("ajax_message").className="mess_ok";
					$("ajax_message").innerHTML=getText("mod_studios_studios_msg_DataWasSaved");
				}else{
					var a=$("studiosListArea");
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_ok");
					e.className="mess_ok";
					e.innerHTML=getText("mod_studios_studios_msg_DataWasSaved");
					a.insertBefore(e, $("studioEditForm"));
				}
				
				aia.className = "infoSuccess";
				aia.innerHTML = 'Saved';

				listStudios();
			
			}else{
				$('studiosListArea').innerHTML=response;
			}

		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;saving&nbsp;studio!';
		}
	}
}

function setStudioStatus(item,status){
	http = createRequestObject();
	http.open('get', 'aac_studios_status_update.php?item=' + item + '&status=' + status + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = setStudioStatusHandle;
	http.send(null);
}

function setStudioStatusHandle(){
	var aia=document.getElementById('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Updating...';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Updated';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'OK';
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				list();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;set&nbsp;studio&nbsp;status!';
		}
	}
}

function initStudioDeletion(user_id){
	$('darkboxDetails').innerHTML = '';
	$('darkboxDetails').innerHTML+= getText('mod_studios_studios_reallyDeleteThisStudio');
	$('darkboxDetails').innerHTML+= '<br /><br />';
	$('darkboxDetails').innerHTML+= '<a href="javascript: deleteStudio('+user_id+'); hideDarkbox();"><strong>'+getText('delete')+'</strong></a>';
	$('darkboxDetails').innerHTML+= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
	$('darkboxDetails').innerHTML+= '<a href="javascript: hideDarkbox();">'+getText('cancel')+'</a>';
}

function deleteStudio(item){
	http = createRequestObject();
	http.open('get', 'aac_studios_delete.php?item=' + item + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = deleteStudioHandle;
	http.send(null);
}

function deleteStudioHandle(){
	var aia=document.getElementById('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Deleting...';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Deleted';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'OK';
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				list();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;delete&nbsp;studio!';
		}
	}
}

function checkElementsWithName(name){
	var els = new Array();
	els=document.body.getElementsByTagName('input');
	
	for(var i=0;i<els.length;i++) {
		if(els[i].type=="checkbox" && els[i].name.indexOf(name) != -1){
			els[i].checked=(els[i].checked==false ? true : false);
		}
	}
} 

 /* stages */

function openStudioStages(id){
	var currentDate = new Date();
	http.open('get', 'aac_studios_stages_list.php?item=' + id + '&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	http.onreadystatechange = openStudioStagesHandle;
	http.send(null);
}

function openStudioStagesHandle(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('studiosListArea').innerHTML=response;
				setTimeout("clearAacInfo('aacInfoArea');",1500);
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;loading&nbsp;studio&nbsp;stages!';
		}
	}
}

function initStudioStageEditor(studio,item){
	var currentDate = new Date();
	http = createRequestObject();
	http.open('get', 'aac_studios_stages_open.php?studio=' + studio + '&item=' + item + '&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	http.onreadystatechange = initStudioStageEditorHandle;
	http.send(null);
}

function initStudioStageEditorHandle(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1) void(0);
	if(http.readyState == 2) void(0);
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error&nbsp;loading&nbsp;stages&nbsp;for&nbsp;editor';
			}else{
				$('darkboxDetails').innerHTML = '<div id="darkBoxLister" class="list">&nbsp;</div>';
				$('darkBoxLister').innerHTML=response;
				$('darkBoxLister').style.paddingRight="5px";
				$('darkBoxLister').style.overflow="auto";
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;loading&nbsp;stages&nbsp;for&nbsp;editor!';
		}
	}
}


function saveStudioStage(){
	var currentDate = new Date();
	var postData=getFormData('studioStageEditForm');

	http.open('post', 'aac_studios_stages_save.php?PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf(), true);
	http.onreadystatechange = saveStudioStageHandle;
	http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	http.setRequestHeader("Content-length", postData.length);
	http.setRequestHeader("Connection", "close");
	http.send(postData);
}

function saveStudioStageHandle(){
	var aia=document.getElementById('aacInfoArea');

	if(http.readyState == 1) void(0);
	if(http.readyState == 2) void(0);
	if(http.readyState == 4){
		if(http.status == 200){
			response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){

				aia.className = "infoError";
				aia.innerHTML = 'Error';
	
			}else if(response=="inserted" || response=="updated"){

				openStudioStages($F('studio'));
				hideDarkbox();
			
			}else{
				$('darkBoxLister').innerHTML=response;
			}


		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;saving&nbsp;studio&nbsp;stage';
		}
	}
}

function initStudioStageDeletion(item){
	$('darkboxDetails').innerHTML = '';
	$('darkboxDetails').innerHTML+= getText('mod_studios_studios_reallyDeleteThisStudioStage');
	$('darkboxDetails').innerHTML+= '<br /><br />';
	$('darkboxDetails').innerHTML+= '<a href="javascript: deleteStudioStage('+item+'); hideDarkbox();"><strong>'+getText('delete')+'</strong></a>';
	$('darkboxDetails').innerHTML+= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
	$('darkboxDetails').innerHTML+= '<a href="javascript: hideDarkbox();">'+getText('cancel')+'</a>';
}

function deleteStudioStage(item){
	http = createRequestObject();
	http.open('get', 'aac_studios_stages_delete.php?item=' + item + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = deleteStudioStageHandle;
	http.send(null);
}

function deleteStudioStageHandle(){
	var aia=document.getElementById('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Deleting...';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Deleted';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'OK';
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				openStudioStages($F('studio'));
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;404&nbsp;delete&nbsp;studio&nbsp;stage!';
		}
	}
}

 /* action layer */

var alid=new Array();
var tmpOpenedActionLayer="";

function showActionLayer(takjak,layer){

	ol=layer;
	if(layer==0) layer=tmpOpenedActionLayer;
			
	clearTimeout(alid[layer]);

	if(takjak==false){
		$("action_list").style.display="none";
		css("remove",$("action_butt_"+layer),"buttonBorded");
		if($("absoluteLayerShadow")) $("absoluteLayerShadow").style.display="none";
		tmpOpenedActionLayer="";
		if($("singleAction")) $("singleAction").value=0;

	}else{
		y=getAnchorPosition("action_butt_"+layer).y;
		x=getAnchorPosition("action_butt_"+layer).x;

		$("action_list").style.left=(x+0)+"px";
		$("action_list").style.top=(y+20)+"px";

		if(tmpOpenedActionLayer!="" && layer!=tmpOpenedActionLayer){
			$("action_list").style.display="none";				
			css("remove",$("action_butt_"+tmpOpenedActionLayer),"buttonBorded");

			if($("absoluteLayerShadow")) $("absoluteLayerShadow").style.display="none";
			tmpOpenedActionLayer="";
			if($("singleAction")) $("singleAction").value=0;
		}
		tmpOpenedActionLayer=layer;

		$("action_list").style.display="block";

		css("add",$("action_butt_"+layer),"buttonBorded");

		if($("absoluteLayerShadow")){
			$("absoluteLayerShadow").style.height=(getElementHeight("action_list")+6)+"px";
			$("absoluteLayerShadow").style.width=getElementWidth("action_list")+"px";

			$("absoluteLayerShadow").style.left=(x+(-7))+"px";
			$("absoluteLayerShadow").style.top=(y+21)+"px";

			$("absoluteLayerShadow").style.display="block";
		}
		if($("singleAction")) $("singleAction").value=tmpOpenedActionLayer;
	}
}

function hideActionLayer(){	
	alid[tmpOpenedActionLayer] = setTimeout("showActionLayer(false,'"+tmpOpenedActionLayer+"')", 250);
}

	/*  */

function getOffset(){
	var listHeight=winHeight();
	if(window.innerHeight) listHeight=window.innerHeight;

	var listHeight=listHeight-161;

	var offsetValue=Math.round(listHeight/21)-2;
	$('offset').value=offsetValue;
}

function list(){
	a=$("listAction").value;
	eval(a);
}
function setOrder(o){
	if($("o").value==o){
		$("d").value=($("d").value=="ASC" ? "DESC" : "ASC");
	}else{
		$("o").value=o;
	}
	list();
}
function listFrom(n){
	$("off").value=n;
	list();
}

function setFilter(){
	$("off").value=0;
	$("filter").value=$("fakeFilter").value;
	list();
}

function clearFilter(){
	$("off").value=0;
	$("filter").value="";
	$("fakeFilter").value="";
	list();
}

function goToPage(n){
	pc=$("pageCount").value;

	// nejde o cislo
	if(isInteger(n)==false){
		
		$("goToPageNum").value="";

	}else{
		n=Math.ceil(n);
		if(n<1) n=1;
		if((pc-n)<1) n=pc;
		tmp_o=$("offSetFor["+n+"]").value;

		listFrom(tmp_o);
	}
}

function setUserOffset(){
	uo=$("userOffsetValue").value;

	// nejde o cislo
	if(isInteger(uo)==false){		
		$("userOffsetValue").value="";
	}else{
		$("useroffset").value=uo;
		$("off").value=0;
		list();
	}
}

/* set session */

function setListSession(module,code){
	var postData = "module="+module;
	els=getElementsByClass('l');
	var elsLen = els.length;
	for (i=0; i<elsLen; i++){ postData+='&' + els[i].id + "=" + els[i].value; }

	if(isHttpBusy){
		http.onreadystatechange = function () {}
		http.abort();
	}
	http.open('post', 'aac_session_list_save.php?PHPSESSID=' + $("sid").value + '&code=' + code, true);
	http.onreadystatechange = handleSetListSession;
	http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	http.setRequestHeader("Content-length", postData.length);
	http.setRequestHeader("Connection", "close");
	isHttpBusy = true;
	http.send(postData);
}

function handleSetListSession(){
	isHttpBusy = false;
	if(http.readyState == 1) void(0);
	if(http.readyState == 2) void(0);
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response!="error") eval(response);
		}
	}
}

/* save session */

function saveSession(spe,key,value,code){
	if(isHttpBusy){
		http.onreadystatechange = function () {}
		http.abort();
	}
	http = createRequestObject();
	http.open('get', 'aac_session_save.php?variant=' + spe + '&key=' + key + '&value=' + value + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = handleSessionSave;
	isHttpBusy = true;
	http.send(null);
	if(code) setTimeout("eval("+code+");",100);
}

function handleSessionSave(){
	isHttpBusy = false;
	return true;
}