<?
session_start();

header("Content-Type: text/html; charset=UTF-8");

	include("../../include/local.inc.php");		
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("users.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$activeModule="users";	
	$u=new Underwood();
	
	/* */

	$openUser=intval($_GET[user]);

	if($u->verifyUserRight("users_insert")==0 && $openUser==0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}

	if($openUser==$_SESSION['uw']['user']['id'] && ($u->verifyUserRight("users_my")==0 && $u->verifyUserRight("users_edit")==0)){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}

	if($openUser!=$_SESSION['uw']['user']['id'] && $openUser>0 && $u->verifyUserRight("users_edit")==0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}

	/* ziska informace o userech */
	if($openUser>0){
		$usersData=getUsers("normal");	
	}else{
		// defaultni nastaveni pro uzivatele
		$usersData[0][status_timecheck]=1;
		$usersData[0][stime]="0000-00-00 00:00:00";
		$usersData[0][etime]="0000-00-00 00:00:00";
	}

	// casova platnost
	$n_use_timecheck=intval($usersData[$openUser][status_timecheck]);
	if($n_use_timecheck==1) $css_table_timecheck="masked";
	$css_use_timecheck[$n_use_timecheck]="inuse";

	if($usersData[$openUser][stime]=="0000-00-00 00:00:00"){	
		$tmp_s_year=date("Y",time());
		$tmp_s_month=date("m",time());
		$tmp_s_day=date("d",time());
		$tmp_s_hour=date("H",time());
		$tmp_s_min=date("i",time());
	}else{			
		$n=sscanf($usersData[$openUser][stime], "%d-%d-%d %d:%d:%d", $tmp_s_year, $tmp_s_month, $tmp_s_day, $tmp_s_hour, $tmp_s_min, $tmp_s_sec);
	}

	if($usersData[$openUser][etime]=="0000-00-00 00:00:00"){	
		$tmp_e_year=date("Y",time());
		$tmp_e_month=date("m",time());
		$tmp_e_day=date("d",(time()+3600*24));
		$tmp_e_hour=date("H",time());
		$tmp_e_min=date("i",time());
	}else{			
		$n=sscanf($usersData[$openUser][etime], "%d-%d-%d %d:%d:%d", $tmp_e_year, $tmp_e_month, $tmp_e_day, $tmp_e_hour, $tmp_e_min, $tmp_e_sec);
	}

	?>

<form name="userEditForm" id="userEditForm">

  <table cellpadding="8" cellspacing="0" border="0" class="tableEdit">
	<tr><td><h4 class="title"><? echo ($openUser>0 ? $usersData[$openUser][fullname] :  $u->getText("users_newUser")); ?></h4></td></tr>
	<tr> 
	  <td><table border="0" cellspacing="0" cellpadding="2">
		  <tr> 
			<td class="caption"><? echo $u->getText('user_it_user'); ?></td>
			<td>&nbsp;</td>
			<td><input type="text" class="input shortest<? if($alert=="username") echo(' alert'); ?>" value="<? echo $usersData[$openUser][username]; ?>" name="d_username" title="<? echo $u->getText("required"); ?>"></td>	
			<td>&nbsp;</td>
			<td class="example"><? echo $u->getText('e_g').' '.$u->getText('user_eg_userUsername'); ?></td>
		  </tr>			  
		  <tr> 
			<td colspan="5">&nbsp;</td>
		  </tr>			
		  <tr> 
			<td class="caption"><? echo $u->getText('user_it_name'); ?></td>
			<td>&nbsp;</td>
			<td><input type="text" class="input shorter" value="<? echo $usersData[$openUser][name]; ?>" name="d_name"></td>	
			<td>&nbsp;</td>
			<td class="example"><? echo $u->getText('e_g').' '.$u->getText('user_eg_userName'); ?></td>
		  </tr>
		  <tr>
			<td class="caption"><? echo $u->getText('user_it_surname'); ?></td>
			<td>&nbsp;</td>
			<td><input type="text" class="input shorter" value="<? echo $usersData[$openUser][surname]; ?>" name="d_surname"></td>
			<td>&nbsp;</td>
			<td class="example"><? echo $u->getText('e_g').' '.$u->getText('user_eg_userSurname'); ?></td>
		  </tr>
		  <tr> 
			<td colspan="5">&nbsp;</td>
		  </tr>			
		 <tr> 
			<td class="caption"><? echo $u->getText('user_it_password'); ?></td>
			<td>&nbsp;</td>
			<td><input type="password" class="input shorter<? if($alert=="pass") echo(' alert'); ?>" value="" name="d_pass" id="d_pass" onkeyup="ratePassword('d_pass');"></td>
			<td>&nbsp;</td>
			<td><div id="t_pass_quality_txt"><? echo $u->getText('password_quality_very_poor'); ?></div><div id="t_pass_quality_bar_bg"><div id="t_pass_quality_bar">&nbsp;</div></div></td>
		  </tr>
		  <tr> 
			<td class="caption"><? echo $u->getText('user_it_password_repeat'); ?></td>
			<td>&nbsp;</td>
			<td><input type="password" class="input shorter" value="" name="d_pass2" id="d_pass2"></td>
			<td>&nbsp;</td>
			<td class="example"><? echo $u->getText('user_tip_creatingGoodPassword'); ?></td>
		  </tr>	
		  <tr> 
			<td colspan="5">&nbsp;</td>
		  </tr>	
		  <tr> 				
			<td class="caption"><? echo $u->getText('user_it_email'); ?></td>	
			<td>&nbsp;</td>
			<td colspan="3"><input type="text" class="input long<? if($alert=="email") echo(' alert'); ?>" value="<? echo $usersData[$openUser][email]; ?>" name="d_email" title="<? echo $u->getText("required"); ?>"></td>				
	   </tr>
	   <tr> 
			<td colspan="5">&nbsp;</td>
	   </tr>
	   <?
	   /* kontrola jestli na to ma uzivatel prava */
	   if($u->verifyUserRight("users_changeUserAccountTimeValidity")==1){
		   ?>
		   <tr>
				<td class="popis" valign="top"><strong><? echo $u->getText('user_it_timecheck'); ?></strong></td>
				<td>&nbsp;</td>
				<td colspan="3">
				<table cellpadding="1" cellspacing="0" border="0" style="position: relative; left: -6px;">
				  <tr>				   
					   <td onclick="highlight_timecheck(1);"><input type="radio" name="f_use_timecheck" value="1"<? echo ($n_use_timecheck==1 ? ' checked="checked"' : ''); ?>></td>	
					   <td id="use_timecheck[1]" class="pointer <? echo $css_use_timecheck[1]; ?>" onclick="document.userEditForm.f_use_timecheck[0].checked=true; highlight_timecheck(1);"><? echo $u->getText('user_it_timecheck_true'); ?></td>
					   <td>&nbsp;</td>
				  </tr>
				  <tr valign="top">
					   <td onclick="highlight_timecheck(2);" style="padding-top: 2px !important;"><input type="radio" name="f_use_timecheck" value="2"<? echo ($n_use_timecheck==2 ? ' checked="checked"' : ''); ?>></td>	
					   <td id="use_timecheck[2]" class="pointer <? echo $css_use_timecheck[2]; ?>" onclick="document.userEditForm.f_use_timecheck[1].checked=true; highlight_timecheck(2);" style="padding-top: 4px !important;"><? echo $u->getText('user_it_timecheck_false'); ?></td>			
					   <td>
						  <table cellpadding="0" cellspacing="0" border="0" id="timecheck_table" class="<? echo $css_table_timecheck; ?>">
							<tr>	
								<td>&nbsp;</td>
								<td><? echo $u->getText('timefrom'); ?></td>
								<td>&nbsp;</td><td><select name="t_s_date[day]"><? for($i=1;$i<32;$i++){ $i=sprintf("%02d",$i); ?>
								<option value="<? echo $i; ?>" <? if($i==$tmp_s_day){ echo "selected"; } ?>><? echo $i; ?></option><? } ?>
								</select></td>
								<td><select name="t_s_date[month]"><? for($i=1;$i<13;$i++){ $i=sprintf("%02d",$i); ?><option value="<? echo $i; ?>" <? if($i==$tmp_s_month){ echo "selected"; } ?>><? echo $i; ?></option><? } ?></select></td>
								<td><select name="t_s_date[year]"><? for($i=$cfg[max_year];$i>1996;$i--){ ?><option value="<? echo $i; ?>" <? if($i==$tmp_s_year){ echo "selected"; } ?>><? echo $i; ?></option><? } ?></select></td>
								<td>&nbsp;</td>
								<td><select name="t_s_date[hour]"><? for($i=0;$i<24;$i++){ $i=sprintf("%02d",$i); ?><option value="<? echo $i; ?>" <? if($i==$tmp_s_hour){ echo "selected"; } ?>><? echo $i; ?></option><? } ?></select></td>
								<td>:</td>
								<td><select name="t_s_date[minute]"><? for($i=0;$i<60;$i++){ $i=sprintf("%02d",$i); ?><option value="<? echo $i; ?>" <? if($i==$tmp_s_min){ echo "selected"; } ?>><? echo $i; ?></option><? } ?></select></td>
							</tr>
							<tr align="middle">	
								<td>&nbsp;</td>
								<td><? echo $u->getText('timeto'); ?></td>
								<td>&nbsp;</td>
								<td><select name="t_e_date[day]"><? for($i=1;$i<32;$i++){ $i=sprintf("%02d",$i); ?><option value="<? echo $i; ?>" <? if($i==$tmp_e_day){ echo "selected"; } ?>><? echo $i; ?></option><? } ?></select></td>
								<td><select name="t_e_date[month]"><? for($i=1;$i<13;$i++){ $i=sprintf("%02d",$i); ?><option value="<? echo $i; ?>" <? if($i==$tmp_e_month){ echo "selected"; } ?>><? echo $i; ?></option><? } ?></select></td>
								<td><select name="t_e_date[year]"><? for($i=$cfg[max_year];$i>1996;$i--){ ?><option value="<? echo $i; ?>" <? if($i==$tmp_e_year){ echo "selected"; } ?>><? echo $i; ?></option><? } ?></select></td>
								<td>&nbsp;</td>
								<td><select name="t_e_date[hour]"><? for($i=0;$i<24;$i++){ $i=sprintf("%02d",$i); ?><option value="<? echo $i; ?>" <? if($i==$tmp_e_hour){ echo "selected"; } ?>><? echo $i; ?></option><? } ?></select></td>
								<td>:</td>
								<td><select name="t_e_date[minute]"><? for($i=0;$i<60;$i++){ $i=sprintf("%02d",$i); ?><option value="<? echo $i; ?>" <? if($i==$tmp_e_min){ echo "selected"; } ?>><? echo $i; ?></option><? } ?></select></td>	 
							</tr>
						  </table>						
					   </td>
				  </tr>
			   </table>
		   </td>
		</tr>
	<? }else{
		// pokud nema prava na meneni casove platnosti uctu, musim udrzet hodnoty
		echo('<input type="hidden" name="f_use_timecheck" value="'.($n_use_timecheck==1 ? 1 : 2).'">');
		// start
		echo('<input type="hidden" name="t_s_date[day]" value="'.$tmp_s_day.'">');
		echo('<input type="hidden" name="t_s_date[month]" value="'.$tmp_s_month.'">');
		echo('<input type="hidden" name="t_s_date[year]" value="'.$tmp_s_year.'">');
		echo('<input type="hidden" name="t_s_date[hour]" value="'.$tmp_s_hour.'">');
		echo('<input type="hidden" name="t_s_date[minute]" value="'.$tmp_s_min.'">');
		// expiration
		echo('<input type="hidden" name="t_e_date[day]" value="'.$tmp_e_day.'">');
		echo('<input type="hidden" name="t_e_date[month]" value="'.$tmp_e_month.'">');
		echo('<input type="hidden" name="t_e_date[year]" value="'.$tmp_e_year.'">');
		echo('<input type="hidden" name="t_e_date[hour]" value="'.$tmp_e_hour.'">');
		echo('<input type="hidden" name="t_e_date[minute]" value="'.$tmp_e_min.'">');
	} ?>
	</table></td>
	</tr>				
	<tr> 
	  <td><a href="#" onClick="saveUser(<? echo $openUser; ?>);" class="button"><img src="<? echo UW_BASE_URL; ?>/images/icons/save.gif" border="0" alt="" /> <? echo $u->getText('save'); ?></a><a href="#" onClick="getOffset(); list();" class="button"><img src="<? echo UW_BASE_URL; ?>/images/icons/cancel.gif" border="0" alt="" /> <? echo $u->getText('cancel'); ?></a><a href="#" onClick="openUser(<? echo $openUser; ?>); " class="button"><img src="<? echo UW_BASE_URL; ?>/images/icons/change.gif" border="0" alt="" /> <? echo $u->getText('refresh'); ?></a></td>
	</tr>		
	<tr><td>&nbsp;</td></tr>
  </table>
	<? /* kontrola jestli na to ma uzivatel prava */
	   if($u->verifyUserRight("users_changeUserAccountTimeValidity")==1){ 
		   echo('<script> highlight_timecheck('.$n_use_timecheck.'); </script>');
	   }
	?>
	<input type="hidden" name="fcc_require" value="d_username,d_email">		
	<input type="hidden" name="fcc_email" value="d_email">
	<input type="hidden" name="fcc_same" value="d_pass,d_pass2">	
	<input type="hidden" name="action" value="save">
	<input type="hidden" name="user_id" value="<? echo $openUser; ?>">	

</form>