<?
	session_start();

	include("../../include/local.inc.php");		
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("content.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$u=new Underwood();	

	/* */

	/* kontrola jestli je uzivatel prihlaseny */
	if($u->verifyUserRight("0")==0){
		echo('AccessDenied');
		exit();
	}

	$node=intval($_GET["node"]);
	$sort_order=$_GET["order"];
	$sort_how=$_GET["how"];

	$orderHowSort=array(SORT_ASC,SORT_DESC);

	if($sort_order=="" || $sort_order=="undefined") $sort_order="sort";
	if($sort_how=="" || $sort_how=="undefined") $sort_how=0;

	// pokud nemam žadnou sekci (sem v rootu)
	if($node<1){
		echo($u->simpleMessage('info',$u->getText('content_chooseSection')));
		exit();
	}

	/* ziska informace o strankach */
	$pagesData=getPages("normal");
	$pagesDataCount=getPages("count");

	$section=$_SESSION[content][l][section];
	$off=intval($_SESSION[content][l][off]);
	$order=$_SESSION[content][l][o];
	$how=$_SESSION[content][l][d];
	$offset=intval($_SESSION[content][l][offset]);
	$resultCountAll=intval($pagesDataCount);

	// prava uzivatele na strom
	$structureRightsData=$u->getStructureRightsData($_SESSION['uw']['user']['id']);

	// pokud nemam pristup do tehle rubriky
	if(in_array($node, $structureRightsData[$_SESSION['uw']['user']['id']])==false){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();
	}

	if(is_array($pagesData)){

		// seradi podle defaultniho poradi (nebo podle toho jak chce user)

	foreach ($pagesData as $key => $row) {
	   $sort_sort[$key]  = $row['page_sort'];		 
	   $sort_id[$key]  = $row['id'];
	   $sort_title[$key]  = $row['title'];
	   $sort_mtime[$key]  = $row['mtime'];
	   $sort_ctime[$key]  = $row['ctime'];
	}

	array_multisort(${"sort_".$sort_order}, $orderHowSort[$sort_how], $sort_sort, SORT_ASC, $pagesData);
	// konec razeni

	/* form */
	echo('<form name="pagesStructureSortForm" id="pagesStructureSortForm">');

		echo('<table cellpadding="10" cellspacing="0" border="0" class="tableEdit">');
		echo('<tr>');
			echo('<td>'); 

			echo('<table cellpadding="2" cellspacing="0" border="0">');
			echo('<tr>');
			echo('<td><strong>'.$u->getText('content_section_sort_change_according_to').'</strong></td>');

			echo('<td><a href="#" onClick="openPageStructureSort('.$node.',\'sort\',\'0\');" class="button"> '.$u->getText('content_section_sort_change_according_default_order').'</a></td>');

			echo('<td><a href="#" onClick="openPageStructureSort('.$node.',\'title\',\'0\');" class="button"> '.$u->getText('content_section_sort_change_according_title').'</a></td>');

			echo('<td><a href="#" onClick="openPageStructureSort('.$node.',\'id\',\'0\');" class="button"> '.$u->getText('content_section_sort_change_according_id').'</a></td>');

			echo('<td><a href="#" onClick="openPageStructureSort('.$node.',\'ctime\',\'0\');" class="button"> '.$u->getText('content_section_sort_change_according_ctime').'</a></td>');

			echo('<td><a href="#" onClick="openPageStructureSort('.$node.',\'mtime\',\'0\');" class="button"> '.$u->getText('content_section_sort_change_according_mtime').'</a></td>');

			echo('<td>|</td>');

			echo('<td><a href="#" onClick="openPageStructureSort('.$node.',\''.$sort_order.'\',\''.($sort_how==0 ? 1 : 0).'\');" class="button"> '.$u->getText('content_section_sort_change_according_backwards').'</a></td>');
			echo('</tr>');
			echo('</table>');
			echo('</td>');

		echo('</tr>');
		echo('<tr>');
			echo('<td>'); 

			echo ($u->getText("content_tip_orderCanBeChangedByDragAndDrop")."<br /><br />");

			echo('<ul id="sortable_list">');
			reset($pagesData);
			while(list($key,$val)=each($pagesData)){

				echo('<li id="item_'.$val[page_id].'" class="'.($v%2==0 ? "dark" : "light").'">');
				echo('<div class="overflowRow"><span class="float_id">id ['.$val[page_id].']</span><strong>'.$val[title].'</strong><span class="overflowText">'.$u->plainText($val[text]).'</span></div>');
				echo('</li>');
				$v++;
			}
			echo('</ul>');
			
			echo("\n".'<br clear="all" />');

			echo('</td>');
		echo('</tr>');  
		echo('<tr>');
			echo('<td><a href="#" onClick="savePageStructureSort('.$node.');" class="button"><img src="'.UW_BASE_URL.'/images/icons/save.gif" border="0" alt="" /> '.$u->getText('save').'</a><a href="#" onClick="getOffset(); list();" class="button"><img src="'.UW_BASE_URL.'/images/icons/cancel.gif" border="0" alt="" /> '.$u->getText('cancel').'</a><a href="#" onClick="openPageStructureSort('.$node.', \''.$sort_order.'\', \''.$sort_how.'\'); " class="button"><img src="'.UW_BASE_URL.'/images/icons/change.gif" border="0" alt="" /> '.$u->getText('refresh').'</a></td>');
		echo('</tr>');

		echo('<tr><td>&nbsp;</td></tr>');

	  echo('</table>');

		echo('<input type="hidden" name="sorted" id="sorted">');
		echo('<input type="hidden" name="action" value="save">');
		echo('<input type="hidden" name="node" value="'.$node.'">');

	echo('</form>');

}else{
	echo($u->simpleMessage('info',$u->getText('content_sectionIsEmpty')));
}					

?>