<?
session_start();

header("Content-Type: text/html; charset=UTF-8");

	include("../../include/local.inc.php");		
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("content.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$activeModule="content";
	$u=new Underwood();	

	$node=intval($_GET["node"]);
	$web=intval($_GET["web"]);

	if($u->verifyUserRight("content_section_sort_subsections")==0){
		echo('AccessDenied');
		exit();
	
	}elseif($node>0){
			
		$sectionsData=getSectionsForSort($node,0);

		if(is_Array($sectionsData)){

			foreach ($sectionsData as $key => $row) {
			   $sort_id[$key]  = $row['id'];
			   $sort_sort[$key]  = $row['sort'];
			   $sort_title[$key]  = $row['title'];
			}

			array_multisort($sort_sort, SORT_ASC, $sectionsData);
			// konec razeni	

			echo('<form name=structureSortForm" id="structureSortForm">');

				echo ("<span>".$u->getText("content_tip_subsectionsOrderCanBeChangedByDragAndDrop")."</span><br />");

				echo('<ul id="sortable_list">');
				reset($sectionsData);
				while(list($key,$val)=each($sectionsData)){

					echo('<li id="item_'.$val[id].'" class="'.($v%2==0 ? "dark" : "light").'">');
						echo('<strong>'.$val[title].'</strong>');
					echo('</li>');
					$v++;
				}
				echo('</ul>');

				echo('<br />');
				echo('<a href="#" onClick="contentNodeSort('.$node.');" class="button"><strong>'.$u->getText('save').'</strong></a>');
				echo('&nbsp;&nbsp;');
				echo('<a href="#" onClick="cancelContentNodeEditQuestion('.$node.');" class="button">'.$u->getText('cancel').'</a>');
						
				echo('<input type="hidden" name="sorted" id="sorted">');
				echo('<input type="hidden" name="action" value="save">');
				echo('<input type="hidden" name="node" value="'.$node.'">');

			echo('</form>');

		}else{			
			echo('content_msg_anySubsections');
			exit();
		}

	}else{
		echo('error');
		exit();
	}		

	db_close($link);

?>