<?
session_start();

	include("../../include/local.inc.php");
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("content.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$activeModule="users";
	$u=new Underwood();

		$page=intval($_GET["page"]);
		$version=intval($_GET["version"]);
		
	// prava uzivatele na strom
	$structureRightsData=$u->getStructureRightsData($_SESSION['uw']['user']['id']);
	
	/* kontrola jestli je uzivatel prihlaseny */
	if($u->verifyUserRight("content_page_insert")==0 && ($page==0 && $version==0)){
		header("Location: ".UW_BASE_URL."/?403=true&request=".$_SERVER[REQUEST_URI]);
		exit();
	}

	/* kontrola jestli je uzivatel prihlaseny */
	if($u->verifyUserRight("content_page_update")==0 && ($page>0 || $version>0)){
		header("Location: ".UW_BASE_URL."/?403=true&request=".$_SERVER[REQUEST_URI]);
		exit();
	}

	// kontrola jestli ma uzivatel prava na tuhle rubriku
	if(!in_array($_SESSION[content][l][section], $structureRightsData[$_SESSION['uw']['user']['id']])){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}

	/* akce */

	// pokud zakladam stranku (page<1 && version<1)
	if($page<1 && $version<1 && $useTemplate<1 && $_POST["action"]!="save"){

		// zalozi stranku v db
		$query = "INSERT INTO ".$cfg['db']['table'][content_pages]." (user_id, ctime, mtime) VALUES ('".$u->checkData($_SESSION['uw']['user']['id'])."', NOW(), NOW());";
		$result = db_query($query,$link);
		
		$page_id=db_insert_id($link);
		
		// vlozi stranku do prislusneho nodu stromu
		$query = "REPLACE INTO ".$cfg['db']['table'][content_structure_pages]." (node_id, page_id) VALUES ('".$u->checkData($_SESSION[content][l][section])."', '".$u->checkData($page_id)."');";
		$result = db_query($query,$link);

		header("Location: edit.php?page=".$page_id."&PHPSESSID=".session_id());	
		exit();	
	}
			
		// ulozeni stranky
		if($_POST["action"]=="save"){

			$page_id=intval($_POST["page_id"]);
			
			// pokud to neni nova stranka, ziska posledni cislo verze
			if($_POST["page_version_id"]>0){
				$versionNum=getLastPageVersion($page_id);
			}

			// soucasna verze
			$versionNum=intval($versionNum);

				// upravy promeny pro ulozeni
				$rtime = sprintf("%04d-%02d-%02d %02d:%02d", intval($rtime_y), intval($rtime_m), intval($rtime_d), intval($rtime_h), intval($rtime_i));
				$atime = sprintf("%04d-%02d-%02d %02d:%02d", intval($atime_y), intval($atime_m), intval($atime_d), intval($atime_h), intval($atime_i));
				$stime = sprintf("%04d-%02d-%02d %02d:%02d", intval($stime_y), intval($stime_m), intval($stime_d), intval($stime_h), intval($stime_i));
				$etime = sprintf("%04d-%02d-%02d %02d:%02d", intval($etime_y), intval($etime_m), intval($etime_d), intval($etime_h), intval($etime_i));

			// pokud je prazdne uri, vygeneruje podle titulku
			if($_POST["page_uri"]==""){
				$_POST["page_uri"]=cleanUri($_POST["page_title"]);
			}else{
				// vycisti uri od nehezkych znaku
				$_POST["page_uri"]=cleanUri($_POST["page_uri"]);
			}

			$query = "INSERT INTO ".$cfg['db']['table'][content_pagesdata]." (page_id, user_id, page_keywords, page_uri, image_small, image_middle, image_big, title, perex, text, rtime, atime, meta_keywords, meta_description, meta_title, version, version_type, version_title, stime, etime, status, ctime, mtime) VALUES ('".$u->checkData($page_id)."', '".$u->checkData($_SESSION['uw']['user']['id'])."', '".$u->checkData($_POST["page_keywords"])."', '".$u->checkData($_POST["page_uri"])."', '".$u->checkData(intval($_POST["page_image_small"]))."', '".$u->checkData(intval($_POST["page_image_middle"]))."', '".$u->checkData(intval($_POST["page_image_big"]))."', '".$u->checkData($_POST["page_title"])."', '".$u->checkData($_POST["page_perex"])."', '".$u->checkData($_POST["txtContent"])."', '".$u->checkData($rtime)."', '".$u->checkData($atime)."', '".$u->checkData($_POST["page_meta_keywords"])."', '".$u->checkData($_POST["page_meta_description"])."', '".$u->checkData($_POST["page_meta_title"])."', '".$u->checkData(($versionNum+1))."', '".$u->checkData($_POST["versionType"])."', '".($_POST["versionType"]==1 ? "" : $u->checkData($_POST["newVersionTitle"]))."', '".$u->checkData($stime)."', '".$u->checkData($etime)."',  '".$u->checkData($page_status)."', NOW(), NOW());";
			$result = db_query($query,$link);

			$newVersionID=db_insert_id($link);

			// oznaci aktualni verzi jako aktualni (pokud neukladam verzi)
			if($_POST["versionType"]==1) labelActualPageVersion($page_id, $newVersionID);
			
			// ulozi informaci o aktualizaci stranky
			$query = "UPDATE ".$cfg['db']['table'][content_pages]." SET mtime=NOW() WHERE id='".$page_id."';";
			$result = db_query($query,$link);

			header("Location: edit.php?page=".$page_id."&PHPSESSID=".session_id());
			exit();
		}
	
	include("../../include/head.php");
	
	// innovaeditor
	echo('<script language="JavaScript" src="'.UW_BASE_URL.'/editor/scripts/language/czech/editor_lang.js"></script>');
	echo('<script language="JavaScript" src="'.UW_BASE_URL.'/editor/scripts/innovaeditor.js"></script>');

	// domtab
	echo('<script language="JavaScript" type="text/javascript" src="../../scripts/domtab.js"></script>');
		
	
	echo('<script language="JavaScript" type="text/javascript" src="../../scripts/prototype.js"></script>');
	echo('<script language="JavaScript" type="text/javascript" src="../../scripts/scriptaculous.js"></script>');

	echo('<script language="JavaScript" type="text/javascript" src="content.js"></script>');	
	echo('<style type="text/css"> @import url("content.css"); </style>');

	echo('</head><body>');
	echo('<input type="hidden" name="sid" id="sid" value="'.session_id().'">');
	echo('<div id="aacInfoArea">&nbsp;</div>');

	include("../../include/menu.inc.php");
	
	/* bar */

	echo('<div id="titleBar">'.$u->getText('content_content').' &#155; '.$u->getText('content_sections_content').'</div>');
	echo('<div id="naviBar">');
		if($_SESSION["structure"]["lang"]>0 || $_SESSION[content][l][section]>0){
			if($_SESSION["structure"]["lang"]>0) $nodeFullPath=getFullNodePath($_SESSION["structure"]["lang"]);
			if($_SESSION[content][l][section]>0) $nodeFullPath=getFullNodePath($_SESSION[content][l][section]);

			if(is_array($nodeFullPath)){
				reset($nodeFullPath);
				while(list($key,$val)=each($nodeFullPath)){
					if($val[depth]==1){
						echo('<a href="content.php?useSection='.$val[id].'">');
							echo('<strong>'.$val[title].'</strong>'); 
						echo('</a>');
					}elseif($val[depth]==2){
						echo(' ('.$u->getText($GLOBALS['cfg']['languages_data'][$val[title]][title_code]).')');
					}else{
						echo(' &#155; <a href="content.php?useSection='.$val[id].'">'.$val[title].'</a>');
					}
				}
			}
		}else{
			echo('&nbsp;');
		}
	echo('</div>');

	echo('<div id="uwArea">');
		echo('<div id="uwPad">');

		/* content */

		// tlacitka
	echo $u->getButtonsStart();
		echo('<a href="content.php?useSection='.$_SESSION[content][l][section].'&setOff='.$_SESSION[content][l][off].'&setOrder='.$_SESSION[content][l][o].'&setDirection='.$_SESSION[content][l][d].'&setFilter='.$_SESSION[content][l][filter].'" class="button"><img src="'.UW_BASE_URL.'/images/icons/back.gif" border="0" alt="'.$u->getText('cancel').'" /> '.$u->getText('cancel').'</a> ');
		echo('&nbsp;');
		echo('<a href="#" onClick="submitWysivyg();" class="button"><img src="'.UW_BASE_URL.'/images/icons/save.gif" border="0" alt="" /> '.$u->getText('save').'</a>');
		echo('&nbsp;');
		echo('<a href="#" onmouseover="showLayer(true,0);" onmouseout="hideLayer(0);" id="butt_0" name="butt_0" class="button"><img src="'.UW_BASE_URL.'/images/icons/save.gif" border="0" alt="" /> '.$u->getText('saveAsVersion').'</a> ');
		echo('&nbsp;');
		echo('<a href="#" onmouseover="showLayer(true,1);" onmouseout="hideLayer(1);" id="butt_1" name="butt_1" class="button"><img src="'.UW_BASE_URL.'/images/icons/open.gif" border="0" alt="" /> '.$u->getText('loadTemplate').'</a> ');

	echo $u->getButtonsEnd();

		/* data */
		
		if($page>0 && $version<1){
			// ziska id zaznamu s aktualni verzi stranky
			$versionID=getActualPageVersion($page);
		}elseif($version>0){
			$versionID=$version;
		}

		// pokud mam verzi, nactu data
		if($versionID>0){
			$search[id]=$versionID;
			$pageData=getPageData($search);
			$page_version_id=$pageData[$versionID][id];
			$page=$pageData[$versionID][page_id];

			// doplni casy

			$tmpTimes=array("r","a","s","e");
			$tmpEnds=array("m","d","h","i","s");
			reset($tmpTimes);
			while(list($key,$val)=each($tmpTimes)){
				list(${$val."time_y"}, ${$val."time_m"}, ${$val."time_d"}, ${$val."time_h"}, ${$val."time_i"}, ${$val."time_s"}) = sscanf($pageData[$versionID][$val."time"], "%d-%d-%d %d:%d:%d");

				reset($tmpEnds);
				while(list($k,$v)=each($tmpEnds)){
					${$val."time_".$v}=sprintf("%02d",${$val."time_".$v});
				}
				${$val."time_y"}=sprintf("%04d",${$val."time_y"});
			}
		}

		// pokud mam nacist urcity template, nactu data
		if($useTemplate>0){		

			// zachova nazev stranky, status, index		
			$tmp_pre_title=$pageData[$versionID][title];
			$tmp_pre_status=$pageData[$versionID][status];
			$tmp_pre_uri=$pageData[$versionID][page_uri];

			// nacte data z sablony
			$search[id]=$useTemplate;
			$pageData=getPageData($search);
			
			// vlozi puvodni nazev do nazvu nactenych dat
			$versionID=$useTemplate;
			$pageData[$versionID][title]=$tmp_pre_title;
			$pageData[$versionID][status]=$tmp_pre_status;
			$pageData[$versionID][page_uri]=$tmp_pre_uri;
			
		}
		// /data

	// script

	?><script language="javascript" type="text/javascript">
	    <!--
			function submitWysivyg(){
				document.pageEditForm.onsubmit();
				sendForm('pageEditForm');
			}
	    // -->
	</script><?

	// form
	echo('<form name="pageEditForm" id="pageEditForm" method="post" action="edit.php?page='.$page.'">');
		echo('<input type="hidden" name="page_status" id="page_status" value="'.(intval($u->insertData($pageData[$versionID][status]))>0 ? $u->insertData($pageData[$versionID][status]) : 1).'">');
		echo('<input type="hidden" name="page_id" id="page_id" value="'.$page.'">');
		echo('<input type="hidden" name="page_version_id" id="page_version_id" value="'.$page_version_id.'">');

	echo('<br clear="all" />');

	// ulozeni verze stranky
	echo('<div class="absolute" id="list_0" onmouseout="hideLayer(0);" onmouseover="showLayer(true, 0);">');
		echo('<div class="slightBg">');
				echo('<table cellpadding="2" cellspacing="0" border="0">');
				echo('<tr>');
					echo('<td>'.$u->getText('content_version_title').'</td>');
					echo('<td><input type="hidden" name="versionType" id="versionType" value="1" /><input type="text" class="textInput" name="newVersionTitle" id="newVersionTitle" onfocus="changeClass(\'newVersionTitle\',\'textInputActive\');" onblur="changeClass(\'newVersionTitle\',\'textInput\');" /></td>');
					echo('<td><a href="#" onclick="setValue(\'versionType\',2); submitWysivyg();" class="buttonBorded"><img src="'.UW_BASE_URL.'/images/icons/save.gif" border="0" alt="" /> '.$u->getText('save').'</a>&nbsp;<a href="#" onclick="$(\'newVersionTitle\').value=\'\'; showLayer(false,\'0\');" class="buttonBorded"><img src="'.UW_BASE_URL.'/images/icons/cancel.gif" border="0" alt="" /> '.$u->getText('cancel').'</a></td>');
				echo('</tr>');
				echo('<tr>');
					echo('<td>&nbsp;</td>');
					echo('<td class="example">'.$u->getText('e_g').' '.$u->getText('content_eg_versionTitle').'</td>');
					echo('<td>&nbsp;</td>');
				echo('</tr>');
				echo('</table>');
		echo('</div>');
	echo('</div>');

	// naten ablony
	echo('<div class="absolute" id="list_1" onmouseout="hideLayer(1);" onmouseover="showLayer(true, 1);">');
		echo('<div class="slightBg">');
			// prehled sablon daneho webu/jazyka

				$search[id]="";
				$search[section]=$_SESSION[structure][lang];
				$search[q] = $_SESSION[content_templates][l][filter];
				$search[q] = str_replace($escape, $unescape, $search[q]);
				$search[order]=$_SESSION[content_templates][l][o];
				$search[how]=$_SESSION[content_templates][l][d];
				$search[off]=intval($_SESSION[content_templates][l][off]);
				$search[offset]=999999;
				$search[param]="normal";

			$templatesData=getTemplates($search);
				$search[param]="count";
			$templatesDataCount=getTemplates($search);
							
			if($templatesDataCount>0){
				echo("\n".'<table cellpadding="2" cellspacing="0" border="0" class="list">');
				reset($templatesData);
				while(list($key,$val)=each($templatesData)){
					echo("\n".'<tr>');
						echo("\n\t".'<td><strong>'.$pack_title.'</strong></td>');
						echo("\n\t".'<td>'.$templatesData[$key][title].'</td>');
						echo("\n\t".'<td><a href="?page='.$page.'&version='.$page_version_id.'&useTemplate='.$key.'" class="buttonBorded"><img src="'.UW_BASE_URL.'/images/icons/open.gif" border="0" alt="" /> '.$u->getText('load').'</a></td>');
					echo("\n".'</tr>');
				}
				echo("\n".'</table>');
			}
		echo('</div>');
	echo('</div>');

	// domtabs
	echo("\n".'<div class="domtab">');

	echo("\n".'<ul class="domtabs smalltabs" id="domtabber">');
		echo("\n".'<li><a href="#t1">'.$u->getText("content_page_edit_tab_meta").'</a></li>');
		echo("\n".'<li><a href="#t2">'.$u->getText("content_page_edit_tab_content").'</a></li>');
		echo("\n".'<li><a href="#t3">'.$u->getText("content_page_edit_tab_addons").'</a></li>');
	//	echo("\n".'<li><a href="#t4">'.$u->getText("content_page_edit_tab_comments").'</a></li>');
	//	echo("\n".'<li><a href="#t5">'.$u->getText("content_page_edit_tab_rating").'</a></li>');
		echo("\n".'<li><a href="#t6">'.$u->getText("content_page_edit_tab_versions").'</a></li>');
		echo("\n".'<li><a href="#t7">'.$u->getText("content_page_edit_tab_history").'</a></li>');
		echo("\n".'<li><a href="#t8">'.$u->getText("content_page_edit_tab_internal").'</a></li>');
	echo("\n".'</ul>');

	/* t1 */
	echo("\n".'<div class="div"><a name="t1" id="t1" class="tabAnchor">&nbsp;</a>');
		// vlastnosti

		echo('<table cellpadding="2" cellspacing="0" border="0" class="w100p">');
		echo('<tr>');
			echo('<td><strong>'.$u->getText('content_it_page_title').'</strong></td>');
			echo('<td>&nbsp;</td>');
			echo('<td class="w100p"><input type="text" name="page_title" id="page_title" class="input w70p high" value="'.$u->insertData($pageData[$versionID][title]).'"></td>');
			echo('<td class="w100p">&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td>'.$u->getText('content_it_page_perex').'</td>');
			echo('<td>&nbsp;</td>');
			echo('<td><textarea name="page_perex" id="page_perex" class="area w70p">'.$u->insertData($pageData[$versionID][perex]).'</textarea></td>');
			echo('<td>&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td colspan="4">&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td><strong>'.$u->getText('content_it_page_uri').'</strong></td>');
			echo('<td>&nbsp;</td>');
			echo('<td><input type="text" name="page_uri" id="page_uri" class="input w70p borded" value="'.$u->insertData($pageData[$versionID][page_uri]).'"></td>');
			echo('<td>&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td colspan="4">&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td nowrap>'.$u->getText('content_it_page_meta_title').'</td>');
			echo('<td>&nbsp;</td>');
			echo('<td><input type="text" name="page_meta_title" id="page_meta_title" class="input w70p" value="'.$u->insertData($pageData[$versionID][meta_title]).'"></td>');
			echo('<td>&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td nowrap>'.$u->getText('content_it_page_meta_description').'</td>');
			echo('<td>&nbsp;</td>');
			echo('<td><input type="text" name="page_meta_description" id="page_meta_description" class="input w70p" value="'.$u->insertData($pageData[$versionID][meta_description]).'"></td>');
			echo('<td>&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td nowrap>'.$u->getText('content_it_page_meta_keywords').'</td>');
			echo('<td>&nbsp;</td>');
			echo('<td><input type="text" name="page_meta_keywords" id="page_meta_keywords" class="input w70p" value="'.$u->insertData($pageData[$versionID][meta_keywords]).'"></td>');
			echo('<td>&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td colspan="4">&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			// datumy			
			echo('<td colspan="4">');
				echo('<table border="0" cellpadding="2" cellspacing="0" class="fleft">');
				echo('<tr>');
					echo('<td><strong>'.$u->getText('content_it_page_rtime').'</strong></td>');
					echo('<td>&nbsp;</td>');
					echo('<td><input type="text" maxlength="2" name="rtime_d" value="'.$rtime_d.'" class="input w2num">.<input type="text" maxlength="2" name="rtime_m" value="'.$rtime_m.'" class="input w2num">.<input type="text" maxlength="4" name="rtime_y" value="'.$rtime_y.'" class="input w4num">&nbsp; &nbsp;<input type="text" maxlength="2" name="rtime_h" value="'.$rtime_h.'" class="input w2num">:<input type="text" maxlength="2" name="rtime_i" value="'.$rtime_i.'" class="input w2num"></td>');
				echo('</tr>'); 
				echo('<tr>');
					echo('<td>'.$u->getText('content_it_page_atime').'</td>');
					echo('<td>&nbsp;</td>');
					echo('<td><input type="text" maxlength="2" name="atime_d" value="'.$atime_d.'" class="input w2num">.<input type="text" maxlength="2" name="atime_m" value="'.$atime_m.'" class="input w2num">.<input type="text" maxlength="4" name="atime_y" value="'.$atime_y.'" class="input w4num">&nbsp; &nbsp;<input type="text" maxlength="2" name="atime_h" value="'.$atime_h.'" class="input w2num">:<input type="text" maxlength="2" name="atime_i" value="'.$atime_i.'" class="input w2num"></td>');
				echo('</tr>');
				echo('</table>');

				echo('<table border="0" cellpadding="2" cellspacing="0" class="fleft">');
				echo('<tr>');
					echo('<td>'.$u->getText('content_it_page_stime').'</td>');
					echo('<td>&nbsp;</td>');
					echo('<td><input type="text" maxlength="2" name="stime_d" value="'.$stime_d.'" class="input w2num">.<input type="text" maxlength="2" name="stime_m" value="'.$stime_m.'" class="input w2num">.<input type="text" maxlength="4" name="stime_y" value="'.$stime_y.'" class="input w4num">&nbsp; &nbsp;<input type="text" maxlength="2" name="stime_h" value="'.$stime_h.'" class="input w2num">:<input type="text" maxlength="2" name="stime_i" value="'.$stime_i.'" class="input w2num"></td>');
				echo('</tr>');
				echo('<tr>');
					echo('<td>'.$u->getText('content_it_page_etime').'</td>');
					echo('<td>&nbsp;</td>');
					echo('<td><input type="text" maxlength="2" name="etime_d" value="'.$etime_d.'" class="input w2num">.<input type="text" maxlength="2" name="etime_m" value="'.$etime_m.'" class="input w2num">.<input type="text" maxlength="4" name="etime_y" value="'.$etime_y.'" class="input w4num">&nbsp; &nbsp;<input type="text" maxlength="2" name="etime_h" value="'.$etime_h.'" class="input w2num">:<input type="text" maxlength="2" name="etime_i" value="'.$etime_i.'" class="input w2num"></td>');
				echo('</tr>');
				echo('</table>');
			echo('</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td colspan="4">&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			// obrazky			
			echo('<td colspan="4">');
				echo('<table border="0" cellpadding="2" cellspacing="0" class="fleft">');
				echo('<tr valign="middle">');
					echo('<td nowrap>'.$u->getText('content_it_page_image_small').'</td>');
					echo('<td>&nbsp;</td>');
					echo('<td><div id="image_small_button">'.($u->insertData($pageData[$versionID][image_small])==0 ? '<a href="javascript: void(0);" onclick="initPageImageAdd(\'small\');" class="button nomarg"><img src="../../images/icons/add_pageimage.gif" width="14" height="14" border="0" alt="" /></a>' : '<a href="javascript: void(0);" onclick="showDarkbox(250,50,\'initPageImageDeletion(\\\'small\\\');\');" class="button nomarg"><img src="../../images/icons/delete.gif" width="14" height="14" border="0" alt="" /></a>').'</div></td>');
					echo('<td><div id="image_small_fake">&nbsp;</div></td>');
					echo('<td><input type="hidden" name="page_image_small" id="page_image_small" value="'.intval($u->insertData($pageData[$versionID][image_small])).'">&nbsp;</td>');
				echo('</tr>');
				echo('<tr valign="middle">');
					echo('<td nowrap>'.$u->getText('content_it_page_image_middle').'</td>');
					echo('<td>&nbsp;</td>');
					echo('<td><div id="image_middle_button">'.($u->insertData($pageData[$versionID][image_middle])==0 ? '<a href="javascript: void(0);" onclick="initPageImageAdd(\'middle\');" class="button nomarg"><img src="../../images/icons/add_pageimage.gif" width="14" height="14" border="0" alt="" /></a>' : '<a href="javascript: void(0);" onclick="showDarkbox(250,50, \'initPageImageDeletion(\\\'middle\\\');\');" class="button nomarg"><img src="../../images/icons/delete.gif" width="14" height="14" border="0" alt="" /></a>').'</div></td>');
					echo('<td><div id="image_middle_fake">&nbsp;</div></td>');
					echo('<td><input type="hidden" name="page_image_middle" id="page_image_middle" value="'.intval($u->insertData($pageData[$versionID][image_middle])).'">&nbsp;</td>');
				echo('</tr>');
				echo('<tr valign="middle">');
					echo('<td nowrap>'.$u->getText('content_it_page_image_big').'</td>');
					echo('<td>&nbsp;</td>');
					echo('<td><div id="image_big_button">'.($u->insertData($pageData[$versionID][image_big])==0 ? '<a href="javascript: void(0);" onclick="initPageImageAdd(\'big\');" class="button nomarg"><img src="../../images/icons/add_pageimage.gif" width="14" height="14" border="0" alt="" /></a>' : '<a href="javascript: void(0);" onclick="showDarkbox(250,50,\'initPageImageDeletion(\\\'big\\\');\');" class="button nomarg"><img src="../../images/icons/delete.gif" width="14" height="14" border="0" alt="" /></a>').'</div></td>');
					echo('<td><div id="image_big_fake">&nbsp;</div></td>');
					echo('<td><input type="hidden" name="page_image_big" id="page_image_big" value="'.intval($u->insertData($pageData[$versionID][image_big])).'">&nbsp;</td>');
				echo('</tr>');
				echo('</table>');
			echo('</td>');
		echo('</tr>');
		echo('</table>');

		echo('<script> fakePageImages(); </script>');

	echo('<br clear="all" />');
	echo('<br clear="all" />');
	echo("\n".'</div>');
	/* /t1 */

	/* t3 */
	echo("\n".'<div class="div"><a name="t3" id="t3" class="tabAnchor">&nbsp;</a>');
		// plohy
		echo('<center><br />');

		echo('<table cellpadding="2" cellspacing="0" border="0">');
		echo('<tr>');			
			echo('<td nowrap>');
				echo('<a href="#" onClick="openAddonLibrary(\'media\');" class="button"><img src="'.UW_BASE_URL.'/images/icons/add_addon.gif" border="0" alt="" /> '.$u->getText('content_page_addFileAddon').'</a>');
			echo('</td>');
			echo('<td nowrap>');
				echo('<a href="#" onClick="openAddonLibrary(\'image\');" class="button"><img src="'.UW_BASE_URL.'/images/icons/add_addon.gif" border="0" alt="" /> '.$u->getText('content_page_addImageAddon').'</a>');
			echo('</td>');
			echo('<td nowrap>');
				echo('<a href="#" onClick="openAddonLibrary(\'link\');" class="button"><img src="'.UW_BASE_URL.'/images/icons/add_addon.gif" border="0" alt="" /> '.$u->getText('content_page_addLinkAddon').'</a>');
			echo('</td>');
			echo('<td nowrap>');
				echo('<a href="#" onClick="listPageAddons('.$page.');" class="button"><img src="'.UW_BASE_URL.'/images/icons/change.gif" border="0" alt="" /> '.$u->getText('refresh').'</a>');
			echo('</td>');
		echo('</tr>');
		echo('</table>');
		
		echo('</center>');

		echo('<div id="pageAddonsList" class="list">&nbsp;</div>');
		echo('<script> listPageAddons('.$page.'); </script>');

	echo('<br clear="all" />');
	echo('<br clear="all" />');
	echo("\n".'</div>');
	/* /t3 */

	/* t4 
	echo("\n".'<div class="div"><a name="t4" id="t4" class="tabAnchor">&nbsp;</a></div>');
	/* /t4 

	/* t5 
	echo("\n".'<div class="div"><a name="t5" id="t5" class="tabAnchor">&nbsp;</a>');
		// hodnocen

	echo('<br clear="all" />');
	echo('<br clear="all" />');
	echo("\n".'</div>');
	 /t5 */

	/* t6 */
	echo("\n".'<div class="div"><a name="t6" id="t6" class="tabAnchor">&nbsp;</a>');
		// verze

		echo('<center><br /><a href="#" onClick="listPageVersions('.$page.');" class="button"><img src="'.UW_BASE_URL.'/images/icons/change.gif" border="0" alt="" /> '.$u->getText('refresh').'</a></center>');

		echo('<br />');
		echo('<div id="pageVersionsList" class="list">&nbsp;</div>');
		echo('<script> listPageVersions('.$page.'); </script>');

	echo("\n".'</div>');
	/* /t6 */

	/* t7 */
	echo("\n".'<div class="div"><a name="t7" id="t7" class="tabAnchor">&nbsp;</a>');
		// historie

		echo('<center><br /><a href="#" onClick="listPageHistory('.$page.');" class="button"><img src="'.UW_BASE_URL.'/images/icons/change.gif" border="0" alt="" /> '.$u->getText('refresh').'</a></center>');

		echo('<br />');
		echo('<div id="pageHistoryList" class="list">&nbsp;</div>');
		echo('<script> listPageHistory('.$page.'); </script>');

	echo('<br clear="all" />');
	echo('<br clear="all" />');
	echo("\n".'</div>');
	/* /t7 */

	/* t8 */
	echo("\n".'<div class="div"><a name="t8" id="t8" class="tabAnchor">&nbsp;</a>');
		// intern

		echo('<center><br />');

		echo('<table cellpadding="2" cellspacing="0" border="0" class="w70p">');
		echo('<tr>');
			echo('<td class="w100p"><textarea name="desk_text" id="desk_text" class="area w100p">&nbsp;</textarea></td>');
			echo('<td nowrap>');
				echo('<a href="#" onClick="savePageDeskNote('.$page.');" class="button"><img src="'.UW_BASE_URL.'/images/icons/save.gif" border="0" alt="" /> '.$u->getText('send').'</a>');
				echo('<br />');
				echo('<br />');
				echo('<a href="#" onClick="listPageDesk('.$page.');" class="button"><img src="'.UW_BASE_URL.'/images/icons/change.gif" border="0" alt="" /> '.$u->getText('refresh').'</a>');
			echo('</td>');
		echo('</tr>');
		echo('</table>');
		
		echo('</center>');

		echo('<br />');
		echo('<div id="pageDeskList" class="list">&nbsp;</div>');
		echo('<script> listPageDesk('.$page.'); </script>');		

	echo('<br clear="all" />');
	echo('<br clear="all" />');
	echo("\n".'</div>');
	/* /t8 */

	/* t2 */
	echo("\n".'<div class="div"><a name="t2" id="t2" class="tabAnchor">&nbsp;</a>');

	echo('<textarea name="txtContent" id="txtContent">'.$u->insertData($pageData[$versionID][text]).'</textarea>');

	?>

	<script>
		var oEdit1 = new InnovaEditor("oEdit1");

//		oEdit1.publishingPath="http://hawk/sherwood/uw2007/!uw2007/";
				
		oEdit1.width="95%";
		oEdit1.height=400;

		oEdit1.btnPrint=true;
		oEdit1.btnPasteText=true;
		oEdit1.btnFlash=true;
		oEdit1.btnMedia=true;
		oEdit1.btnLTR=true;
		oEdit1.btnRTL=true;
		oEdit1.btnStrikethrough=true;
		oEdit1.btnSuperscript=true;
		oEdit1.btnSubscript=true;
		oEdit1.btnClearAll=true;
		oEdit1.btnSave=true;
		oEdit1.btnStyles=true; 
		
		oEdit1.css="design.css";

		oEdit1.cmdAssetManager = "modalDialogShow('<? echo UW_BASE_URL; ?>/modules/library/library.php?PHPSESSID=<? echo session_id(); ?>',700,470)";
		
		oEdit1.arrCustomTag=[["First Name","{%first_name%}"],
				["Last Name","{%last_name%}"],
				["Email","{%email%}"]];

		oEdit1.customColors=["#ff4500","#ffa500","#808000","#4682b4","#1e90ff","#9400d3","#ff1493","#a9a9a9"];

		oEdit1.mode="XHTMLBody";
		oEdit1.REPLACE("txtContent");
	</script>
<?
	echo("\n".'</div>');
	/* /t2 */
	
	?>

	<input type="hidden" name="fcc_require" value="d_username,d_email">	
	<input type="hidden" name="action" value="save">

</form>
<?
	/* patka */
	include("../../include/foot.php");
?>