<?
session_start();

header("Content-Type: text/html; charset=UTF-8");

	include("../../include/local.inc.php");
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("files.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$activeModule="library";
	$u=new Underwood();

	/* kontrola jestli je uzivatel prihlaseny */
	if($u->verifyUserRight("0")==0){
		echo('AccessDenied');
		exit();
	}
	
	/* */

	$openFile=intval($_GET["file"]);

	if($u->verifyUserRight("library_files_file_insert,library_files_file_upload")==0 && $openFile==0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();
	}

	if($u->verifyUserRight("library_files_item_update")==0 && $openFile>0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();
	}

	/* ziska informace o souborech */
	if($openFile>0){
		$search[id]=$openFile;
		/* */
		$filesData=getFilesData($search);
	}

	/* pokud hledam soubory na disku */
	if($_GET[listFiles]==1){

		// vezme vsechny soubory v adresari
		$gf=new getDirContent();
		$all_files = $gf->open(UW_LIBRARY_FILES_DIR);

		// vezme ulozene soubory
			$search="";
			$search[unlimited]=true;
		$filesData=getFilesData($search);

		$old_files = "";

		if(is_array($filesData)){

			reset($filesData);
			while(list($key,$val)=each($filesData)){
				$old_files[]=$val[filename];
			}
			$new_files=array_diff($all_files,$old_files);
		}		
		
		if($old_files) $new_files=array_diff($all_files,$old_files);
		
		if(count($new_files)==0) $new_files="";

		// pokud nejsou dn nov soubory na disku
		if(!is_array($new_files)){
			echo $u->simpleMessage('info',$u->getText('library_files_msg_newFilesNotFound'));
			echo('<a href="#" onClick="getOffset(); list();" class="button"><img src="'.UW_BASE_URL.'/images/icons/cancel.gif" border="0" alt="" /> '.$u->getText('cancel').'</a>');
			exit();
		}
	}

/* form */

	echo('<form enctype="multipart/form-data" name="filesEditForm" id="filesEditForm" method="post" action="aac_files_save.php" target="uploadIframe">');

	echo('<table cellpadding="8" cellspacing="0" border="0" class="tableEdit">');
	echo('<tr><td><h4 class="title">'.($openFile>0 ? $filesData[$openFile][title].'&nbsp;&nbsp;&nbsp;<span>|</span>&nbsp;&nbsp;&nbsp;<strong>'.$filesData[$openFile][filename].'</strong>' : $u->getText("library_files_newFile")).'</h4></td></tr>');
		echo('<tr>');
			echo('<td>');  

	echo('<table cellpadding="2" cellspacing="0" border="0">');
		echo('<tr>');
			echo('<td><strong>'.$u->getText('library_files_it_title').'</strong></td>');
			echo('<td>&nbsp;</td>');
			echo('<td><input type="text" name="file_title" id="file_title" class="input long high" value="'.$u->insertData($filesData[$openFile][title]).'"></td>');
			echo('<td>&nbsp;</td>');
			echo('<td class="example">'.$u->getText('e_g').' '.$u->getText('library_files_eg_itemTitle').'</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td colspan="5">&nbsp;</td>');
		echo('</tr>');

		if($openFile>0){
			echo('<tr>');
				echo('<td><strong>'.$u->getText('library_files_it_filename').'</strong></td>');
				echo('<td>&nbsp;</td>');
				echo('<td><strong>'.$u->insertData($filesData[$openFile][filename]).'</strong></td>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
			echo('</tr>');
			echo('<tr>');
				echo('<td><strong>'.$u->getText('library_files_it_renameOldfile').'</strong></td>');
				echo('<td>&nbsp;</td>');
				echo('<td><input type="hidden" value="'.$u->insertData($filesData[$openFile][filename]).'" name="OldFilename" id="OldFilename"><input type="text" class="input long" name="newFilename" id="newFilename"></td>');
				echo('<td>&nbsp;</td>');
				echo('<td class="example"><strong class="high">'.$u->getText('tip').'</strong>: '.$u->getText('library_files_tip_useOnlySimpleChars').'</td>');
			echo('</tr>');
			echo('<tr>');
				echo('<td><strong>'.$u->getText('library_files_it_newFilename').'</strong></td>');
				echo('<td>&nbsp;</td>');
				echo('<td><input type="file" name="updateFile" id="updateFile"></td>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
			echo('</tr>');

			if($filesData[$openFile]["filetype"] == "flv"){

				echo('<tr>');
					echo('<td>&nbsp;</td>');
					echo('<td>&nbsp;</td>');
					echo('<td>&nbsp;</td>');
					echo('<td>&nbsp;</td>');
					echo('<td>&nbsp;</td>');
				echo('</tr>');
				echo('<tr>');
					echo('<td>&nbsp;</td>');
					echo('<td>&nbsp;</td>');
					echo('<td><a href="#" onclick="openFLVCapture('.$openFile.')" class="buttonBorded">&nbsp;'.$u->getText('library_files_captureScreen').'</a></td>');
					echo('<td>&nbsp;</td>');
					echo('<td>&nbsp;</td>');
				echo('</tr>');
			}
			
		}elseif($_GET[listFiles]==1){
			echo('<tr>');
				echo('<td><strong>'.$u->getText('library_files_it_filename').'</strong></td>');
				echo('<td>&nbsp;</td>');

					// pokud jsou nejaky jine nez ty uz ulozene vypise select, jinak info
					if(is_array($new_files)){
						echo('<td><select name="assFile" id="assFile">');
							reset($new_files);
							while(list($key,$val)=each($new_files)){
								echo('<option value="'.$val.'">'.$val.'</option>');
							}
						echo('</select></td>');
					}else{
						$hide_save_button=1;
						echo('<td>'.$u->simpleMessage('info', $u->getText('library_files_msg_newFilesNotFound')).'</td>');
					}				
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
			echo('</tr>');
		}else{
			echo('<tr>');
				echo('<td><strong>'.$u->getText('library_files_it_filename').'</strong></td>');
				echo('<td>&nbsp;</td>');
				echo('<td><input type="file" name="newFile" id="newFile"></td>');
				echo('<td>&nbsp;</td>');
				echo('<td>&nbsp;</td>');
			echo('</tr>');
		}

		echo('<tr>');
			echo('<td colspan="5">&nbsp;</td>');
		echo('</tr>');
		echo('<tr valign="top">');
			echo('<td>'.$u->getText('library_files_it_about').'</td>');
			echo('<td>&nbsp;</td>');
			echo('<td><textarea name="file_note" id="file_note" class="area w100p">'.$u->insertData($filesData[$openFile][note]).'</textarea></td>');
			echo('<td>&nbsp;</td>');
			echo('<td>&nbsp;</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td><strong>'.$u->getText('library_files_it_keywords').'</strong></td>');
			echo('<td>&nbsp;</td>');
			echo('<td><input type="text" name="file_keywords" id="file_keywords" class="input long" value="'.$u->insertData($filesData[$openFile][keywords]).'"></td>');
			echo('<td>&nbsp;</td>');
			echo('<td class="example">'.$u->getText('e_g').' '.$u->getText('library_files_eg_itemKeywords').'</td>');
		echo('</tr>');
		echo('<tr>');
			echo('<td colspan="5">&nbsp;</td>');
		echo('</tr>');
	echo('</table>');

	echo('<tr>');
		echo('<td>');
		if($hide_save_button==0) echo('<a href="#" onClick="sendForm(\'filesEditForm\');" class="button"><img src="'.UW_BASE_URL.'/images/icons/save.gif" border="0" alt="" /> '.$u->getText('save').'</a>');
		echo('<a href="#" onClick="getOffset(); list();" class="button"><img src="'.UW_BASE_URL.'/images/icons/cancel.gif" border="0" alt="" /> '.$u->getText('cancel').'</a><a href="#" onClick="'.($listFiles==1 ? 'openUploadedFile' : 'openFile').'('.$openFile.');" class="button"><img src="'.UW_BASE_URL.'/images/icons/change.gif" border="0" alt="" /> '.$u->getText('refresh').'</a></td>');
	echo('</tr>');

	echo('<tr><td>&nbsp;</td></tr>');

    echo('</table>');
  
	echo('<input type="hidden" name="fcc_require" value="d_username,d_email">');
	echo('<input type="hidden" name="fcc_email" value="d_email">');
	echo('<input type="hidden" name="fcc_same" value="d_pass,d_pass2">');
	echo('<input type="hidden" name="action" value="save">');
	echo('<input type="hidden" name="file_id" id="file_id" value="'.$openFile.'">');
	echo('<input type="hidden" name="file_action" id="file_action" value="">');

	echo('</form>');

?>