<?
session_start();

header("Content-Type: text/html; charset=UTF-8");

	include("../../include/local.inc.php");		
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("images.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$activeModule="library";	
	$u=new Underwood();	

	/* */

	if($u->verifyUserRight("library_images_image_insert_multiple_uploaded")==0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}

/* form */

	// projde obrazky ktere uzivatel oznacil a nahazi je do pole selected_images
	if(is_array($_POST[thumb_inp])){
		reset($_POST[thumb_inp]);
		while(list($key,$val)=each($_POST[thumb_inp])){
			if($val!="") $selected_images[]=$key;
		}
		if(count($selected_images)<1){
			// pokud uzivatel nevybral zadne obrazky, upozornim ho a zobrazim opet nahledy pro vyber
			echo("library_images_msg_haveToSelectOneImage");
			exit();
		}
	}
	
	// vezme ulozene soubory
		$search="";
		$search[unlimited]=true;
	$imagesData=getImagesData($search);

	$old_images = "";
	if(is_array($imagesData)){

		reset($imagesData);
		while(list($key,$val)=each($imagesData)){
			$old_images[]=$val[filename];
		}
		$new_images=array_diff($selected_images,$old_images);
	}else{
		$new_images=$selected_images;
	}

	if(count($new_images)==0) $new_images="";

	// pokud jsou nejaky jine nez ty uz ulozene vypise select, jinak info
	if(is_array($new_images)){
		reset($new_images);
		while(list($key,$val)=each($new_images)){
			$filenameData = $u->getFilenameParts($val);
			$extension=$filenameData[ext];
			if(in_array($extension,$cfg[library_image_allowed_types])==false) unset($new_images[$key]);
		}
	}

echo('<form name="imagesMultipleForm" id="imagesMultipleForm">');

	if(is_array($new_images) && count($new_images)){
		// utvori nahledy
		@mkdir(UW_LIBRARY_IMAGES_THUMBS_DIR,"0777");
		reset($new_images);
		while(list($key,$val)=each($new_images)){
			createThumb(UW_LIBRARY_IMAGES_DIR."/".$val, UW_LIBRARY_IMAGES_THUMBS_DIR."/".$val, 133,100);
		}	

		echo('<div id="thumbs_area">');

		echo('<table cellpadding="2" cellspacing="0" border="0" align="center">');
			
		// zobrazi nahledy
		reset($new_images);
		while(list($key,$val)=each($new_images)){

			$filesize=round((filesize(UW_LIBRARY_IMAGES_DIR."/".$val)/1000));
			list($filewidth,$fileheight) = @getimagesize(UW_LIBRARY_IMAGES_DIR."/".$val);
			$fileformat=($filewidth/$fileheight);

			echo('<tr>');
				echo('<td>');				
					echo('<div class="thumb" id="thumb_div['.$val.']">');
						echo('<div class="thumb_title">&nbsp;</div> ');
						echo('<div class="thumb_img" style="background: white  url(\''.UW_LIBRARY_IMAGES_THUMBS_URL."/".$val.'\') center no-repeat;">&nbsp;</div>');		
						echo('<div class="thumb_file">'.$u->stripString($val,27).'</div> ');
						echo('<div class="thumb_info">'.$filewidth.'x'.$fileheight. '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'. $u->printSmartFilesize($filesize).'</div>');
					echo('</div> ');
					echo('<input type="hidden" name="thumb_inp['.$val.']" id="thumb_inp['.$val.']" value="1">');
				echo('</td>');

				echo('<td>&nbsp;</td>');

				echo('<td>');
					echo('<table cellpadding="2" cellspacing="0" border="0">');
						echo('<tr>');
							echo('<td><strong>'.$u->getText('library_images_it_title').'</strong></td>');
							echo('<td>&nbsp;</td>');
							echo('<td><input type="text" name="image_title['.$val.']" id="image_title['.$val.']" class="input long high" value="'.$val.'"></td>');
							echo('<td>&nbsp;</td>');
							echo('<td class="example">'.$u->getText('e_g').' '.$u->getText('library_images_eg_itemTitle').'</td>');
						echo('</tr>');
						echo('<tr>');
							echo('<td colspan="5">&nbsp;</td>');
						echo('</tr>');
						echo('<tr valign="top">');
							echo('<td>'.$u->getText('library_images_it_about').'</td>');
							echo('<td>&nbsp;</td>');
							echo('<td><textarea name="image_note['.$val.']" id="image_note['.$val.']" class="area w100p">'.$u->insertData($imagesData[$openImage][note]).'</textarea></td>');
							echo('<td>&nbsp;</td>');
							echo('<td>&nbsp;</td>');
						echo('</tr>');		
						echo('<tr>');
							echo('<td><strong>'.$u->getText('library_images_it_keywords').'</strong></td>');
							echo('<td>&nbsp;</td>');
							echo('<td><input type="text" name="image_keywords['.$val.']" id="image_keywords['.$val.']" class="input long" value="'.$u->insertData($imagesData[$openImage][keywords]).'"></td>');
							echo('<td>&nbsp;</td>');
							echo('<td class="example">'.$u->getText('e_g').' '.$u->getText('library_images_eg_itemKeywords').'</td>');
						echo('</tr>');
						echo('<tr>');
							echo('<td colspan="5">&nbsp;</td>');
						echo('</tr>');
					echo('</table>');	
					
				echo('</td>');

			echo('</tr>');
		}

		echo('</table>');

		echo('</div> ');

	}else{
		$hide_save_button=1;
		echo $u->simpleMessage('error',$u->getText('library_images_msg_newImagesNotFound'));
	}

	echo('<br clear="all" />');

echo('<table cellpadding="4" cellspacing="0" border="0" align="center">');
	echo('<tr>');
		echo('<td>');
		if($hide_save_button==0) echo('<a href="#" onClick="saveMultipleForm();" class="button"><img src="'.UW_BASE_URL.'/images/icons/save.gif" border="0" alt="" /> '.$u->getText('save').'</a>');
		echo('<a href="#" onClick="getOffset(); list();" class="button"><img src="'.UW_BASE_URL.'/images/icons/cancel.gif" border="0" alt="" /> '.$u->getText('cancel').'</a><a href="#" onClick="showMultipleForm();" class="button"><img src="'.UW_BASE_URL.'/images/icons/change.gif" border="0" alt="" /> '.$u->getText('refresh').'</a></td>');
	echo('</tr>');
  echo('</table>');
  
	echo('<input type="hidden" name="action" value="save">');

echo('</form>');

?>