	/* files */

var http = createRequestObject();
var isHttpBusy=false;

function getOffset(){
	var listHeight=winHeight();
	if(window.innerHeight) listHeight=window.innerHeight;

	var listHeight=listHeight-200;

	var offsetValue=Math.round(listHeight/21)-2;
	$('offset').value=offsetValue;
}

function list(){
	a=$("listAction").value;
	eval(a);
}
function setOrder(o){
	if($("o").value==o){
		$("d").value=($("d").value=="ASC" ? "DESC" : "ASC");
	}else{
		$("o").value=o;
	}
	list();
}
function listFrom(n){
	$("off").value=n;
	list();
}

function setFilter(){
	$("off").value=0;
	$("filter").value=$("fakeFilter").value;
	setTypesFilter();
	list();
}

function clearFilter(){
	$("off").value=0;
	$("filter").value="";
	$("fakeFilter").value="";
	clearTypesFilter();
	list();
}

function setTypesFilter(){
	fts=getElementsByClass('fakeTypeFilter');
	var ftsLen = fts.length;
	for (i=0; i<ftsLen; i++){
		idd=fts[i].id;
		t_i=idd.split("_");
		t=t_i[1];
		if($("filter_type_"+t)) $("filter_type_"+t).value=(fts[i].checked==true ? 0 : 1);
	}
}

function clearTypesFilter(){
	fts=getElementsByClass('fakeTypeFilter');
	var ftsLen = fts.length;
	for (i=0; i<ftsLen; i++){
		idd=fts[i].id;
		fts[i].checked=true;
		t_i=idd.split("_");
		t=t_i[1];
		if($("filter_type_"+t)) $("filter_type_"+t).value=0;
	}
}

function goToPage(n){
	pc=$("pageCount").value;

	// nejde o cislo
	if(isInteger(n)==false){
		
		$("goToPageNum").value="";

	}else{
		n=Math.ceil(n);
		if(n<1) n=1;
		if((pc-n)<1) n=pc;
		tmp_o=$("offSetFor["+n+"]").value;

		listFrom(tmp_o);
	}
}

/* set session */

function setListSession(module,code){
	var postData = "module="+module;
	els=getElementsByClass('l');
	var elsLen = els.length;
	for (i=0; i<elsLen; i++){ postData+='&' + els[i].id + "=" + els[i].value; }

	if(isHttpBusy){
		http.onreadystatechange = function () {}
		http.abort();
	}
	http.open('post', 'aac_session_list_save.php?PHPSESSID=' + $("sid").value + '&code=' + code, true);
	http.onreadystatechange = handleSetListSession;
	http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	http.setRequestHeader("Content-length", postData.length);
	http.setRequestHeader("Connection", "close");
	isHttpBusy = true;
	http.send(postData);
}

function handleSetListSession(){
	isHttpBusy = false;
	if(http.readyState == 1) void(0);
	if(http.readyState == 2) void(0);
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response!="error") eval(response);
		}
	}
}

/* save session */

function saveSession(spe,key,value,code){
	if(isHttpBusy){
		http.onreadystatechange = function () {}
		http.abort();
	}
	http = createRequestObject();
	http.open('get', 'aac_session_save.php?variant=' + spe + '&key=' + key + '&value=' + value + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = handleSessionSave;
	isHttpBusy = true;
	http.send(null);
	if(code) setTimeout("eval("+code+");",100);
}

function handleSessionSave(){
	isHttpBusy = false;
	return true;
}

/* list files */

function readCategoryFiles(node){
	if($('category')) $('category').value=node;
	renderNaviPath(node);
	list();
}

function renderNaviPath(node){
	var currentDate = new Date();
	if($('category')) node = $('category').value;

	httpNavi = createRequestObject();
	httpNavi.open('get', 'aac_files_navi_path.php?node=' + node + '&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	httpNavi.onreadystatechange = handleRenderNaviPath;
	httpNavi.send(null);
}

function handleRenderNaviPath(){
	var aia=$('aacInfoArea');

	if(httpNavi.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(httpNavi.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(httpNavi.readyState == 4){
		if(httpNavi.status == 200){
			var responseNavi = httpNavi.responseText;
			if(responseNavi=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('naviBar').innerHTML=responseNavi;
				setTimeout("clearAacInfo('aacInfoArea');",1500);
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;loading&nbsp;navi&nbsp;path!';
		}
	}
}

function listFiles(){
	var currentDate = new Date();
	http = createRequestObject();
	http.open('get', 'aac_files_list.php?PHPSESSID=' + $("sid").value + ($("lister") ? "&lister=1" : "") + ($("addonuse") ? "&addonuse=1" : "") + '&time='+currentDate.valueOf());
	http.onreadystatechange = handleListFiles;
	http.send(null);
}

function handleListFiles(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('filesListArea').innerHTML=response;
				setTimeout("clearAacInfo('aacInfoArea');",1500);
				if($('mPage')) renderSlider();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error';
		}
	}
}

function openFile(file){
	var currentDate = new Date();
	http.open('get', 'aac_files_open.php?file=' + file + '&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	http.onreadystatechange = handleOpenFile;
	http.send(null);
}

function handleOpenFile(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('filesListArea').innerHTML=response;
				setTimeout("clearAacInfo('aacInfoArea');",1500);
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;loading&nbsp;file!';
		}
	}
}

function openUploadedFile(){
	var currentDate = new Date();
	http.open('get', 'aac_files_open.php?file=0&listFiles=1&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	http.onreadystatechange = handleOpenUploadedFile;
	http.send(null);
}

function handleOpenUploadedFile(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('filesListArea').innerHTML=response;
				setTimeout("clearAacInfo('aacInfoArea');",1500);
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;loading&nbsp;file!';
		}
	}
}

function openFileCategory(file){
	var currentDate = new Date();
	http.open('get', 'aac_files_category.php?file=' + file + '&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	http.onreadystatechange = handleOpenFileCategory;
	http.send(null);
}

function handleOpenFileCategory(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('filesListArea').innerHTML=response;
				setTimeout("clearAacInfo('aacInfoArea');",1500);
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;loading&nbsp;file&nbsp;category!';
		}
	}
}

function fileSaveAnswer(response){
	var aia=$('aacInfoArea');

	if(response=="error"){
		aia.className = "infoError";
		aia.innerHTML = 'Error';
		
	}else if(response=="library_files_msg_fileAlreadyExists"){

		// zobrazi hlasku o tom ze soubor jiz existuje
		if($("ajax_message")){
			$("ajax_message").className="mess_error";
			$("ajax_message").innerHTML=getText("library_files_msg_fileAlreadyExists");
		}else{
			var a=$("filesListArea");
			var e = document.createElement("div");
			e.setAttribute("id","ajax_message");
			e.setAttribute("class","mess_error");
			e.className="mess_error";
			e.innerHTML=getText("library_files_msg_fileAlreadyExists");
			a.insertBefore(e, $("filesEditForm"));
		}

		// zobrazi volbu, za prepsat, nebo prejmenovat
		$("file_action").value="";

		if(!$("tmp_question")){

			me=$("filesListArea");
			var e = document.createElement("div");
			e.setAttribute("id","tmp_question");
			e.setAttribute("class","tree_question_area");
			e.innerHTML = "";
			e.innerHTML+=getText('library_files_whatYouWantToDo')+"&nbsp;&nbsp;&nbsp;";
			e.innerHTML+= '<a href="#" onclick="$(\'file_action\').value=\'rewrite\'; sendForm(\'filesEditForm\');"><strong>'+getText('library_files_doRewriteOldFile')+'</strong></a>';
			e.innerHTML+= '&nbsp;&nbsp;';
			e.innerHTML+= '<a href="#" onclick="$(\'file_action\').value=\'rename\'; sendForm(\'filesEditForm\');"><strong>'+getText('library_files_doRenameNewFile')+'</strong></a>';
			e.innerHTML+= '<br />';
			e.innerHTML+= '<br />';
			ae=$("ajax_message");
			insertAfter(me,e,ae);
		}
		
	}else if(response=="library_files_msg_mustFillTitle"){
		
		if($("ajax_message")){
			$("ajax_message").className="mess_error";
			$("ajax_message").innerHTML=getText("library_files_msg_mustFillTitle");
		}else{
			var a=$("filesListArea");
			var e = document.createElement("div");
			e.setAttribute("id","ajax_message");
			e.setAttribute("class","mess_error");
			e.className="mess_error";
			e.innerHTML=getText("library_files_msg_mustFillTitle");
			a.insertBefore(e, $("filesEditForm"));
		}

	}else if(response=="library_files_msg_thisFilenameAlreadyExists"){
		
		if($("ajax_message")){
			$("ajax_message").className="mess_error";
			$("ajax_message").innerHTML=getText("library_files_msg_thisFilenameAlreadyExists");
		}else{
			var a=$("filesListArea");
			var e = document.createElement("div");
			e.setAttribute("id","ajax_message");
			e.setAttribute("class","mess_error");
			e.className="mess_error";
			e.innerHTML=getText("library_files_msg_thisFilenameAlreadyExists");
			a.insertBefore(e, $("filesEditForm"));
		}
		
	}else if(response=="inserted" || response=="updated"){
		aia.className = "infoSuccess";
		aia.innerHTML = 'Saved';
		
		if($("ajax_message")){
			$("ajax_message").className="mess_ok";
			$("ajax_message").innerHTML=getText("library_files_msg_DataWasSaved");
		}else{
			var a=$("filesListArea");
			var e = document.createElement("div");
			e.setAttribute("id","ajax_message");
			e.setAttribute("class","mess_ok");
			e.className="mess_ok";
			e.innerHTML=getText("library_files_msg_DataWasSaved");
			a.insertBefore(e, $("filesEditForm"));
		}
		
		getOffset();
		list();
					
		setTimeout("clearAacInfo('aacInfoArea');",1500);
	}else{
		alert(reponse);
	}
}


function setFileStatus(item,status){
	http = createRequestObject();
	http.open('get', 'aac_files_status_update.php?item=' + item + '&status=' + status + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = handleSetFileStatus;
	http.send(null);
}

function handleSetFileStatus(){
	var aia=document.getElementById('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Updating...';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Updated';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'OK';
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				list();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error';
		}
	}
}

function deleteFile(item){
	http = createRequestObject();
	http.open('get', 'aac_files_delete.php?item=' + item + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = handleDeleteFile;
	http.send(null);
}

function handleDeleteFile(){
	var aia=document.getElementById('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Deleting...';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Deleted';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';

			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'OK';
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				list();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error';
		}
	}
}

function getFilesCategoryTree(){
	var currentDate = new Date();
	var active = $('category').value;

	httpFilesCategoryTree = createRequestObject();
	httpFilesCategoryTree.open('get', 'aac_files_files_category_tree.php?active=' + active + '&PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	httpFilesCategoryTree.onreadystatechange = handleGetFilesCategoryTree;
	httpFilesCategoryTree.send(null);
}

function handleGetFilesCategoryTree(){
	var aia=$('aacInfoArea');

	if(httpFilesCategoryTree.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(httpFilesCategoryTree.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(httpFilesCategoryTree.readyState == 4){
		if(httpFilesCategoryTree.status == 200){
			var responseFilesCategoryTree = httpFilesCategoryTree.responseText;
			if(responseFilesCategoryTree=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('filesTreeArea').innerHTML=responseFilesCategoryTree;
				setTimeout("clearAacInfo('aacInfoArea');",1500);
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;loading&nbsp;files&nbsp;tree!';
		}
	}
}

function getCategoryTree(){
	var currentDate = new Date();

	httpCategoryTree = createRequestObject();
	httpCategoryTree.open('get', 'aac_files_category_tree.php?PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf());
	httpCategoryTree.onreadystatechange = handleGetCategoryTree;
	httpCategoryTree.send(null);
}

function handleGetCategoryTree(){
	var aia=$('aacInfoArea');

	if(httpCategoryTree.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading';
	}
	if(httpCategoryTree.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Loading...';
	}
	if(httpCategoryTree.readyState == 4){
		if(httpCategoryTree.status == 200){
			var responseCategoryTree = httpCategoryTree.responseText;
			if(responseCategoryTree=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Loaded';
				$('categoryTreeArea').innerHTML=responseCategoryTree;
				setTimeout("clearAacInfo('aacInfoArea');",1500);
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;loading&nbsp;category&nbsp;tree!';
		}
	}
}

	/* files category functions */

var tmpOpenedFilesNodeEditQuestion = "";

function initFilesNodeEditQuestion(eid){
	if(tmpOpenedFilesNodeEditQuestion!="") cancelFilesNodeEditQuestion(tmpOpenedFilesNodeEditQuestion);
	tmpOpenedFilesNodeEditQuestion=eid;

	if(eid!=1) $("tree_li["+eid+"]").className="tree_node_open";
	$("tree_title["+eid+"]").className="bold";
	
	// pripravim se menicko
	tmpData="";
	tmpData+= getText('library_files_whatYouWantToDo');
	tmpData+= '<br />';
	tmpData+= '<a href="javascript: initFilesNodeEdit('+eid+');">'+getText('library_files_editTitle')+'</a>';
	tmpData+= ',&nbsp;';
	tmpData+= '<a href="javascript: initFilesNodeAdd('+eid+');">'+getText('library_files_addSubNode')+'</a>';
	tmpData+= ',&nbsp;';
	if(eid!=1){
		tmpData+= '<a href="javascript: initFilesNodeDelete('+eid+');">'+getText('library_files_deleteNode')+'</a>';
		tmpData+= ',&nbsp;';
	}
	tmpData+= '<a href="javascript: cancelFilesNodeEditQuestion('+eid+');">'+getText('nothing')+'</a>.';

	li=$("tree_li["+eid+"]");
	var e = document.createElement("div");
	e.setAttribute("id","tree_inner_div["+eid+"]");
	e.setAttribute("class","tree_question_area");
	e.innerHTML=tmpData;
	ae=li.firstChild;
	insertAfter(li,e,ae);
}

function cancelFilesNodeEditQuestion(){
	eid=tmpOpenedFilesNodeEditQuestion;
	if($("tree_li["+eid+"]")){
		li=$("tree_li["+eid+"]");
		re=$("tree_inner_div["+eid+"]"); 
		if(re) throwawayNode = li.removeChild(re);
		if(eid!=1) $("tree_li["+eid+"]").className="tree_node_norm";
		$("tree_title["+eid+"]").className="";
	}
	tmpOpenedFilesNodeEditQuestion="";
}

function initFilesNodeAdd(eid){
	$('tree_inner_div['+eid+']').innerHTML = '';
	$('tree_inner_div['+eid+']').innerHTML = '<input class="bigTextEdit w100" id="newTitle" name="newTitle" type="text" />';
	$('tree_inner_div['+eid+']').innerHTML+= '&nbsp;&nbsp;';
	$('tree_inner_div['+eid+']').innerHTML+= '<a href="javascript: addFilesNodeTitle('+eid+');"><strong>'+getText('add')+'</strong></a>';
	$('tree_inner_div['+eid+']').innerHTML+= '&nbsp;&nbsp;';
	$('tree_inner_div['+eid+']').innerHTML+= '<a href="javascript: cancelFilesNodeEditQuestion('+eid+');">'+getText('cancel')+'</a>';
	$('newTitle').focus();
}


function initFilesNodeDelete(eid){
	$('tree_inner_div['+eid+']').innerHTML = '';
	$('tree_inner_div['+eid+']').innerHTML+= getText('library_files_reallyDeleteThisNode');
	$('tree_inner_div['+eid+']').innerHTML+= '<br />';
	$('tree_inner_div['+eid+']').innerHTML+= '<a href="javascript: filesNodeDelete('+eid+');"><strong>'+getText('delete')+'</strong></a>';
	$('tree_inner_div['+eid+']').innerHTML+= '&nbsp;&nbsp;';
	$('tree_inner_div['+eid+']').innerHTML+= '<a href="javascript: cancelFilesNodeEditQuestion('+eid+');">'+getText('cancel')+'</a>';
}

function initFilesNodeEdit(eid){
	$('tree_inner_div['+eid+']').innerHTML = '';
	$('tree_inner_div['+eid+']').innerHTML = '<input class="bigTextEdit w100" id="editTitle" name="editTitle" type="text" />';
	$('tree_inner_div['+eid+']').innerHTML+= '&nbsp;&nbsp;';
	$('tree_inner_div['+eid+']').innerHTML+= '<a href="javascript: saveFilesNodeTitle('+eid+');"><strong>'+getText('save')+'</strong></a>';
	$('tree_inner_div['+eid+']').innerHTML+= '&nbsp;&nbsp;';
	$('tree_inner_div['+eid+']').innerHTML+= '<a href="javascript: cancelFilesNodeEditQuestion('+eid+');">'+getText('cancel')+'</a>';

	$('editTitle').value=$('tree_title['+eid+']').innerHTML;
	$('editTitle').focus();
}

function initFilesItemDeletion(file_id){
	$('darkboxDetails').innerHTML = '';
	$('darkboxDetails').innerHTML+= getText('library_files_reallyDeleteThisItem');
	$('darkboxDetails').innerHTML+= '<br /><br />';
	$('darkboxDetails').innerHTML+= '<a href="javascript: deleteFile('+file_id+'); hideDarkbox();"><strong>'+getText('delete')+'</strong></a>';
	$('darkboxDetails').innerHTML+= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
	$('darkboxDetails').innerHTML+= '<a href="javascript: hideDarkbox();">'+getText('cancel')+'</a>';
}

function saveFilesNodeTitle(eid){
	var postData='node=' + eid + '&title=' + $("editTitle").value;

	http.open('post', 'aac_files_node_title_update.php?PHPSESSID=' + $("sid").value, true);
	http.onreadystatechange = handleSaveFilesNodeTitle;
	http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	http.setRequestHeader("Content-length", postData.length);
	http.setRequestHeader("Connection", "close");
	http.send(postData);
}

function handleSaveFilesNodeTitle(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		// aia.className = "infoUnknown";
		// aia.innerHTML = 'Saving';
	}
	if(http.readyState == 2){
		// aia.className = "infoUnknown";
		// aia.innerHTML = 'Saving...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;

			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				// aia.className = "infoError";
				// aia.innerHTML = 'Error';
			}else{
				// aia.className = "infoSuccess";
				// aia.innerHTML = 'Saved';
				$('tree_title['+response+']').innerHTML=$('editTitle').value;
				cancelFilesNodeEditQuestion(response);
				getCategoryTree(); 
				getFilesCategoryTree();
				renderNaviPath();
				// setTimeout("clearAacInfo('aacInfoArea');",1500);
			}
		}else{
			// aia.className = "infoError";
			// aia.innerHTML = 'Error';
		}
	}
}


function addFilesNodeTitle(eid){
	var postData='node=' + eid + '&title=' + $("newTitle").value;

	http.open('post', 'aac_files_node_add.php?PHPSESSID=' + $("sid").value, true);
	http.onreadystatechange = handleAddFilesNodeTitle;
	http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	http.setRequestHeader("Content-length", postData.length);
	http.setRequestHeader("Connection", "close");
	http.send(postData);
}

function handleAddFilesNodeTitle(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Saving';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Saving...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Saved';
				getCategoryTree(); 
				getFilesCategoryTree();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error';
		}
	}
}

function filesNodeDelete(eid){
	http.open('get', 'aac_files_node_delete.php?node=' + eid + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = handleDeleteFilesNode;
	http.send(null);
}

function handleDeleteFilesNode(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Deleting';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Deleting...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
			}else{
				aia.className = "infoSuccess";
				aia.innerHTML = 'Deleted';
				getCategoryTree(); 
				getFilesCategoryTree();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error';
		}
	}
}


function saveFileCategory(){
	var currentDate = new Date();
	var postData=getFormData('filesCategoryForm');

	http.open('post', 'aac_files_category_save.php?PHPSESSID=' + $("sid").value + '&time='+currentDate.valueOf(), true);
	http.onreadystatechange = handleSaveFileCategory;
	http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	http.setRequestHeader("Content-length", postData.length);
	http.setRequestHeader("Connection", "close");
	http.send(postData);
}

function handleSaveFileCategory(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Saving';
	}
	if(http.readyState == 2){
		aia.className = "infoUnknown";
		aia.innerHTML = 'Saving...';
	}
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error';
				
			}else if(response=="library_files_msg_fileHaveToBeInOneCategory"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("library_files_msg_fileHaveToBeInOneCategory");
				}else{
					var a=$("filesListArea");
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("library_files_msg_fileHaveToBeInOneCategory");
					a.insertBefore(e, $("filesCategoryForm"));
				}
				
			}else if(response=="updated"){
				aia.className = "infoSuccess";
				aia.innerHTML = 'Saved';
				
				if($("ajax_message")){
					$("ajax_message").className="mess_ok";
					$("ajax_message").innerHTML=getText("library_files_msg_DataWasSaved");
				}else{
					var a=$("filesListArea");
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_ok");
					e.className="mess_ok";
					e.innerHTML=getText("library_files_msg_DataWasSaved");
					a.insertBefore(e, $("filesCategoryForm"));
				}
				
				getOffset();
				list();
							
				setTimeout("clearAacInfo('aacInfoArea');",1500);
			}else{
				alert(reponse);
			}

		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;saving&nbsp;file&nbsp;category!';
		}
	}
}

var tmpFilesCategoryArray = new Array();

function checkFilesBoxes(i,p){

	var a = new Array();
	if(p!=0) a=p.split(",");
	var ident='box['+i+']';

	tmpFilesCategoryArray[i]=($(ident).checked==true ? true : false);
	aTmpsCheckStatus=(tmpFilesCategoryArray[i]==true ? true : false);

	if(p!=0){
		for(var j=0;j<a.length;j++){
			var ident='box['+a[j]+']';
			$(ident).checked=aTmpsCheckStatus;
		}
	}
}

function checkFilesTypeFilter(f){
	inp = $("fakeFilterType_"+f);
	inp.click();
}

	/* flv capture */

function openFLVCapture(file_id){	
	http.open('get', 'aac_files_flv_capture.php?file=' + file_id + '&PHPSESSID=' + $("sid").value);
	http.onreadystatechange = handleOpenFLVCapture;
	http.send(null);
}

function handleOpenFLVCapture(){
	var aia=$('aacInfoArea');

	if(http.readyState == 1) void(0);
	if(http.readyState == 2) void(0);
	if(http.readyState == 4){
		if(http.status == 200){
			var response = http.responseText;
			if(response=="AccessDenied"){

				if($("ajax_message")){
					$("ajax_message").className="mess_error";
					$("ajax_message").innerHTML=getText("error403");
				}else{
					var e = document.createElement("div");
					e.setAttribute("id","ajax_message");
					e.setAttribute("class","mess_error");
					e.className="mess_error";
					e.innerHTML=getText("error403");
					aia.appendChild(e);
				}
				setTimeout("clearAacInfo('aacInfoArea');",3000);
				
			}else if(response=="error"){
				aia.className = "infoError";
				aia.innerHTML = 'Error&nbsp;handleOpenFLVCapture&nbsp;(response)';
			}else{
				$('filesListArea').innerHTML=response;	
				initFLVCapture();
			}
		}else{
			aia.className = "infoError";
			aia.innerHTML = 'Error&nbsp;handleOpenFLVCapture&nbsp;(404)';
		}
	}
}

function initFLVCapture(){	
	var capture = { movie:"capture.swf", width:"635", height:"420",majorversion:"8", build:"0", flashvars:"pepa=" + $F("capture_file_path") + "&file_id=" + $F("capture_file_id") + "&flv_1=" + $F("capture_end_target"), wmode:"transparent"}; 
	
	UFO.create(capture, "captureFlashArea");
}

/* /flv capture */