<?

	// vrati plnou cestu k nodu vcetne dat
	function getFullNodePath($nodeID){
		global $link,$pathData;

		$pathData="";

		return getDetailNodePath($nodeID);
		
	}	
	function getDetailNodePath($nodeID){
		global $link,$pathData,$cfg;

		// najde rodice
		$query_parent="SELECT parentID, depth, title FROM ".$cfg['db']['table']['images_category']." WHERE id='".$nodeID."'";
		$result_parent = db_query($query_parent,$link);
		while($row_parent = db_fetch_array($result_parent)){

			$pathData[]=array(
					"id" => $nodeID, 
					"parent" => $row_parent['parentID'], 
					"depth" => $row_parent['depth'], 
					"title" => $row_parent['title']
			);

			// rekurze
			getDetailNodePath($row_parent['parentID']);
		}

		reset($pathData);
		krsort($pathData);
		return $pathData;
	}

	// prida potomka
	function addTreeNode($parentID,$title){
		global $link,$u,$cfg;

		if($title==""){
			// nema vyplnen nazev webu
			$alertStorage[]=$u->simpleMessage('error',$u->getText('library_images_msg_mustFillTitle'));
		}else{
			$query="INSERT INTO ".$cfg['db']['table']['images_category']." (title, parentID) VALUES ('".$title."', '".$parentID."')";
			$result = db_query($query,$link);

			setTreeDepths(0,0);
		}

		return $alertStorage;
	}

	// udela ze stromu optiony pro select
	function getTreeToSelect($parentID, $level, $selectedId){
		global $link,$cfg;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['images_category']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){
			echo '<option value="'.$row['id'].'"'.($row['id']==$selectedId ? ' selected' : '').'>'.str_repeat('&nbsp;&nbsp;&nbsp;&nbsp;',($row[depth]>1 ? ($row[depth]-2) : ($row[depth]>0 ? ($row[depth]-1) : $row[depth]))).$row['title'].'</option>'."\n";

			getTreeToSelect($row['id'], $level+1, $selectedId);
		}				
	}

	// doplni hloubky do stromu
	function setTreeDepths($parentID, $level){
		global $link,$cfg;

		$query="SELECT id, title, parentID FROM ".$cfg['db']['table']['images_category']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)) {
			$query_update="UPDATE ".$cfg['db']['table']['images_category']." SET depth='".($level+1)."' WHERE id='".$row['id']."'";
			$result_update = db_query($query_update,$link);
			setTreeDepths($row['id'], $level+1);
		}
	}

	// nacte nazvy nodu
	function getNodeTitles($nodes){
		global $link, $u, $cfg;

		if(is_array($nodes)){
			$tmp_nodes=implode(",",$nodes);
		}elseif($nodes!=""){
			$tmp_nodes=intval($nodes);
		}else{
			return false;
		}

		$query="SELECT id, title, depth FROM ".$cfg['db']['table']['images_category']." WHERE id IN (".$tmp_nodes.")";
		$result = db_query($query,$link);
		while($row = db_fetch_array($result)){
			$dataReturn[$row['id']]=$row['title'];
		}
		return $dataReturn;
	}

	// ziskani parentu nodu
	function getNodeParents($parentID_parent){
		global $link, $pData, $cfg;

		// najde rodice, kteri jsou v urovni dal nez vrstva jazyku
		$query_parent="SELECT parentID FROM ".$cfg['db']['table']['images_category']." WHERE id='".$parentID_parent."' AND depth>2";
		$result_parent = db_query($query_parent,$link);
		while ($row_parent = db_fetch_array($result_parent)){

			$pData[]=$row_parent['parentID'];

			// rekurze
			getNodeParents($row_parent['parentID']);
		}

		return $pData;
	}

	// ziskani deti nodu
	function getNodeChilds($node_node_child){
		global $link, $chData, $cfg;

		// najde deti
		$query_node_child="SELECT id FROM ".$cfg['db']['table']['images_category']." WHERE parentID='".$node_node_child."';";
		$result_node_child = db_query($query_node_child,$link);
		while($row_node_child = db_fetch_array($result_node_child)){

			$chData[] = $row_node_child['id'];

			// rekurze
			getNodeChilds($row_node_child['id']);
		}

		return $chData;
	}

	// nacteni dat stromu	
	function getTreeData($parentID, $level){
		global $link, $getPath, $tData, $pData, $chData, $cfg;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['images_category']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){

			$pData="";
			$chData="";
						
			$tData[$row['id']]=array(id=>$row['id'], title=>$row['title'], parent=>$row['parentID'], depth=>$row['depth'], parentNodes=>getNodeParents($row['id']), childNodes=>getNodeChilds($row['id']));
						
			// rekurze
			getTreeData($row['id'], $level+1);
		}
	
		return $tData;
	}
	
	/* strom categorii */

	function getImagesCategoryTree($parentID, $level){
		global $link, $v, $tmp_depth, $treeData, $cfg, $u;
 		$tmp_depth[0]=0;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['images_category']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		$result_rows = db_num_rows($result);
		
		// pokud je strom przdn
		if($parentID==0 && $result_rows==0){
			addTreeNode(0, $u->getText("library_images_default_category_title"));
			echo ("<script> getCategoryTree(); </script>");
		}
	
		while ($row = db_fetch_array($result)){
										
			$tmp_depth[$v]=$row[depth];
			$ted=$tmp_depth[$v];
			$pred=$tmp_depth[($v-1)];

			// pokud je dalsi node vis nez byl predchozi, je potreba otevrit ul
			if($ted > $pred){
			
				echo ("\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-2) : $row[depth]))."<ul>");

			// pokud je dalsi node niz nez byl predchozi, je potreba uzavrit li a ul
			}elseif($ted < $pred){ 						
				
				// vypise tolik uzavreni, kolik je potreba
				for($x=$pred;$x>$ted;$x--){
					echo "\n".str_repeat("\t",($x-1))."</li> \n".str_repeat("\t",($x-2))."</ul>";
				}			
				// uzavre li
				echo("\n".str_repeat("\t",($ted-1)).'</li>');

			}else{
				echo ("\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-1) : $row[depth]))."</li>");
			}			
						
			echo "\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-1) : $row[depth])).'<li class="'.($row[depth]==1 ? 'tree_node_web' : 'tree_node_norm').'">';

			echo ('<a href="#" onClick="readCategoryImages('.$row['id'].');">'.$row['title'].'</a>');
						
			$v++;
		
			// rekurze
			getImagesCategoryTree($row['id'], $level+1);
		}
	}

	function getCategoryTree($parentID, $level){
		global $link, $v, $tmp_depth, $treeData, $cfg, $u;
 		$tmp_depth[0]=0;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['images_category']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		$result_rows = db_num_rows($result);

		while ($row = db_fetch_array($result)){
										
			$tmp_depth[$v]=$row[depth];
			$ted=$tmp_depth[$v];
			$pred=$tmp_depth[($v-1)];

			// pokud je dalsi node vis nez byl predchozi, je potreba otevrit ul
			if($ted > $pred){
			
				echo ("\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-2) : $row[depth]))."<ul>");

			// pokud je dalsi node niz nez byl predchozi, je potreba uzavrit li a ul
			}elseif($ted < $pred){ 						
				
				// vypise tolik uzavreni, kolik je potreba
				for($x=$pred;$x>$ted;$x--){
					echo "\n".str_repeat("\t",($x-1))."</li> \n".str_repeat("\t",($x-2))."</ul>";
				}			
				// uzavre li
				echo("\n".str_repeat("\t",($ted-1)).'</li>');

			}else{
				echo ("\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-1) : $row[depth]))."</li>");
			}			
						
			echo "\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-1) : $row[depth])).'<li class="'.($row[depth]==1 ? 'tree_node_web' : 'tree_node_open').'" id="tree_li['.$row['id'].']">';
					
			echo ('<a href="#" onclick="javascript: initImagesNodeEditQuestion('.$row['id'].');" id="tree_title['.$row['id'].']">'.$row['title'].'</a>');
						
			$v++;
		
			// rekurze
			getCategoryTree($row['id'], $level+1);
		}
	}

	function getImagesCategoryImagesTree($parentID, $level){
		global $link, $cfg, $v, $tmp_depth, $getPath, $treeData, $_GET, $tmp_box;
 		$tmp_depth[0]=0;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['images_category']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		$result_rows = db_num_rows($result);

		while ($row = db_fetch_array($result)){
			
			$tmp_depth[$v]=$row[depth];
			$ted=$tmp_depth[$v];
			$pred=$tmp_depth[($v-1)];

			// pokud je dalsi node vis nez byl predchozi, je potreba otevrit ul
			if($ted > $pred){
			
				echo ("\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-2) : $row[depth]))."<ul>");

			// pokud je dalsi node niz nez byl predchozi, je potreba uzavrit li a ul
			}elseif($ted < $pred){ 	
				
				// vypise tolik uzavreni, kolik je potreba
				for($x=$pred;$x>$ted;$x--){
					echo "\n".str_repeat("\t",($x-1))."</li> \n".str_repeat("\t",($x-2))."</ul>";
				}			
				// uzavre li
				echo("\n".str_repeat("\t",($ted-1)).'</li>');

			}else{
				echo ("\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-1) : $row[depth]))."</li>");
			}				
			
			echo "\n".str_repeat("\t",$row[depth]).'<li id="tree_right_li['.$row['id'].']">';

			if($row[depth]==1) echo('<img src="./images/small_icon_web.gif" border="0" />');

			if($row[depth]>1) echo('<img src="./images/small_icon_folder.gif" border="0" />');

			// $fce='checkLinksBoxes(\''.$row['id'].'\', \''.(is_array($treeData[$row['id']][childNodes]) ? implode(",", $treeData[$row['id']][childNodes]) : "0").'\')';
			
			echo ('<input type="checkbox" name="box['.$row['id'].']" id="box['.$row['id'].']" value="1" onclick="'.$fce.'"'.$tmp_box[$row['id']].'> '.$row['title'].'');
						
			$v++;
			
			// rekurze
			getImagesCategoryImagesTree($row['id'], $level+1);
		}
		
	}	

	function getDeletionTree($parentID, $level){
		global $link, $cfg, $u, $nodes2delete;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['images_category']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		while($row = db_fetch_array($result)){
			
			$nodes2delete[]=$row[id];
				
			// rekurze
			getDeletionTree($row['id'], $level+1);
		}

		return $nodes2delete;
	}

	function getImagesFromCategory($category){
		global $link, $cfg, $u;

		$images2deletion="";

		$query="SELECT image_id FROM ".$cfg['db']['table']['images_category_images']." WHERE node_id='".$category."'";
		$result = db_query($query,$link);
		while($row = db_fetch_array($result)){
			$images2deletion[]=$row[image_id];
		}

		return $images2deletion;
	}

	function getImagesData($search){
		global $link, $cfg;

		$data="";

		$q = $search[q];
		$q = str_replace($escape, $unescape, $q);

		$format_w=$search[format_w];
		$format_h=$search[format_h];
		$format_n=$search[format_n];

		$category=$search[category];
		$order=$search[order];
		$how=$search[how];
		$off=intval($search[off]);
		$offset=intval($search[offset]);

		$category = $search[category];

		$id = $search[id];
									
		unset($query_arr); $v=0;
		$query_arr[$v++] = "deleted='".$cfg["DELETED_FALSE"]."'";
		if($q!=""){ 
			$query_arr[$v++] = '((title LIKE "%'.$q.'%") OR (filetype LIKE "%'.$q.'%") OR (filesize LIKE "%'.$q.'%") OR (filename LIKE "%'.$q.'%") OR (note LIKE "%'.$q.'%") OR (keywords LIKE "%'.$q.'%"))';
		}	
		if($category>0){ 
			$query_arr[$v++] = '(c.node_id = "'.$category.'")';
		}	
		if(is_array($id)){ 
			$query_arr[$v++] = 'id IN ('.implode(",", $id).')';
		}elseif($id!=""){ 
			$query_arr[$v++] = '(id IN ('.$id.'))';
		}

		// format obrazku
		if($format_w!=1 && $id<1  && $search[unlimited]==false){
			$query_arr[$v++] = '(fileformat <= 1)';
		}
		if($format_h!=1 && $id<1  && $search[unlimited]==false){
			$query_arr[$v++] = '(fileformat >= 1)';
		}
		if($format_n!=1 && $id<1 && $search[unlimited]==false){
			$query_arr[$v++] = '(fileformat != 1)';
		}

		if($order!=""){
			$query_order="ORDER BY ".$order." ".$how.", title ASC, mtime ASC";
		}

		if($search[param]!="count" && $id<1 && $search[unlimited]==false){
			$query_limit="LIMIT ".$off.",".$offset;
		}
		
		$query="SELECT * FROM ".$cfg['db']['table'][images]." AS l LEFT JOIN ".$cfg['db']['table'][images_category_images]." AS c ON c.image_id=l.id WHERE ".implode(" AND ",$query_arr)." GROUP BY image_id ".$query_order." ".$query_limit.";";

		if($search[param]=="count"){
			$result=db_query($query,$link);
			$data=db_num_rows($result);
		}else{
			$result=db_query($query,$link);
			while($output=db_fetch_assoc($result,$link)){
				$data[$output[id]]=$output;
			}	
		}	
		
		return $data;
	}

?>