<?
	session_start();

	header("Content-Type: text/html; charset=UTF-8");

	include("../../include/local.inc.php");		
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("locations.inc.php");
	include("../mod_photos/photos.class.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$u=new Underwood();

	$locations=new Locations();	
	$photoClass=new Photos();
	
	/* */

	$openLocation=intval($_GET[item]);

	if($u->verifyUserRight("mod_locations_locations_location_insert")==0 && $openLocation==0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}

	if($u->verifyUserRight("mod_locations_locations_location_update")==0 && $openLocation>0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}

	/* ziska informace o lektorovi */
	if($openLocation>0){
		$search[id] = $openLocation;
		$search[param]="normal";
		$locationsData = $locations->getLocationsData($search);
	}

	// vezme informaci o setech
	$setsData = $photoClass->getSetsData($none, "meta_title ASC");

	// vezme data o knihovne
	$libraryData = $u->getLibraryData();

	$sort_id = $sort_title = "";
	foreach($libraryData["files"] AS $key => $row){
	   $sort_id[$key]  = $row['id'];
	   $sort_title[$key]  = $row['title'];
	}
	array_multisort($sort_title, SORT_ASC, $libraryData["files"]);

	?>

<form name="locationEditForm" id="locationEditForm">

<table cellpadding="8" cellspacing="0" border="0" class="tableEdit">
	<tr><td><h4 class="title"><? echo ($openLocation>0 ? $locationsData[$openLocation][title] :  $u->getText("mod_locations_locations_location_newItem")); ?></h4></td></tr>
	<tr>
		<td>
		<table cellpadding="0" cellspacing="0" border="0">
			<tr>
				<td class="caption"><? echo $u->getText('mod_locations_locations_location_it_title'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_title" id="d_title" class="input long high" value="<? echo $u->insertData($locationsData[$openLocation][title]); ?>"></td>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>&nbsp;</td>
				<td>&nbsp;</td>
				<td>&nbsp;</td>
			</tr>			
			<tr>
				<td class="caption"><? echo $u->getText('mod_locations_locations_location_it_slideshow'); ?></td>
				<td>&nbsp;</td>
				<td>
				<?
					echo('<select name="d_set_id" name="d_set_id">');
					echo('<option value="0"'.($locationsData[$openLocation]["set_id"]==0 ? " selected" : "").'>-- ('.$u->getText('nothing').') --</option>');
					reset($setsData);
					while(list($key,$val)=each($setsData)){
						echo('<option value="'.$val[id].'"'.($locationsData[$openLocation]["set_id"]==$val[id] ? " selected" : "").'>'.$val['title'].'</option>');
					}
					echo('</select>');
				?>
				</td>
		</tr>
		</table>
			
		</td>
	</tr>
	<tr><td colspan="5">&nbsp;</td></tr>
	<tr>
		<td><a href="#" onClick="saveLocation(<? echo $openLocation; ?>);" class="button"><img src="<? echo UW_BASE_URL; ?>/images/icons/save.gif" border="0" alt="" /> <? echo $u->getText('save'); ?></a><a href="#" onClick="getOffset(); list();" class="button"><img src="<? echo UW_BASE_URL; ?>/images/icons/cancel.gif" border="0" alt="" /> <? echo $u->getText('cancel'); ?></a><a href="#" onClick="openLocation(<? echo $openLocation; ?>); " class="button"><img src="<? echo UW_BASE_URL; ?>/images/icons/change.gif" border="0" alt="" /> <? echo $u->getText('refresh'); ?></a></td>
	</tr>
	<tr><td>&nbsp;</td></tr>
</table>
<input type="hidden" name="action" value="save">
<input type="hidden" name="location_id" value="<? echo $openLocation; ?>">

</form>