<?
session_start();

    set_time_limit(36000);
    ini_set("memory_limit","20M");

	// ěščřžýáíé
	header("Content-Type: text/html; charset=UTF-8");
	
	include("../../include/local.inc.php");
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");

	include("photos.class.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	$u=new Underwood();	
	$photoClass=new Photos(); 
	
	/* kontrola jestli je uzivatel prihlaseny */
	if($u->verifyUserRight("mod_photos_content")==0){
		header("Location: ".UW_BASE_URL."/?403=true&request=".$_SERVER[REQUEST_URI]);
	}

	$lang = intval($lang)==0 ? $U_LANGUAGE_CZE : intval($lang);
	$off = intval($off);
  
	$ord=intval($ord);
	$how=intval($how);

	/* konec */

	unset($query_arr); $v=0;
	$query_arr[$v++] = "(resize='1')";
	$query_arr[$v++] = "(deleted=".$cfg["DELETED_FALSE"].")";
	
	// filtr podle selectoru
	if($_POST[findrFilterSelector]!=""){

		// bez názvu
		if($_POST[findrFilterSelector]=="_WithoutTitle") $query_arr[$v++] = "(meta_title = '')";
		// s názvem
		if($_POST[findrFilterSelector]=="_WithTitle") $query_arr[$v++] = "(meta_title != '')";

		// bez popisu
		if($_POST[findrFilterSelector]=="_WithoutAbout") $query_arr[$v++] = "(meta_about = '')";
		// s popisem
		if($_POST[findrFilterSelector]=="_WithAbout") $query_arr[$v++] = "(meta_about != '')";

		// bez autora
		if($_POST[findrFilterSelector]=="_WithoutAuthor") $query_arr[$v++] = "(meta_author = '')";
		// s autorem
		if($_POST[findrFilterSelector]=="_WithAuthor") $query_arr[$v++] = "(meta_author != '')";

		// bez data
		if($_POST[findrFilterSelector]=="_WithoutWhen") $query_arr[$v++] = "(meta_when = '0000-00-00 00:00:00')";
		// s datem
		if($_POST[findrFilterSelector]=="_WithWhen") $query_arr[$v++] = "(meta_when != '0000-00-00 00:00:00')";

		// adresare
		if(ereg("path_",$_POST[findrFilterSelector])){
			$query_arr[$v++] = "(path = '".str_replace("path_","",$_POST[findrFilterSelector])."')";
		}
		// sety
		if(ereg("set_",$_POST[findrFilterSelector])){
			// vybere fotky ze setu
			$query = "SELECT p.id FROM ".$cfg['db']['table']['mod_photos_sets']." AS c, ".$cfg['db']['table']['mod_photos_photos']." AS p WHERE set_id='".str_replace("set_","",$_POST[findrFilterSelector])."' AND p.id=c.photo_id ORDER BY c.sort ASC;";
			$result = db_query($query,$link);
			while(list($f_id) = db_fetch_row($result)) $tmp_in_set[]=$f_id;
			$query_arr[$v++] = "(id IN (".implode(",",$tmp_in_set)."))";	
		}
	}

	$useAdvanced=0;
	reset($findrFilterSign);
	while(list($key,$val)=each($findrFilterSign)){
		if($val!=""){		
			$useAdvanced=1;
			$query_arr[$v++] = "(".$key." ".$photoClass->createSQLQueryCondition($val,$findrFilterValue[$key]).")";
		}
	}


	// pokud nezadal zadny filtr, vratim uzivateli upozorneni
	if($_POST[findrFilterSelector]=="" && $useAdvanced==0){
		echo('<div class="info">'.$u->getText('mod_photos_findr_choosePhotos').'</div>');
		flush();
		db_close($link);
		exit();
	}	

	$query = "SELECT id, filename, filehash, extension FROM ".$cfg['db']['table']['mod_photos_photos']." WHERE ".implode(" AND ",$query_arr)." ORDER BY id DESC;";

	$result = db_query($query,$link);
	$resultCount=db_num_rows($result);

	if($resultCount > $photoClass->PHOTOS_FINDRLIMIT){
		$query = "SELECT id, filename, filehash, extension FROM ".$cfg['db']['table']['mod_photos_photos']." WHERE ".implode(" AND ",$query_arr)." ORDER BY id DESC LIMIT 0,".$photoClass->PHOTOS_FINDRLIMIT.";";
		$result = db_query($query,$link);
		$newResultCount=db_num_rows($result);

		echo('<div class="sq_info">');
			echo('<div class="pad">');
				echo(''.$u->getText('mod_photos_findr_showingFirst').' <strong>'.$newResultCount.'</strong> '.$u->getText('mod_photos_findr_showingFirstPhotosFrom').' '.$resultCount);
				$infoCount=1;
			echo('</div>');	
		echo('</div>');
	}

	while(list($f_id, $f_filename, $f_filehash, $f_extension) = db_fetch_row($result)){
		$files[]=array("id" => $f_id, "filename" => $f_filename, "filehash" => $f_filehash, "ext" => $f_extension);
	}

	$all_photos_in_finder="";

	if(is_array($files)){
		reset($files);
		while(list($key,$val)=each($files)){

			$all_photos_in_finder[]=$val[id];
			$img_path = $photoClass->PHOTOS_URL."/".$photoClass->PHOTOS_DIRNAME_RESIZE."/".$photoClass->PHOTOS_THUMB_SIZES[s]."/".strtolower(substr($val[filehash],0,1));

			echo('<div id="photo_div['.$val[id].']" class="photo_sq_float"  onclick="photosSelectPhotoSq(\''.$val[id].'\',1);">');
				echo('<img src="'.$img_path.'/'.$val[filehash].'.'.$val[ext].'" title="pid['.$val[id].'] - '.$val[filename].'">');
			echo('</div>');
			flush();
		}
	}else{
		echo('<div class="info">'.$u->getText('mod_photos_findr_nothingFound').'</div>');
		flush();
		db_close($link);
		exit();
	}	

	echo('<input type="hidden" name="count_photos_in_finder" id="count_photos_in_finder" value="'.intval(count($all_photos_in_finder)+$infoCount).'" />');
		
	echo('<input type="hidden" name="all_photos_in_finder" id="all_photos_in_finder" value="'.(is_array($all_photos_in_finder) ? implode(',',$all_photos_in_finder) : "").'" />');

	echo('<input type="hidden" name="selected_photos" id="selected_photos" value="" />');
	
	flush();	
	db_close($link);

	exit();
?>