<?
	// ěščřžýáíé
	header("Content-Type: text/html; charset=UTF-8");

	set_time_limit(36000);
	ini_set("memory_limit","100M");

class Photos{
   var $modules = Array();

	function Photos(){
		$this->today = date("Y-m-d");
		$this->globalTest = $GLOBALS['test'];
		
		$this->PHOTOS_SET_LOCKS = array(
			"1" => array("title_code" => 'mod_photos_sets_lock_club'), 
			"2" => array("title_code" => 'mod_photos_sets_lock_normal')
		);

		// slozka s fotkami
		$this->PHOTOS_DIR = UW_DIR."/".'photos';
		$this->PHOTOS_URL = UW_URL."/".'photos';

		$this->PHOTOS_DIRNAME_RESIZE = 'resize';
		$this->PHOTOS_DIRNAME_ORIGINAL = 'original';
		$this->PHOTOS_DIRNAME_TEMP = 'temp';
		$this->PHOTOS_DIRNAME_UPLOAD = 'upload';

		// nazvy slozek ktere se budou ignorovat
		$this->PHOTOS_IGNORE_FOLDER = array("nahledy");

		$this->SOURCE_SIZE_BIG = "1000x1000";
		$this->SOURCE_SIZE_SMALL = "400x265";
		
		// rozmery velkych obrazku; key je check ("1200" => "1200x1200", "750" => "750x750", "525" => "525x525", "400" => "400x400")
		$this->PHOTOS_BIG_SIZES=array(
			'750' => "750x500", 
			'525' => "525x350", 
			'480' => "480x360", 
			'400' => "400x265",
			'384' => "384x258");
		
		// rozmery nahledovych obrazku; ("240x160","100x100","75x75") + volitelne (t)!
		$this->PHOTOS_THUMB_SIZES=array(
			'm' => "240x160",
			'q' => "100x100", 
			's' => "75x75",			
			't' => "125x94"
		);

		// editace fotek - po kolika strankovat
		$this->PHOTOS_EDIT_PERPAGE=10;

		// maximalni pocet zobrazitelnych ve findru
		$this->PHOTOS_FINDRLIMIT=1500;

	}

	function getRootNode(){
		global $link, $cfg, $v;	

		// pokud je strom prázdný, vytvoří první kategorii (rootovskou)
		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE parentID='0'";
		$result = db_query($query,$link);	
		$result_rows = db_num_rows($result);	
		if($parentID==0 && $result_rows==0){
			$query = "INSERT INTO ".$cfg['db']['table']['mod_photos_structure']." (parentID, title, depth, ctime, mtime) VALUES ('0', 'Fotogalerie', '1', NOW(), NOW());";
			$result = db_query($query, $link);	
		}

		// jinak vrati
		$query="SELECT id FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE parentID='0'";
		$result = db_query($query,$link);
		list($tmp_root_id) = db_fetch_row($result,$link);

		return $tmp_root_id;
	}

	function getTreeForEdit(){
		global $link, $cfg, $v;

		$rootID=$this->getRootNode();

		$data=$dataTree="";
		$v=1;
		$tmp_depth=array(0=>3);

		$data.=('<ul>');
		
		$data.=('<li class="tree_node_main" id="tree_li['.$rootID.']">');
		
			$data.=('<a href="#" onclick="javascript: initTreeNodeEditQuestion('.$rootID.',\'tree\');" id="tree_title['.$rootID.']" title="'.$rootID.'">'.implode("", $this->getNodeTitles($rootID)).'</a>');
			
		$data.=$this->getTreeForEditReal($rootID,0);

		$pred=$tmp_depth[($v-1)];
		for($x=$pred;$x>1;$x--)	$data.="\n".str_repeat("\t",($x-1))."</li> \n".str_repeat("\t",($x-2))."</ul>";

		return $data;
	}

	// zobrazeni stromu	
	function getTreeForEditReal($parentID, $level){
		global $link, $v, $cfg, $tmp_depth, $dataTree;
		
		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE parentID='".$parentID."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){
			
			$tmp_depth[$v]=$row[depth];
			$ted=$tmp_depth[$v];
			$pred=$tmp_depth[($v-1)];

			// pokud je dalsi node vis nez byl predchozi, je potreba otevrit ul
			if($ted > $pred){
				$dataTree.=("\n".str_repeat("\t",$row[depth])."<ul>");

			// pokud je dalsi node niz nez byl predchozi, je potreba uzavrit li a ul
			}elseif($ted < $pred){ 
				
				// vypise tolik uzavreni, kolik je potreba
				for($x=$pred;$x>$ted;$x--){
					$dataTree.="\n".str_repeat("\t",($x-1))."</li> \n".str_repeat("\t",($x-2))."</ul>";
				}
				// uzavre li
				$dataTree.=("\n".str_repeat("\t",($ted-1)).'</li>');

			}else{
				$dataTree.=("\n".str_repeat("\t",$row[depth])."</li>");
			}
			
			$dataTree.="\n".str_repeat("\t",$row[depth]).'<li class="'.($getPath==$row[id] ? 'tree_node_open' : 'tree_node_norm').'" id="tree_li['.$row['id'].']">';
				
			$dataTree.=('<a href="javascript: void(0);" onclick="javascript: initTreeNodeEditQuestion('.$row['id'].',\'node\');" id="tree_title['.$row['id'].']" title="'.$row['id'].'">'.$row['title'].'</a>');
						
			$v++;
			
			// rekurze
			$this->getTreeForEditReal($row['id'], $level+1);
		}

		return $dataTree;
	}

	function getTreeForCheck(){
		global $link, $cfg, $v, $tmp_box;

		$rootID=$this->getRootNode();

		$data=$dataTree="";
		$v=1;
		$tmp_depth=array(0=>3);

		$data.=('<ul>');
		
		$data.=('<li class="tree_node_main" id="tree_check_li['.$rootID.']">');
					
			$data.=('<input type="checkbox" name="box['.$rootID.']" id="box['.$rootID.']" value="1" '.$tmp_box[$rootID].'> '.implode("", $this->getNodeTitles($rootID)).'');	
			
		$data.=$this->getTreeForCheckReal($rootID,0);

		$pred=$tmp_depth[($v-1)];
		for($x=$pred;$x>1;$x--)	$data.="\n".str_repeat("\t",($x-1))."</li> \n".str_repeat("\t",($x-2))."</ul>";

		return $data;
	}

	// zobrazeni stromu	
	function getTreeForCheckReal($parentID, $level){
		global $link, $v, $cfg, $tmp_depth, $dataTree, $tmp_box;
		
		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE parentID='".$parentID."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){
			
			$tmp_depth[$v]=$row[depth];
			$ted=$tmp_depth[$v];
			$pred=$tmp_depth[($v-1)];

			// pokud je dalsi node vis nez byl predchozi, je potreba otevrit ul
			if($ted > $pred){
				$dataTree.=("\n".str_repeat("\t",$row[depth])."<ul>");

			// pokud je dalsi node niz nez byl predchozi, je potreba uzavrit li a ul
			}elseif($ted < $pred){ 
				
				// vypise tolik uzavreni, kolik je potreba
				for($x=$pred;$x>$ted;$x--){
					$dataTree.="\n".str_repeat("\t",($x-1))."</li> \n".str_repeat("\t",($x-2))."</ul>";
				}
				// uzavre li
				$dataTree.=("\n".str_repeat("\t",($ted-1)).'</li>');

			}else{
				$dataTree.=("\n".str_repeat("\t",$row[depth])."</li>");
			}
			
			$dataTree.="\n".str_repeat("\t",$row[depth]).'<li class="'.($getPath==$row[id] ? 'tree_node_open' : 'tree_node_norm').'" id="tree_check_li['.$row['id'].']">';

			$dataTree.=('<input type="checkbox" name="box['.$row['id'].']" id="box['.$row['id'].']" value="1" '.$tmp_box[$row['id']].'> '.$row['title'].'');				
						
			$v++;
			
			// rekurze
			$this->getTreeForCheckReal($row['id'], $level+1);
		}

		return $dataTree;
	}

	/* sort */
	
	// nacteni dat stromu pro razeni	
	function getNodesForSort($parentID, $level){
		global $link, $cfg, $u;

		$data="";

		$query="SELECT id, title, sort FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE parentID='".$parentID."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC;";

		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){						
			$data[$row['id']]=array(id=>$row['id'], title=>$row['title'], 'sort'=>$row['sort']);
		}
	
		return $data;
	}

	/* delete */
	
	function getNodesForDelete($parentID, $level){
		global $link, $cfg, $nodes2delete;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		while($row = db_fetch_array($result)){
			
			$nodes2delete[]=$row[id];
				
			// rekurze
			$this->getNodesForDelete($row['id'], $level+1);
		}

		return $nodes2delete;
	}

	// zobrazi cestu k nodu
	function getNodePath($nodeID){
		global $link,$cfg;

		$result = db_query('SELECT parentID, depth, title FROM '.$cfg['db']['table']['mod_photos_structure'].' WHERE id="'.$nodeID.'" AND deleted="'.$cfg["DELETED_FALSE"].' ORDER BY sort ASC";',$link);
		$row =db_fetch_array($result);
		$path = array();
		if($row['parentID']!=''){
			/* nevim */
			// if($row[depth]!=3) $path[] = $row['parentID'];
			$path = array_merge($this->getNodePath($row['parentID']), $path);
		}

		return $path;
	}

	// vrati plnou cestu k nodu vcetne dat
	function getFullNodePath($nodeID){
		global $link,$pathData;

		$pathData=array();

		return $this->getDetailNodePath($nodeID);
		
	}
	function getDetailNodePath($nodeID){
		global $link,$pathData,$cfg;

		// najde rodice
		$query_parent="SELECT parentID, depth, title FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE id='".$nodeID."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC;";
		$result_parent = db_query($query_parent,$link);
		while($row_parent = db_fetch_array($result_parent)){

			$pathData[]=array(
					"id" => $nodeID, 
					"parent" => $row_parent['parentID'], 
					"depth" => $row_parent['depth'], 
					"sort" => $row_parent['sort'], 
					"title" => $row_parent['title']
			);

			// rekurze
			$this->getDetailNodePath($row_parent['parentID']);
		}

		if(is_array($pathData)){
			reset($pathData);
			krsort($pathData);
		}
		return $pathData;
	}

	// udela ze stromu optiony pro select
	function getTreeToSelect($parentID, $level, $selectedId){
		global $link,$cfg;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE parentID='".$parentID."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC;";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){
			if($row[depth]!=2){
				echo '<option value="'.$row['id'].'"'.($row['id']==$selectedId ? ' selected' : '').'>'.str_repeat('&nbsp;&nbsp;&nbsp;&nbsp;',($row[depth]>1 ? ($row[depth]-2) : ($row[depth]>0 ? ($row[depth]-1) : $row[depth]))).$row['title'].'</option>'."\n";
			}
			$this->getTreeToSelect($row['id'], $level+1, $selectedId);
		}
	}

	// doplni hloubky do stromu
	function setTreeDepths($parentID, $level){
		global $link, $cfg, $u;

		$query="SELECT id, title, depth FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE parentID='".$parentID."' AND deleted='".$cfg["DELETED_FALSE"]."';";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){

			$query_update="UPDATE ".$cfg['db']['table']['mod_photos_structure']." SET depth='".($level+1)."' WHERE id='".$row['id']."'";
			$result_update = db_query($query_update,$link);

			// rekurze
			$this->setTreeDepths($row['id'], $level+1);
		}
	}

	// nacte nazvy nodu
	function getNodeTitles($nodes){
		global $link, $cfg;

		if(is_array($nodes)){
			$tmp_nodes=implode(",",$nodes);
		}elseif($nodes!=""){
			$tmp_nodes=intval($nodes);
		}else{
			return false;
		}

		$dataReturn=array();

		$query="SELECT id, title, depth FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE id IN (".$tmp_nodes.") AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC;";
		$result = db_query($query,$link);
		while($row = db_fetch_array($result)){
			$dataReturn[$row['id']]=$row['title'];
		}


		return $dataReturn;
	}

	// ziskani parentu nodu
	function getNodeParents($parentID_parent){
		global $link, $pData, $cfg;

		// najde rodice, kteri jsou v urovni dal nez vrstva jazyku
		$query_parent="SELECT parentID FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE id='".$parentID_parent."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC";
		$result_parent = db_query($query_parent,$link);
		while ($row_parent = db_fetch_array($result_parent)){

			$pData[]=$row_parent['parentID'];

			// rekurze
			$this->getNodeParents($row_parent['parentID']);
		}

		return $pData;
	}

	// ziskani deti nodu
	function getNodeChilds($node_node_child){
		global $link,$chData,$cfg;

// 		echo ($node_node_child.", ");

		// najde rodice, kteri jsou v urovni dal nez vrstva jazyku
		$query_node_child="SELECT id FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE parentID='".$node_node_child."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC;";
		$result_node_child = db_query($query_node_child,$link);
		while($row_node_child = db_fetch_array($result_node_child)){

			$chData[] = $row_node_child['id'];

			// rekurze
			$this->getNodeChilds($row_node_child['id']);
		}

		return $chData;
	}

	// nacteni dat stromu	
	function getTreeData($parentID, $level){
		global $link, $cfg, $getPath, $tData, $pData, $chData;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE parentID='".$parentID."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC;";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){

			$pData="";
			$chData="";
						
			$tData[$row['id']]=array(id=>$row['id'], title=>$row['title'], parent=>$row['parentID'], depth=>$row['depth'], parentNodes=>$this->getNodeParents($row['id']), childNodes=>$this->getNodeChilds($row['id']));
						
			// rekurze
			$this->getTreeData($row['id'], $level+1);
		}
	
		return $tData;
	}

	function getTreeNodeData($nodeID){
		global $link, $cfg;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_photos_structure']." WHERE id='".$nodeID."' AND deleted='".$cfg["DELETED_FALSE"]."' ORDER BY sort ASC;";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){
						
			$tData[$row['id']]=array(id=>$row['id'], title=>$row['title'], parent=>$row['parentID'], depth=>$row['depth']);
		}
	
		return $tData;
	}

	function cleanUri($string){
		$utf_str=array(
		"á"=>"a", "ä"=>"a", "č"=>"c", "ď"=>"d", "é"=>"e", "ě"=>"e", "ë"=>"e", "í"=>"i", "ň"=>"n", "ó"=>"o", "ö"=>"o", "ř"=>"r", "š"=>"s", "ť"=>"t", "ú"=>"u", "ů"=>"u", "ü"=>"u", "ý"=>"y", "ž"=>"z", "Á"=>"A", "Ä"=>"A", "Č"=>"C", "Ď"=>"D", "É"=>"E", "Ě"=>"E", "Ë"=>"E", "Í"=>"I", "Ň"=>"N", "Ó"=>"O", "Ö"=>"O", "Ř"=>"R", "Š"=>"S", "Ť"=>"T", "Ú"=>"U", "Ů"=>"U", "Ü"=>"U", "Ý"=>"Y", "Ž"=>"Z");
		$tmp_data = strtr(trim($string), $utf_str);
		$ret_data=preg_replace("/([^a-zA-Z0-9\/-_])/","-",$tmp_data);
		$ret_data=ereg_replace("--+","-",$ret_data);
		$ret_data=trim($ret_data,"-");

		return strtolower($ret_data);
	}

		function returnData($string){
		return trim($string);
	}

	function insertData($string){
		return ($string);
	}

	function photosSetHashes(){
		global $link, $cfg;

		/*  vyplni fotkam kteri nemaji photohash photohash */
		$query_hash = "SELECT id FROM ".$cfg['db']['table']['mod_photos_photos']." WHERE photohash='';";
		$result_hash = db_query($query_hash,$link);
		while (list($e_id) = db_fetch_row($result_hash)){
			db_query("UPDATE ".$cfg['db']['table']['mod_photos_photos']." SET photohash='".$this->photosGetPhotoHash()."' WHERE id=".$e_id,$link);
		}

		/*  vyplni fotkam kteri nemaji filehash filehash */
		$query_hash = "SELECT id FROM ".$cfg['db']['table']['mod_photos_photos']." WHERE filehash='';";
		$result_hash = db_query($query_hash,$link);
		while (list($e_id) = db_fetch_row($result_hash)){
			db_query("UPDATE ".$cfg['db']['table']['mod_photos_photos']." SET filehash='".$this->photosGetFileHash()."' WHERE id=".$e_id,$link);
		}

		/*  vyplni setum ktere nemaji sethash sethash */
		$query_hash = "SELECT id FROM ".$cfg['db']['table']['mod_photos_photosets']." WHERE sethash='';";
		$result_hash = db_query($query_hash,$link);
		while (list($e_id) = db_fetch_row($result_hash)){
			db_query("UPDATE ".$cfg['db']['table']['mod_photos_photosets']." SET sethash='".$this->photosGetSetHash()."' WHERE id=".$e_id,$link);
		}

		return true;
	}

	function photosGetPhotoHash(){
		global $link, $cfg;
		do{	
			$test_hash=$this->generateHash(1,8,"alfanumeric");
			$query_yet="SELECT photohash FROM ".$cfg['db']['table']['mod_photos_photos']." WHERE photohash='".$test_hash."';";
			$result_yet=db_query($query_yet,$link);
			$count_yet=db_num_rows($result_yet);
			if($count_yet==0){
				$p=$test_hash;
				break;
			}
		}while($p=="");

		return $p;
	}

	function photosGetSetHash(){
		global $link, $cfg;
		do{	
			$test_hash=$this->generateHash(1,8,"numeric");
			$query_yet="SELECT sethash FROM ".$cfg['db']['table']['mod_photos_photosets']." WHERE sethash='".$test_hash."';";
			$result_yet=db_query($query_yet,$link);
			$count_yet=db_num_rows($result_yet);
			if($count_yet==0){
				$p=$test_hash;
				break;
			}
		}while($p=="");

		return $p;
	}

	function photosGetFileHash(){
		global $link, $cfg;
		do{	
			$test_hash=$this->generateHash(1,8,"alfanumeric");
			$query_yet="SELECT filehash FROM ".$cfg['db']['table']['mod_photos_photos']." WHERE filehash='".$test_hash."';";
			$result_yet=db_query($query_yet,$link);
			$count_yet=db_num_rows($result_yet);
			if($count_yet==0){
				$p=$test_hash;
				break;
			}
		}while($p=="");

		return $p;
	}

	function generateHash($t,$l,$c){
		// type, length, characters

		$hash="";

		if($c=="pass"){
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx23456789_*245678923456789";
		}elseif($c=="alfa"){
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx";
		}elseif($c=="smallalfa"){
			$char = "abcdefghjkmnpqrstuvwx";
		}elseif($c=="numeric"){
			$char = "012345679";
		}elseif($c=="alfanumeric"){
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx123456790";
		}else{
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx23456789_*245678923456789";
		}

		srand((double)microtime()*100000);
		for($i=0; $i<$l;$i++){
			$pass.= $char[rand()%strlen($char)]; 
		}

		$tm=floor($l/4)-1;

		$hash = ($t==2 ? substr(chunk_split(substr($pass,0,$l-$tm),4,"-"), 0, -1) : $pass);

		return $hash;
	}

	function photosMakeThumbs(){
		global $link, $cfg;

		/*  vyplni fotkam kteri nemaji photohash photohash */
		$query_hash = "SELECT fullpath, filehash, extension FROM ".$cfg['db']['table']['mod_photos_photos']." WHERE resize='2';";
		$result_hash = db_query($query_hash,$link);
		while(list($f_fullpath, $f_filehash, $f_extension) = db_fetch_row($result_hash)){
			$files[]=array("fullpath" => $f_fullpath, "filehash" => $f_filehash, "ext" => $f_extension);
		}

		$filescount = count($files);

		reset($files);
		while(list($key,$file)=each($files)){
		
			// z toho bude delat nahledy
			$output_path_small = $this->PHOTOS_DIR."/".$this->PHOTOS_DIRNAME_RESIZE."/".$this->SOURCE_SIZE_SMALL."/".strtolower(substr($file[filehash],0,1));

			/* zacina zmensovat */
			echo ("<strong>".($filescount-$key)."</strong> ");


			reset($this->PHOTOS_BIG_SIZES);
			while(list($key_sizes,$val_sizes)=each($this->PHOTOS_BIG_SIZES)){

				@mkdir($this->PHOTOS_DIR."/".$this->PHOTOS_DIRNAME_RESIZE."/".$val_sizes,0777);

				list($width, $height) = explode('x',$val_sizes);

				$source=$this->PHOTOS_DIR."/".$this->PHOTOS_DIRNAME_ORIGINAL."".$file[fullpath];
				$output=$this->PHOTOS_DIR."/".$this->PHOTOS_DIRNAME_RESIZE."/".$val_sizes."/".strtolower(substr($file[filehash],0,1));

				@mkdir($output,0777);
				
				$this->resize_photo($source, $output."/".$file[filehash].".".$file[ext], $width, $height);

				echo(".");

				flush();
			}	

			reset($this->PHOTOS_THUMB_SIZES);
			while(list($key_sizes,$val_sizes)=each($this->PHOTOS_THUMB_SIZES)){

				@mkdir($this->PHOTOS_DIR."/".$this->PHOTOS_DIRNAME_RESIZE."/".$val_sizes,0777);

				list($width, $height) = explode('x',$val_sizes);

				$source = $output_path_small."/".$file[filehash].".".$file[ext];
				$output=$this->PHOTOS_DIR."/".$this->PHOTOS_DIRNAME_RESIZE."/".$val_sizes."/".strtolower(substr($file[filehash],0,1));

				@mkdir($output,0777);
				
				$this->resize_photo_crop($source, $output."/".$file[filehash].".".$file[ext], $width, $height, "255", "255", "255");

				echo(".");

				flush();
			}

			echo(' ');

			// oznaci ze ma udelane nahledy
			db_query("UPDATE ".$cfg['db']['table']['mod_photos_photos']." SET resize='1' WHERE filehash='".$file[filehash]."';",$link);

			flush();
		}

		echo(' 0');

		return true;
	}

	function resize_photo($name,$filename,$new_w,$new_h){
	
		list($old_w,$old_h,$old_type)=@getimagesize($name);

		switch($old_type) {
			case 1: $src_img=imagecreatefromgif($name); break;
			case 2: $src_img=imagecreatefromjpeg($name); break;
			case 3: $src_img=imagecreatefrompng($name); break;
			default: return;
		}

		if($old_w<=$new_w && $old_h<=$new_h){
			$new_w=$old_w;
			$new_h=$old_h;
		}

		if($old_h>$old_w){
		   $thumb_h = $new_h;
		   $thumb_w = ($new_h/$old_h)*$old_w;
		}else{
		   $thumb_w = $new_w;
		   $thumb_h = ($new_w/$old_w)*$old_h;
		}
		
		$dst_img=ImageCreateTrueColor($thumb_w,$thumb_h);
		imagecopyresampled($dst_img,$src_img,0,0,0,0,$thumb_w,$thumb_h,$old_w,$old_h); 

		switch($old_type) {
			case 1: imagegif($dst_img,$filename); break;
			case 2: imagejpeg($dst_img,$filename); break;
			case 3: imagepng($dst_img,$filename); break;
		}

		imagedestroy($dst_img); 
		imagedestroy($src_img); 
	}

	function resize_photo_crop($filein, $fileout, $imagethumbsize_w, $imagethumbsize_h, $red, $green, $blue){

		list($width,$height,$old_type)=@getimagesize($filein);
			$new_width = $width * $percent;
			$new_height = $height * $percent;

		switch($old_type) {
			case 1: $image=imagecreatefromgif($filein); $format = 'image/gif'; break;
			case 2: $image=imagecreatefromjpeg($filein); $format = 'image/jpeg'; break;
			case 3: $image=imagecreatefrompng($filein); $format = 'image/png'; break;
			default: return;
		}

		$width = $imagethumbsize_w;
		$height = $imagethumbsize_h;

		list($width_orig, $height_orig) = getimagesize($filein);

		if($width_orig < $height_orig){
		  $height = ($imagethumbsize_w / $width_orig) * $height_orig;
		}else{
		   $width = ($imagethumbsize_h / $height_orig) * $width_orig;
		}

		if($width < $imagethumbsize_w){
			$width = $imagethumbsize_w;
			$height = ($imagethumbsize_w/ $width_orig) * $height_orig;;
		}

		if($height < $imagethumbsize_h){
			$height = $imagethumbsize_h;
			$width = ($imagethumbsize_h / $height_orig) * $width_orig;
		}

		$thumb = imagecreatetruecolor($width , $height); 
		$bgcolor = imagecolorallocate($thumb, $red, $green, $blue); 
		ImageFilledRectangle($thumb, 0, 0, $width, $height, $bgcolor);
		imagealphablending($thumb, true);

		imagecopyresampled($thumb, $image, 0, 0, 0, 0,
		$width, $height, $width_orig, $height_orig);
		$thumb2 = imagecreatetruecolor($imagethumbsize_w , $imagethumbsize_h);

		$bgcolor = imagecolorallocate($thumb2, $red, $green, $blue); 
		ImageFilledRectangle($thumb2, 0, 0,
		$imagethumbsize_w , $imagethumbsize_h , $white);
		imagealphablending($thumb2, true);

		$w1 =($width/2) - ($imagethumbsize_w/2);
		$h1 = ($height/2) - ($imagethumbsize_h/2);

		imagecopyresampled($thumb2, $thumb, 0,0, $w1, $h1,
		$imagethumbsize_w , $imagethumbsize_h ,$imagethumbsize_w, $imagethumbsize_h);
		
		switch($old_type) {
			case 1: imagegif($thumb2,$fileout); break;
			case 2: imagejpeg($thumb2,$fileout); break;
			case 3: imagepng($thumb2,$fileout); break;
		}

		imagedestroy($thumb2);
	}

	function getSetsData($search,$order){
		global $link, $cfg;

		$data="";

		unset($query_arr); $v=0;
		$query_arr[$v++] = "(deleted=".$cfg["DELETED_FALSE"].")";
		if(is_array($search)){
			reset($search);
			while(list($key,$val)=each($search)){
				$query_arr[$v++] = "(".$key." LIKE '%".$val."%')";
			}
		}

		if($search[id]!=""){
			$query_arr[$v++] = "(id = '".intval($search[id])."')";
		}
		
		$query = "SELECT id, meta_title, meta_about, meta_author, meta_when, status, setlock, ctime, mtime FROM ".$cfg['db']['table']['mod_photos_photosets']." WHERE ".implode(" AND ",$query_arr)." ORDER BY ".$order.";";

		$result = db_query($query,$link);
		while(list($f_id, $f_title, $f_about, $f_author, $f_when, $f_status, $f_lock, $f_ctime, $f_mtime) = db_fetch_row($result)){
			$data[$f_id]=array("id" => $f_id, "title" => $f_title, "about" => $f_about, "author" => $f_author, "when" => $f_when, "status" => $f_status, "lock" => $f_lock, "ctime" => $f_ctime, "mtime" => $f_mtime);

			// nacte fotky k setum
			$files="";

			$query_files = "SELECT p.id, p.filename, p.filehash, p.extension, p.fullpath, p.meta_title, p.meta_about FROM ".$cfg['db']['table']['mod_photos_sets']." AS c, ".$cfg['db']['table']['mod_photos_photos']." AS p WHERE c.set_id='".$f_id."' AND p.id=c.photo_id ORDER BY c.sort ASC;";
			$result_files = db_query($query_files,$link);
			while(list($p_id, $p_filename, $p_filehash, $p_extension, $p_fullpath, $p_title, $p_about) = db_fetch_row($result_files)){
				$files[]=array("id" => $p_id, "filename" => $p_filename, "filehash" => $p_filehash, "ext" => $p_extension, "fullpath" => $p_fullpath, "title" => $p_title, "about" => $p_about);
			}

			$data[$f_id]["photos"]=$files;
		}

		return $data;
	}

	function getPhotosData($photos){
		global $link, $cfg;
		
		$files="";
		$query_arr[$v++] = "(1=1)";

		if(is_array($photos)){ 
			$query_arr[$v++] = 'p.id IN ("'.implode(",", $photos).'")';
		}elseif($photos!=""){ 
			$query_arr[$v++] = '(p.id IN ('.$photos.'))';
		}

		$query_files = "SELECT p.id, p.filename, p.filehash, p.extension, p.ctime, p.meta_when, p.meta_title, p.meta_about, p.meta_author, p.meta_keywords, p.meta_gps, p.meta_type, p.meta_where FROM ".$cfg['db']['table']['mod_photos_photos']." AS p WHERE ".implode(" AND ",$query_arr)." ORDER BY p.id ASC;";
		$result_files = db_query($query_files,$link);
		while(list($p_id, $p_filename, $p_filehash, $p_extension, $p_ctime, $p_when, $p_title, $p_about, $p_author, $p_keywords, $p_gps, $p_type, $p_where) = db_fetch_row($result_files)){
			$files[$p_id]=array("id" => $p_id, "filename" => $p_filename, "filehash" => $p_filehash, "ext" => $p_extension, "ctime" => $p_ctime, "when" => $p_when, "title" => $p_title, "about" => $p_about, "author" => $p_author, "keywords" => $p_keywords, "gps" => $p_gps, "type" => $p_type, "where" => $p_where);
		}

		return $files;
	}

	function renderSetInfo($val,$type){
		global $cfg;
		$img_path=$this->PHOTOS_URL."/".$this->PHOTOS_DIRNAME_RESIZE."/".$this->PHOTOS_THUMB_SIZES[s]."/".strtolower(substr($val[photos][0][filehash],0,1));
	
		echo('<div id="set_'.$val[id].'_'.$type.'" class="'.($val[status]==$cfg["STATUS_ACTIVE"] ? "set" : "setInActive").'" onmouseover="highSet('.$val[id].',\''.$type.'\');" onmouseout="unHighSet('.$val[id].',\''.$type.'\');">');
			echo('<div class="fleft setPhoto">');
				echo('<div class="setVisual">');

				// lock
				if($val[lock]!=2) echo('<div style="position: relative;"><img src="./images/photos_set_lock.gif" style="position: absolute; left: 50px; top: 43px; width: 30px; height: 36px;" alt="zamčený set" title="zamčený set"></div>');

				echo('<img src="'.$img_path.'/'.$val[photos][0][filehash].'.'.$val[photos][0][ext].'" border="0"></div>');
			echo('</div>');
			echo('<div class="fleft setInfo">');
				echo('<strong>'.$val[title].'</strong>');
				echo('<big>'.$this->printDate($val[when]).'</big>');

				// status
				echo('<a href="javascript: setSetStatus('.$val[id].','.$val[status].');" class="setStatusButton_'.$val[status].'"  id="setStatusButton['.$type.']['.$val[id].']">&nbsp;</a>');

				echo(($val[author]!="" ? '<span>Autor:</span> <em>'.$val[author].'</em>' : "&nbsp;").'<br />');
				echo('<span>Počet fotek:</span> '.intval(count($val[photos])).'<br />');
				echo('<span>Poslední úprava:</span> '.$this->printSmartDate($val[mtime]).'');
			echo('</div>');
			echo('<div class="fright setButtons">');
				echo('<a href="javascript: initSetEditor('.$val[id].');" class="edit">Upravit&nbsp;set</a>');
				echo('<br />');
				echo('<a href="javascript: initSetStructureEditor('.$val[id].');" class="edit">Struktura</a>');
				echo('<br />');
				echo('<a href="javascript: initSetPhotosMetaEditor('.$val[id].');" class="edit">Upravit&nbsp;popisky</a>');
				echo('<br />');
				echo('<a href="javascript: initSetThumbChanger('.$val[id].',\'\');" class="edit">Přepsat&nbsp;náhledy</a>');
				echo('<br />');
				echo('<span id="setDelArea['.$type.']['.$val[id].']"><a href="javascript: initSetDelete('.$val[id].',\''.$type.'\');" class="delete">Smazat&nbsp;set</a></span>');
			echo('</div>');
			echo('<div class="clearAll">&nbsp;</div>');
		echo('</div>');	
	}

	function getSetFirstPhoto($set_id, $size){
		global $cfg, $link;

		$query_files = "SELECT p.id, p.filename, p.filehash, p.extension, p.fullpath, p.meta_title, p.meta_about FROM ".$cfg['db']['table']['mod_photos_sets']." AS c, ".$cfg['db']['table']['mod_photos_photos']." AS p WHERE c.set_id='".$set_id."' AND p.id=c.photo_id ORDER BY c.sort ASC LIMIT 1;";
		$result_files = db_query($query_files,$link);
		while(list($p_id, $p_filename, $p_filehash, $p_extension, $p_fullpath, $p_title, $p_about) = db_fetch_row($result_files)){
			$files[]=array("id" => $p_id, "filename" => $p_filename, "filehash" => $p_filehash, "ext" => $p_extension, "fullpath" => $p_fullpath, "title" => $p_title, "about" => $p_about);
		}

		return $this->PHOTOS_URL."/". $this->PHOTOS_DIRNAME_RESIZE."/". $this->PHOTOS_THUMB_SIZES[$size]."/". strtolower(substr($files[0][filehash],0,1)).'/'. $files[0][filehash].'.'.$files[0][ext];
	
	}

	function renderSetInfoLight($val,$type){
		global $cfg;
		$img_path=$this->PHOTOS_URL."/".$this->PHOTOS_DIRNAME_RESIZE."/".$this->PHOTOS_THUMB_SIZES[s]."/".strtolower(substr($val[photos][0][filehash],0,1));
	
		echo('<div id="set_'.$val[id].'_'.$type.'" class="set" onmouseover="highSet('.$val[id].',\''.$type.'\');" onmouseout="unHighSet('.$val[id].',\''.$type.'\');">');
			echo('<div class="fleft setPhoto">');
				echo('<div class="setVisual">');

				// lock
				if($val[lock]!=2) echo('<div style="position: relative;"><img src="/images/photos_set_lock.gif" style="position: absolute; left: 50px; top: 43px; width: 30px; height: 36px;" alt="zamčený set" title="zamčený set"></div>');

				echo('<img src="'.$img_path.'/'.$val[photos][0][filehash].'.'.$val[photos][0][ext].'" border="0"></div>');
			echo('</div>');
			echo('<div class="fleft setInfo">');
				echo('<strong>'.$val[title].'</strong>');
				echo('<big>'.$this->printDate($val[when]).'</big><br />');
				echo(($val[author]!="" ? '<span>Autor:</span> <em>'.$val[author].'</em>' : "&nbsp;").'<br />');
				echo('<span>Počet fotek:</span> '.intval(count($val[photos])).'<br />');
				echo('<span>Poslední úprava:</span> '.$this->printSmartDate($val[mtime]).'<br /><br />');				;
			echo('</div>');
			echo('<div class="clearAll">&nbsp;</div>');
		echo('</div>');	
	}

	function createPhotosTempFolder(){
		global $cfg;

		$dirName=photosGetTempDirName();
		// mkdir($PHOTOS_DIR."/temp/".$dirName,0777);
		return $dirName;
	}

	function photosGetTempDirName(){
		global $cfg;
		do{	
			$test_hash=generateHash(1,5,"smallalfa");				
			if(!file_exists($this->PHOTOS_DIR."/".$test_hash)){
				$p=$test_hash;
				break;
			}
		}while($p=="");

		return $p;
	}
	
	function createSQLQueryCondition($sign,$value){

		if($sign=="is") return " = '".$value."'";
		if($sign=="isNot") return " != '".$value."'";

		if($sign=="inc") return " LIKE '%".$value."%'";
		if($sign=="incNot") return " NOT LIKE '%".$value."%'";

		if($sign=="isHigher") return " > '".$value."'";
		if($sign=="isSmaller") return " < '".$value."'";
	}

	function printSmartDate($date){
		list($time_y, $time_m, $time_d, $time_h, $time_i, $time_s) = sscanf($date, "%d-%d-%d %d:%d:%d");
 
		$today=date("Ymd",time());
		$tommorow=date("Ymd",time()+(60*60*24));
		$yesterday=date("Ymd",time()-(60*60*24));
 
		$tmp_ymd=sprintf("%02d",$time_y).sprintf("%02d",$time_m).sprintf("%02d",$time_d);
 
		if($today==$tmp_ymd){
			return "dnes ".sprintf("%02d",$time_h).":".sprintf("%02d",$time_i).":".sprintf("%02d",$time_s);
		}elseif($tommorow==$tmp_ymd){
			return "zítra ".sprintf("%02d",$time_h).":".sprintf("%02d",$time_i).":".sprintf("%02d",$time_s);
		}elseif($yesterday==$tmp_ymd){
			return "včera ".sprintf("%02d",$time_h).":".sprintf("%02d",$time_i).":".sprintf("%02d",$time_s);
		}else{
			return sprintf("%02d",$time_h).":".sprintf("%02d",$time_i).":".sprintf("%02d",$time_s)." ".sprintf("%02d",$time_d).".".sprintf("%02d",$time_m).".".sprintf("%04d",$time_y);
		} 
	}

	function convertDate(&$datum){
		list($day, $month, $year) = sscanf($datum, "%d.%d.%d");
		return $year."-".sprintf("%02d",$month)."-".sprintf("%02d",$day)." 00:00:00";
	}

	function printDate($date){
		list($time_y, $time_m, $time_d, $time_h, $time_i, $time_s) = sscanf($date, "%d-%d-%d %d:%d:%d"); 
		return sprintf("%02d",$time_d).".".sprintf("%02d",$time_m).".".sprintf("%04d",$time_y); 
	}

}

?>