<?
	session_start();

	header("Content-Type: text/html; charset=UTF-8");

	include("../../include/local.inc.php");		
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("reels.inc.php");
	include("../mod_photos/photos.class.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$u=new Underwood();

	$reels=new Reels();	
	$photoClass=new Photos();
	
	/* */

	$openReel=intval($_GET[item]);

	if($u->verifyUserRight("mod_reels_reels_reel_insert")==0 && $openReel==0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}

	if($u->verifyUserRight("mod_reels_reels_reel_update")==0 && $openReel>0){
		echo($u->simpleMessage('error',$u->getText('error403')));
		exit();	
	}

	/* ziska informace o lektorovi */
	if($openReel>0){
		$search[id] = $openReel;
		$search[param]="normal";
		$reelsData = $reels->getReelsData($search);
	}

	// vezme informaci o setech
	$setsData = $photoClass->getSetsData($none, "meta_title ASC");

	// vezme data o knihovne
	$libraryData = $u->getLibraryData();

	$sort_id = $sort_title = "";
	foreach($libraryData["files"] AS $key => $row){
	   $sort_id[$key]  = $row['id'];
	   $sort_title[$key]  = $row['title'];
	}
	array_multisort($sort_title, SORT_ASC, $libraryData["files"]);

	?>

<form name="reelEditForm" id="reelEditForm">

<table cellpadding="8" cellspacing="0" border="0" class="tableEdit">
	<tr><td><h4 class="title"><? echo ($openReel>0 ? $reelsData[$openReel][title] :  $u->getText("mod_reels_reels_reel_newItem")); ?></h4></td></tr>
	<tr>
		<td>
		<table cellpadding="0" cellspacing="0" border="0">
			<tr valign="top">
				<td>
			<table border="0" cellspacing="0" cellpadding="2">
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_title'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_title" id="d_title" class="input long high" value="<? echo $u->insertData($reelsData[$openReel][title]); ?>"></td>
				<td>&nbsp;</td>
			</tr>
			<tr><td colspan="5">&nbsp;</td></tr>
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_company'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_company" id="d_company" class="input long" value="<? echo $u->insertData($reelsData[$openReel][company]); ?>"></td>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_year'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_year" id="d_year" class="input" value="<? echo $u->insertData($reelsData[$openReel][year]); ?>"></td>
				<td>&nbsp;</td>
			</tr>
			<tr><td colspan="5">&nbsp;</td></tr>
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_director'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_director" id="d_director" class="input long" value="<? echo $u->insertData($reelsData[$openReel][director]); ?>"></td>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_production'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_production" id="d_production" class="input long" value="<? echo $u->insertData($reelsData[$openReel][production]); ?>"></td>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_associate'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_associate" id="d_associate" class="input long" value="<? echo $u->insertData($reelsData[$openReel][associate]); ?>"></td>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_dop'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_dop" id="d_dop" class="input long" value="<? echo $u->insertData($reelsData[$openReel][dop]); ?>"></td>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_cast'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_cast" id="d_cast" class="input long" value="<? echo $u->insertData($reelsData[$openReel][cast]); ?>"></td>
				<td>&nbsp;</td>
			</tr>
			</table>
		</td>
		<td width="30">&nbsp;</td>
		<td>
			<table border="0" cellspacing="0" cellpadding="2">			
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_video_file'); ?></td>
				<td>&nbsp;</td>
				<td>
				<?
					echo('<select name="d_video_file_id" name="d_video_file_id">');
					echo('<option value="0"'.($reelsData[$openReel]["video_file_id"]==0 ? " selected" : "").'>-- ('.$u->getText('nothing').') --</option>');
					reset($libraryData["files"]);
					while(list($key,$val)=each($libraryData["files"])){
						if($val["filetype"] == "flv"){
							echo('<option value="'.$val[id].'"'.($reelsData[$openReel]["video_file_id"]==$val[id] ? " selected" : "").'>'.$val['title'].' ('.$val['filename'].')</option>');
						}
					}
					echo('</select>');
				?>
				</td>
				<td>&nbsp;</td>
			</tr>			
			<tr><td colspan="5">&nbsp;</td></tr>
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_website'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_website_link" id="d_website_link" class="input long" value="<? echo $u->insertData($reelsData[$openReel][website_link]); ?>"></td>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td class="caption"><? echo $u->getText('mod_reels_reels_reel_it_external_trailer'); ?></td>
				<td>&nbsp;</td>
				<td><input type="text" name="d_external_trailer" id="d_external_trailer" class="input long" value="<? echo $u->insertData($reelsData[$openReel][external_trailer]); ?>"></td>
				<td>&nbsp;</td>
			</tr>

			</table>
		</td>
		</tr>
		</table>
			
		</td>
	</tr>
	<tr><td colspan="5">&nbsp;</td></tr>
	<tr>
		<td><a href="#" onClick="saveReel(<? echo $openReel; ?>);" class="button"><img src="<? echo UW_BASE_URL; ?>/images/icons/save.gif" border="0" alt="" /> <? echo $u->getText('save'); ?></a><a href="#" onClick="getOffset(); list();" class="button"><img src="<? echo UW_BASE_URL; ?>/images/icons/cancel.gif" border="0" alt="" /> <? echo $u->getText('cancel'); ?></a><a href="#" onClick="openReel(<? echo $openReel; ?>); " class="button"><img src="<? echo UW_BASE_URL; ?>/images/icons/change.gif" border="0" alt="" /> <? echo $u->getText('refresh'); ?></a></td>
	</tr>
	<tr><td>&nbsp;</td></tr>
</table>
<input type="hidden" name="action" value="save">
<input type="hidden" name="reel_id" value="<? echo $openReel; ?>">

</form>