<?
session_start();

header("Content-Type: text/html; charset=UTF-8");

	include("../../include/local.inc.php");		
	include("../../common/config.inc.php");
	include("../../include/underwood.inc.php");
	include("../../common/lang.inc.php");
	include("../../include/dbsql.inc.php");
	include("../../include/underwood.class.php");
	
	include("repository.class.inc.php");

	$link = db_connect($U_DB_SERVER,$U_DB_USER,$U_DB_PASSWORD,$U_DB_DATABASE) or die("Couldn't connect SQL server!");

	// code modulu
	$u=new Underwood();
	$repository = new Repository();

	/* */

	$node = intval($_GET["node"]);

	/* smaze kategorii a pripadne souborz, ktere nejsou v jine kategorii presune pod prvni rubriku */

	if($u->verifyUserRight("mod_repository_submodule_private")==0){
		echo('AccessDenied');
		exit();
	
	}elseif($node>0){

		$nodes2delete="";

		// najde rootovskou kategorii
		$query="SELECT id FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE parentID='0'";
		$result = db_query($query,$link);
		$result_rows = db_num_rows($result);
		if($result_rows>0){
		list($id) = db_fetch_row($result,$link);

			// id roota, pod ktery kdyztak presunu soubory ze smazane kategorie
			$root_id = $id;

			// projedu strom a najdu kategorie ke smazani
			$nodes2delete = "";
			$nodes2delete[] = $node;
			$repository->getDeletionTree($node,0);

			// projedu kategorie je smazani
			reset($nodes2delete);
			while(list($key_node,$node_id) = each($nodes2delete)){

				// soubory
				$files = array();
			
				// najdu soubory ktere do nich patri
				$files = $repository->getStructureFiles($node_id);

				if(count($files) > 0){
					// projedu soubory
					reset($files);
					while(list($key,$file_id)=each($files)){

						$query_files="SELECT node_id FROM ".$cfg['db']['table']['mod_repository_structure_files']." WHERE node_id!='".$node_id."' AND file_id='".$file_id."';";
						$result_files = db_query($query_files,$link);
						$result_count_files=db_num_rows($result_files);
						
						// pokud nepatri jinam, dam je do rootu
						if($result_count_files<1){
							$query = "INSERT INTO ".$cfg['db']['table']['mod_repository_structure_files']." (node_id, file_id) VALUES ('".$root_id."', '".$file_id."');"; 
							$result = db_query($query,$link);
						}
					}
				}
			}

			$query_delete_files="DELETE FROM ".$cfg['db']['table']['mod_repository_structure_files']." WHERE node_id IN (".implode(",",$nodes2delete).");";
			$result_delete_files = db_query($query_delete_files,$link);

			$query_delete_nodes="DELETE FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE id IN (".implode(",",$nodes2delete).");";
			$result_delete_nodes = db_query($query_delete_nodes,$link);

			$repository->setTreeDepths(0,0);

			/* LOG > */
				$u->logActivity($_SESSION['uw']['user']['id'], "mod_repository_private_log_nodeDeleted", implode(",",$nodes2delete), $_SERVER['HTTP_USER_AGENT']);
			/* < LOG */

			echo('deleted');
			exit();
			
		}
		
	}else{
		
		echo('error');
		exit();
	}

?>