<?
	// ěščřžýáíé
	header("Content-Type: text/html; charset=UTF-8");

	set_time_limit(36000);
	ini_set("memory_limit","100M");

class Repository{

	function Repository(){

		$this->today = date("Y-m-d");
		$this->globalTest = $GLOBALS['test'];

		// heslo pro pristup k ukladani souboru
		$this->PASSWORD = "5129";

		// slozka se soubory
		$this->REPOSITORY_DIR = UW_DIR."/".'repository'."/".'storage';
		$this->REPOSITORY_URL = UW_URL."/".'repository'."/".'storage';

	}

	function getStorageData($search){
		global $link, $cfg;

		$data="";

		unset($query_arr); $v=0;
		$query_arr[$v++] = "(deleted=".$cfg["DELETED_FALSE"].")";		

		if($search[id]!=""){
			$query_arr[$v++] = "(id = '".intval($search[id])."')";
		}
		
		$query = "SELECT * FROM repository WHERE ".implode(" AND ",$query_arr)." ORDER BY id ASC;";
		$result = db_query($query,$link);
		while($output = db_fetch_assoc($result,$link)){
			$data[$output[id]]=$output;

			// nacte soubory
			$files="";

			$query_files = "SELECT * FROM repository_files WHERE repository_id='".$output[id]."' AND deleted=".$cfg["DELETED_FALSE"]." ORDER BY id ASC;";
			$result_files = db_query($query_files,$link);
			while($output_files = db_fetch_assoc($result_files, $link)){
				$files[$output_files[id]] = $output_files;
			}

			$data[$output[id]]["files"]=$files;
		}

		return $data;
	}

	function getPrivateStorageData($search){
		global $link, $cfg;

		$data="";

		unset($query_arr); $v=0;
		$query_arr[$v++] = "(deleted=".$cfg["DELETED_FALSE"].")";		

		if($search[node_id]!=""){
			$query_arr[$v++] = "(node_id = '".intval($search[node_id])."')";
		}
		
		$query_files = "SELECT * FROM ".$cfg['db']['table']['mod_repository_structure_files']." WHERE ".implode(" AND ",$query_arr)." ORDER BY sort ASC, id ASC;";

		$result_files = db_query($query_files,$link);
		while($output_files = db_fetch_assoc($result_files, $link)){
			$data[$output_files[id]] = $output_files;
		}

		return $data;
	}	

	function cleanUri($string){
		$utf_str=array(
		"á"=>"a", "ä"=>"a", "č"=>"c", "ď"=>"d", "é"=>"e", "ě"=>"e", "ë"=>"e", "í"=>"i", "ň"=>"n", "ó"=>"o", "ö"=>"o", "ř"=>"r", "š"=>"s", "ť"=>"t", "ú"=>"u", "ů"=>"u", "ü"=>"u", "ý"=>"y", "ž"=>"z", "Á"=>"A", "Ä"=>"A", "Č"=>"C", "Ď"=>"D", "É"=>"E", "Ě"=>"E", "Ë"=>"E", "Í"=>"I", "Ň"=>"N", "Ó"=>"O", "Ö"=>"O", "Ř"=>"R", "Š"=>"S", "Ť"=>"T", "Ú"=>"U", "Ů"=>"U", "Ü"=>"U", "Ý"=>"Y", "Ž"=>"Z");
		$tmp_data = strtr(trim($string), $utf_str);
		$ret_data=preg_replace("/([^a-zA-Z0-9\/-_])/","-",$tmp_data);
		$ret_data=ereg_replace("--+","-",$ret_data);
		$ret_data=trim($ret_data,"-");

		return strtolower($ret_data);
	}

	function returnData($string){
		return trim($string);
	}

	function insertData($string){
		return ($string);
	}

	function setHashes(){
		global $link, $cfg;

		/*  vyplni slozkam, ktere nemaji hash hash */
		$query_hash = "SELECT id FROM repository WHERE hash = '';";
		$result_hash = db_query($query_hash,$link);
		while (list($e_id) = db_fetch_row($result_hash)){
			db_query("UPDATE repository SET hash='".$this->getRepositoryHash()."' WHERE id=".$e_id, $link);
		}

		/*  vyplni slozkam, ktere nemaji storagehash storagehash */
		$query_hash = "SELECT id FROM repository WHERE storagehash = '';";
		$result_hash = db_query($query_hash,$link);
		while (list($e_id) = db_fetch_row($result_hash)){
			db_query("UPDATE repository SET storagehash='".$this->getRepositoryStorageHash()."' WHERE id=".$e_id, $link);
		}

		/*  vyplni souborum, ktere nemaji filehash filehash */
		$query_hash = "SELECT id FROM repository_files WHERE filehash = '';";
		$result_hash = db_query($query_hash,$link);
		while (list($e_id) = db_fetch_row($result_hash)){
			db_query("UPDATE repository_files SET filehash='".$this->getRepositoryFilesHash()."' WHERE id=".$e_id, $link);
		}

		return true;
	}

	function getRepositoryHash(){
		global $link, $cfg;
		do{	
			$test_hash=$this->generateHash(1,12,"alfanumeric");
			$query_yet="SELECT hash FROM repository WHERE hash='".$test_hash."';";
			$result_yet=db_query($query_yet,$link);
			$count_yet=db_num_rows($result_yet);
			if($count_yet==0){
				$p=$test_hash;
				break;
			}
		}while($p=="");

		return $p;
	}

	function getRepositoryStorageHash(){
		global $link, $cfg;
		do{	
			$test_hash=$this->generateHash(1,12,"alfanumeric");
			$query_yet="SELECT storagehash FROM repository WHERE storagehash='".$test_hash."';";
			$result_yet=db_query($query_yet,$link);
			$count_yet=db_num_rows($result_yet);
			if($count_yet==0){
				$p=$test_hash;
				break;
			}
		}while($p=="");

		return $p;
	}

	function getRepositoryFilesHash(){
		global $link, $cfg;
		do{	
			$test_hash=$this->generateHash(1,8,"alfanumeric");
			$query_yet="SELECT filehash FROM repository_files WHERE filehash='".$test_hash."';";
			$result_yet=db_query($query_yet,$link);
			$count_yet=db_num_rows($result_yet);
			if($count_yet==0){
				$p=$test_hash;
				break;
			}
		}while($p=="");

		return $p;
	}

	function generateHash($t,$l,$c){
		// type, length, characters

		$hash="";

		if($c=="pass"){
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx23456789_*245678923456789";
		}elseif($c=="alfa"){
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx";
		}elseif($c=="smallalfa"){
			$char = "abcdefghjkmnpqrstuvwx";
		}elseif($c=="numeric"){
			$char = "012345679";
		}elseif($c=="alfanumeric"){
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx123456790";
		}else{
			$char = "ABCDEFGHJKMNPQRSTUVWXabcdefghjkmnpqrstuvwx23456789_*245678923456789";
		}

		srand((double)microtime()*100000);
		for($i=0; $i<$l;$i++){
			$pass.= $char[rand()%strlen($char)]; 
		}

		$tm=floor($l/4)-1;

		$hash = ($t==2 ? substr(chunk_split(substr($pass,0,$l-$tm),4,"-"), 0, -1) : $pass);

		return $hash;
	}

	function getAnnex($num,$type){
						
		if($num==1){
			if($type=="files") $data="mod_repository_files_annex_1";
		}elseif($num>=2 && $num<=4){
			if($type=="files") $data="mod_repository_files_annex_2";
		}else{
			if($type=="files") $data="mod_repository_files_annex_3";
		}

		return $data;		
	}

	/* tree */

	// vrati plnou cestu k nodu vcetne dat
	function getFullNodePath($nodeID){
		global $link,$pathData;

		$pathData="";

		return $this->getDetailNodePath($nodeID);		
	}

	function getDetailNodePath($nodeID){
		global $link,$pathData,$cfg;

		// najde rodice
		$query_parent="SELECT parentID, depth, title FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE id='".$nodeID."'";
		$result_parent = db_query($query_parent,$link);
		while($row_parent = db_fetch_array($result_parent)){

			$pathData[]=array(
					"id" => $nodeID, 
					"parent" => $row_parent['parentID'], 
					"depth" => $row_parent['depth'], 
					"title" => $row_parent['title']
			);

			// rekurze
			$this->getDetailNodePath($row_parent['parentID']);
		}

		reset($pathData);
		krsort($pathData);
		return $pathData;
	}

	// prida potomka
	function addTreeNode($parentID,$title){
		global $link,$u,$cfg;

		if($title==""){
			// nema vyplnen nazev webu
			$alertStorage[]=$u->simpleMessage('error',$u->getText('library_files_msg_mustFillTitle'));
		}else{
			$query="INSERT INTO ".$cfg['db']['table']['mod_repository_structure']." (title, parentID) VALUES ('".$title."', '".$parentID."')";
			$result = db_query($query,$link);

			$this->setTreeDepths(0,0);
		}

		return $alertStorage;
	}

	// doplni hloubky do stromu
	function setTreeDepths($parentID, $level){
		global $link,$cfg;

		$query="SELECT id, title, parentID FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)) {
			$query_update="UPDATE ".$cfg['db']['table']['mod_repository_structure']." SET depth='".($level+1)."' WHERE id='".$row['id']."'";
			$result_update = db_query($query_update,$link);
			$this->setTreeDepths($row['id'], $level+1);
		}
	}

	// nacte nazvy nodu
	function getNodeTitles($nodes){
		global $link, $u, $cfg;

		if(is_array($nodes)){
			$tmp_nodes=implode(",",$nodes);
		}elseif($nodes!=""){
			$tmp_nodes=intval($nodes);
		}else{
			return false;
		}

		$query="SELECT id, title, depth FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE id IN (".$tmp_nodes.")";
		$result = db_query($query,$link);
		while($row = db_fetch_array($result)){
			$dataReturn[$row['id']]=$row['title'];
		}
		return $dataReturn;
	}

	// ziskani parentu nodu
	function getNodeParents($parentID_parent){
		global $link, $pData, $cfg;

		// najde rodice, kteri jsou v urovni dal nez vrstva jazyku
		$query_parent="SELECT parentID FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE id='".$parentID_parent."' AND depth>2";
		$result_parent = db_query($query_parent,$link);
		while ($row_parent = db_fetch_array($result_parent)){

			$pData[]=$row_parent['parentID'];

			// rekurze
			$this->getNodeParents($row_parent['parentID']);
		}

		return $pData;
	}

	// ziskani deti nodu
	function getNodeChilds($node_node_child){
		global $link, $chData, $cfg;

		// najde deti
		$query_node_child="SELECT id FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE parentID='".$node_node_child."';";
		$result_node_child = db_query($query_node_child,$link);
		while($row_node_child = db_fetch_array($result_node_child)){

			$chData[] = $row_node_child['id'];

			// rekurze
			$this->getNodeChilds($row_node_child['id']);
		}

		return $chData;
	}

	// nacteni dat stromu	
	function getTreeData($parentID, $level){
		global $link, $getPath, $tData, $pData, $chData, $cfg;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){

			$pData="";
			$chData="";
						
			$tData[$row['id']]=array(id=>$row['id'], title=>$row['title'], parent=>$row['parentID'], depth=>$row['depth'], parentNodes => $this->getNodeParents($row['id']), childNodes => $this->getNodeChilds($row['id']));
						
			// rekurze
			$this->getTreeData($row['id'], $level+1);
		}
	
		return $tData;
	}

	function getStructureFiles($node_id){
		global $link, $cfg;
	
		$query_files = "SELECT id FROM ".$cfg['db']['table']['mod_repository_structure_files']." WHERE node_id='".$node_id."' AND deleted=".$cfg["DELETED_FALSE"]." ORDER BY id ASC;";
		$result_files = db_query($query_files,$link);
		while($output_files = db_fetch_assoc($result_files, $link)){
			$files[] = $output_files[id];
		}

		return $files;
	}

	function getStructureEditTree($parentID, $level){
		global $link, $v, $tmp_depth, $treeData, $cfg, $u;
 		$tmp_depth[0]=0;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE parentID='".$parentID."' ORDER BY sort ASC, id ASC";
		$result = db_query($query,$link);
		$result_rows = db_num_rows($result);

		while ($row = db_fetch_array($result)){
										
			$tmp_depth[$v]=$row[depth];
			$ted=$tmp_depth[$v];
			$pred=$tmp_depth[($v-1)];

			// pokud je dalsi node vis nez byl predchozi, je potreba otevrit ul
			if($ted > $pred){
			
				echo ("\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-2) : $row[depth]))."<ul>");

			// pokud je dalsi node niz nez byl predchozi, je potreba uzavrit li a ul
			}elseif($ted < $pred){ 						
				
				// vypise tolik uzavreni, kolik je potreba
				for($x=$pred;$x>$ted;$x--){
					echo "\n".str_repeat("\t",($x-1))."</li> \n".str_repeat("\t",($x-2))."</ul>";
				}
				// uzavre li
				echo("\n".str_repeat("\t",($ted-1)).'</li>');

			}else{
				echo ("\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-1) : $row[depth]))."</li>");
			}
						
			echo "\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-1) : $row[depth])).'<li class="'.($row[depth]==1 ? 'tree_node_web' : 'tree_node_open').'" id="tree_li['.$row['id'].']">';
					
			echo ('<a href="#" onclick="javascript: initTreeNodeEditQuestion('.$row['id'].');" id="tree_title['.$row['id'].']">'.$row['title'].'</a>');
						
			$v++;
		
			// rekurze
			$this->getStructureEditTree($row['id'], $level+1);
		}
	}
	
	function getStructureTree($parentID, $level){
		global $link, $v, $tmp_depth, $treeData, $cfg, $u;
 		$tmp_depth[0]=0;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE parentID='".$parentID."' ORDER BY sort ASC, id ASC";
		$result = db_query($query,$link);
		$result_rows = db_num_rows($result);

		while ($row = db_fetch_array($result)){
										
			$tmp_depth[$v]=$row[depth];
			$ted=$tmp_depth[$v];
			$pred=$tmp_depth[($v-1)];

			// pokud je dalsi node vis nez byl predchozi, je potreba otevrit ul
			if($ted > $pred){
			
				echo ("\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-2) : $row[depth]))."<ul>");

			// pokud je dalsi node niz nez byl predchozi, je potreba uzavrit li a ul
			}elseif($ted < $pred){ 						
				
				// vypise tolik uzavreni, kolik je potreba
				for($x=$pred;$x>$ted;$x--){
					echo "\n".str_repeat("\t",($x-1))."</li> \n".str_repeat("\t",($x-2))."</ul>";
				}
				// uzavre li
				echo("\n".str_repeat("\t",($ted-1)).'</li>');

			}else{
				echo ("\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-1) : $row[depth]))."</li>");
			}
						
			echo "\n".str_repeat("\t",($row[depth]>1 ? ($row[depth]-1) : $row[depth])).'<li class="'.($row[depth]==1 ? 'tree_node_web' : 'tree_node_open').'">';
					
			echo ('<a href="javascript: void(0);" onclick="javascript: readStructureFiles('.$row['id'].');">'.$row['title'].'</a>');
						
			$v++;
		
			// rekurze
			$this->getStructureTree($row['id'], $level+1);
		}
	}

	function getDeletionTree($parentID, $level){
		global $link, $cfg, $u, $nodes2delete;

		$query="SELECT id, title, parentID, depth FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE parentID='".$parentID."'";
		$result = db_query($query,$link);
		while($row = db_fetch_array($result)){
			
			$nodes2delete[]=$row[id];
				
			// rekurze
			$this->getDeletionTree($row['id'], $level+1);
		}

		return $nodes2delete;
	}

	function getNodesForSort($parentID, $level){
		global $link, $cfg;

		$data="";

		$query="SELECT id, title, sort FROM ".$cfg['db']['table']['mod_repository_structure']." WHERE parentID='".$parentID."' ORDER BY sort ASC;";
		$result = db_query($query,$link);
		while ($row = db_fetch_array($result)){						
			$data[$row['id']]=array(id=>$row['id'], title=>$row['title'], 'sort'=>$row['sort']);
		}
	
		return $data;
	}

}

?>